//---------------------------------------------------------------------------
//      AN1990 / TM-2004 (based on K1446VG5)
//---------------------------------------------------------------------------
#pragma hdrstop
#include "AN1990.h"
#include "ProgressBar.h"        //   -
#include "MainProgram.h"        //    
#include "ChipFunctions.h"      //      
#include "PortFunctions.h"      //    
#include "CalcCRC.h"            //   CRC
#include "SendMsgFunctions.h"   //     
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---    ROM (0x33) -----------------------------
//---------------------------------------------------------------------------
// output:      Success
AN1990_OUTPUT_DATA AN1990_ReadROM()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  AN1990_OUTPUT_DATA OutputData;        //   

  OutputData.Success=false;             //   

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Read ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x33;                                  // Read ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM
  for(unsigned int i=0; i<8; i++)                       //    ROM
  { //    
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                              // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    SelectedChip.ROM[i]=rd_buf.Data[0];               //    (  0x0  0xFF)
    Sleep(1);
  }
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;          //    Test   
}
//---------------------------------------------------------------------------
//---    ROM (0x3C) -------------------------------------
//---------------------------------------------------------------------------
// output:      Success
AN1990_OUTPUT_DATA AN1990_WriteROM()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  AN1990_OUTPUT_DATA OutputData;        //   
  unsigned int CurrentByte, CurrentBit; //     
  unsigned char CRC8;                   //   CRC8

  OutputData.Success=false;             //  

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Write ROM (0x3C)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x3C;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");       //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     CRC8
  CRC8=0;
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
    wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
  }
  //****************************************************************************
  //    ,    K1446VG5 ,    2
  //  TA1, TA2,     AN1990 (    K1446VG5), -
  //    7   .    . 
  //        !  .
  //****************************************************************************
  //   ,      14465.   .
  //****************************************************************************
  //  16   (TA1=0, TA2=0)
  for(unsigned int i=0;i<16;i++)
  { //   
      wr_buf.Size=2;
      wr_buf.Data[0]=0x63;
      wr_buf.Data[1]=0;         //    ,   16  - 
      if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");                 //   
                             LBar->Free();                         //    -
                             ClosePort();
                             return OutputData;
                           }
      Sleep(1);         //     
      CRC8=CalcCRC8(CRC8,wr_buf.Data[1]);       //  CRC
  }
  //  8   ROM
  for(unsigned int i=0;i<8;i++)
  {   //  8  
      for(unsigned int j=0;j<8;j++)
      { //   
        wr_buf.Size=2;
        wr_buf.Data[0]=0x63;
        wr_buf.Data[1]=SelectedChip.ROM[i]>>j;                  //      
        if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");                 //   
                               LBar->Free();                         //    -
                               ClosePort();
                               return OutputData;
                             }
        Sleep(1);         //     
        CRC8=CalcCRC8(CRC8,wr_buf.Data[1]);       //  CRC
      }
      //  CRC8
      wr_buf.Size=1;
      wr_buf.Data[0]=0x62;                                  //   
      if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                             LBar->Free();            //    -
                             ClosePort();
                             return OutputData;
                           }
      Sleep(1);
      //   (CRC8)
      rd_buf=ReadFrom();                                // 
      if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                         LBar->Free();                      //    -
                         ClosePort();
                         return OutputData;
                       }
      Sleep(1);
      for(unsigned int j=0;j<8;j++)
      { CRC8=CalcCRC8(CRC8, rd_buf.Data[0]>>j);         //   CRC8 (    )
      }
      if(CRC8)  SendMsgToLogForm(14,"");          //  CRC8
      //  Program Pulse (-  )
      //  0  
      wr_buf.Size=2;
      wr_buf.Data[0]=0x63;
      wr_buf.Data[1]=0;
      if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");                 //   
                             LBar->Free();                         //    -
                             ClosePort();
                             return OutputData;
                           }
      Sleep(52);        //   50+ 
      //   
      wr_buf.Size=1;
      wr_buf.Data[0]=0x62;                                  //   
      if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                             LBar->Free();            //    -
                             ClosePort();
                             return OutputData;
                           }
      Sleep(1);
      //   (  )
      rd_buf=ReadFrom();                                // 
      if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                         LBar->Free();                      //    -
                         ClosePort();
                         return OutputData;
                       }
      Sleep(1);
      if(SelectedChip.ROM[i]!=rd_buf.Data[0]) { SendMsgToLogForm(105,"");          //  
                                                LBar->Free();                      //    -
                                                //    
                                                return OutputData;
                                              }
      //     -   CRC8   
      CRC8=0;
      for(unsigned int j=0;j<8;j++)
      { CRC8=CalcCRC8(CRC8, (i+1)>>j);      //   CRC8
      }
  }
  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;
}
//---------------------------------------------------------------------------
//---    ROM (0x35) -------------------------
//---------------------------------------------------------------------------
// output:      Success
AN1990_OUTPUT_DATA AN1990_BlockROM()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  AN1990_OUTPUT_DATA OutputData;        //   

  OutputData.Success=false;             //   

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  switch(SelectedProgrammer)
  { case 1:     //   RH-0004
                //***************
                //  I/O    
                // ***  I/O  ,     ***
                //  IO0ConfigInput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0C;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO1ConfigInput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x10;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO2ConfigInput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x14;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                // ***     ***
                //  IO0Output0
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0D;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO1Output0
                wr_buf.Size=1;
                wr_buf.Data[0]=0x11;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO2Output0
                wr_buf.Size=1;
                wr_buf.Data[0]=0x15;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                break;
    case 2:     //   RH-0010
                //   
    default:    break;
  }
  //***************
  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Block ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x35;                                  // Block ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //        
  switch(SelectedProgrammer)
  { case 1:     //   RH-0004
                //  IO0ConfigOutput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0B;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                Sleep(1);
                //  IO0ConfigInput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0C;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
    case 2:     //   RH-0010
                //  Get110ms_Pulse_1W (0x6A)
                wr_buf.Size=1;
                wr_buf.Data[0]=0x6A;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                break;
    default:    break;
  }
  Sleep(1000);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;          //    Test   
}
//---------------------------------------------------------------------------