//---------------------------------------------------------------------------
//      DS18B20, DS1822
//---------------------------------------------------------------------------
#pragma hdrstop
#include "DS18B20.h"
#include "ProgressBar.h"        //   -
#include "MainProgram.h"        //    
#include "ChipFunctions.h"      //      
#include "PortFunctions.h"      //    
#include "CalcCRC.h"            //   CRC
#include "SendMsgFunctions.h"   //     
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---   SCRATCHPAD (0x4E) (   1) ----------------------
//---------------------------------------------------------------------------
// output:      Test - ,      (0xFF) + Success
DS18B20_OUTPUT_DATA DS18B20_WriteToScratchpad()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS18B20_OUTPUT_DATA OutputData;       //   

  OutputData.Test=0;
  OutputData.Success=false;             //   

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Write Scratchpad
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x4E;                                  // Write Scratchpad
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //***     ***
  //  TH
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=SelectedChip.Area1[2];                 //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->ProgressBar1->Position=100*1/3;      //    -
  // TL
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=SelectedChip.Area1[3];                 //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->ProgressBar1->Position=100*2/3;      //    -
  // CONFIG
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=SelectedChip.Area1[4];                 //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);
  LBar->ProgressBar1->Position=100*3/3;      //    -
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;          //    Test   
}
//---------------------------------------------------------------------------
//---   SCRATCHPAD (0xBE) (   1) ----------------------
//---------------------------------------------------------------------------
// output:      Test + Success
DS18B20_OUTPUT_DATA DS18B20_ReadFromScratchpad()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS18B20_OUTPUT_DATA OutputData;       //   
  unsigned char CRC8;                   //   CRC8

  OutputData.Test=0;
  OutputData.Success=false;             //  

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Scratchpad-
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xBE;                                  // Read Scratchpad
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  CRC8=0;                                       //     CRC8
  Sleep(10);
  //***    ***
  for(unsigned int i=0; i<SelectedChip.Area1Size; i++)  //    
  { //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                              // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    SelectedChip.Area1[i]=rd_buf.Data[0];       //      (Area1)
    //  CRC8 (CRC8    ,    ,   )
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8, rd_buf.Data[0]);                      //   CRC8
      rd_buf.Data[0]>>=1;                                       //   (   )
    }
    LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;      //    -
    Sleep(1);
  }
  //  CRC8 (1 , )
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   ( CRC8)
  rd_buf=ReadFrom();                                // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                      //    -
                     ClosePort();
                     return OutputData;
                   }
  Sleep(1);
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8, rd_buf.Data[0]);                      //   CRC8
    rd_buf.Data[0]>>=1;                                       //   (   )
  }
  //  
  if(CRC8!=0)   SendMsgToLogForm(14,"");          //  CRC8   //    -      CRC8
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;
}
//---------------------------------------------------------------------------
//---   SCRATCHPAD  EEPROM (0x48) -----------------------------
//---------------------------------------------------------------------------
// output:      Status + Success
DS18B20_OUTPUT_DATA DS18B20_CopyScratchpadToMemory()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS18B20_OUTPUT_DATA OutputData;       //   

  OutputData.Test=0;
  OutputData.Success=false;             //  

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Copy Scratchpad
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x48;                                  // Copy Scratchpad
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);
  //         (Test)
  Sleep(1);
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     (Test)
  rd_buf=ReadFrom();                                // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                      //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];
  Sleep(1);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  OutputData.Success=true;
  return OutputData;            //    Test   
}
//---------------------------------------------------------------------------
//---   EEPROM  SCRATCHPAD (0xB8) -----------------------------
//---------------------------------------------------------------------------
// output:      Status + Success
DS18B20_OUTPUT_DATA DS18B20_RecallE2()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS18B20_OUTPUT_DATA OutputData;       //   

  OutputData.Test=0;
  OutputData.Success=false;             //  

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Recall E2
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xB8;                                  // Recall E2
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);
  //         (Test)
  Sleep(1);
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     (Test)
  rd_buf=ReadFrom();                                // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                      //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];
  Sleep(1);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  OutputData.Success=true;
  return OutputData;            //    Test   
}
//---------------------------------------------------------------------------
//---    POWER (0xB4) -----------------------------------
//---------------------------------------------------------------------------
// output:      Status + Success
DS18B20_OUTPUT_DATA DS18B20_ReadPowerSupply()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS18B20_OUTPUT_DATA OutputData;       //   

  OutputData.Test=0x55;                 // 0x0 - parasite power, 0xFF - separate power
  OutputData.Success=false;             //  

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Read Power Supply
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xB4;                                  // Read Power Supply
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //         (Test)
  Sleep(1);
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     (Test)
  rd_buf=ReadFrom();                                // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                      //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];               //    
  Sleep(1);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  OutputData.Success=true;
  //          
  return OutputData;            //    Test   
}
//---------------------------------------------------------------------------
//---   (0x44) ------------------------------------------
//---------------------------------------------------------------------------
// output:      Status + Success
DS18B20_OUTPUT_DATA DS18B20_ConvertT()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS18B20_OUTPUT_DATA OutputData;       //   

  OutputData.Test=0;
  OutputData.Success=false;             //  

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Convert Temperature
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x44;                                  // Convert T
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);
  //         (Test)
  Sleep(1);
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     (Test)
  rd_buf=ReadFrom();                                // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                      //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];
  Sleep(1);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  OutputData.Success=true;
  return OutputData;            //    Test   
}
//---------------------------------------------------------------------------
//---    ---------------------------------------
//---------------------------------------------------------------------------
float DS18B20_DecodeTemperature()
{ float OutputValue, Temp1;     //    +   (   )
  unsigned int R1R0, Temp2;     //    +   (   )
  unsigned char Mask;           //    

  //  ,        
  R1R0=(SelectedChip.Area1[4]&0x60)>>5; //   5,6      
  switch(R1R0)
  { case 0:  Mask=0xF8;         // 0b11111000 - 9-bits format
             break;
    case 1:  Mask=0xFC;         // 0b11111100 - 10-bits format
             break;
    case 2:  Mask=0xFE;         // 0b11111110 - 11-bits format
             break;
    case 3:
    default: Mask=0xFF;         // 0b11111111 - 12-bits format
             break;
  }
  //     OutputValue
  OutputValue=0; Temp1=0.0625;                          //   0, Temp1 = 2^-4
  Temp2=SelectedChip.Area1[1]&0x0F;                     //    MSB
  Temp2=(Temp2<<8)+(SelectedChip.Area1[0]&Mask);        //      LSB
  //     ( )    
  for(unsigned int i=0; i<11; i++)
  { OutputValue+=Temp1*(Temp2&1);
    Temp2>>=1;  //    
    Temp1*=2;   //      (  )
  }
  //   ( Temp2        )
  if(Temp2)     OutputValue*=-1.0;      //      ,   
  return OutputValue;
}
//---------------------------------------------------------------------------
//---      -------------------------
//---------------------------------------------------------------------------
void DS18B20_DecodeConfigAndThresholds()
{ unsigned int R1R0, Temp;      //        
  int TH, TL;                   //  
  unsigned char THByte, TLByte; //    
  AnsiString TempStr;           //   

  //    (    )
  R1R0=(SelectedChip.Area1[4]&0x60)>>5; //   5,6      
  switch(R1R0)
  { case 0:  // 0b11111000 - 9-bits format
             TempStr="The chip has 9-bits temperature format (0.5 oC accuracy)";
             break;
    case 1:  // 0b11111100 - 10-bits format
             TempStr="The chip has 10-bits temperature format (0.25 oC accuracy)";
             break;
    case 2:  // 0b11111110 - 11-bits format
             TempStr="The chip has 11-bits temperature format (0.125 oC accuracy)";
             break;
    case 3:  // 0b11111111 - 12-bits format
             TempStr="The chip has 12-bits temperature format (0.0625 oC accuracy)";
             break;
    default: // unknown format
             TempStr="The chip has unknown temperature format";
             break;
  }
  //   
  TH=0; TL=0; Temp=1;
  THByte=SelectedChip.Area1[2]; TLByte=SelectedChip.Area1[3];
  for(unsigned int i=0; i<7; i++)
  { TH+=(THByte&1)*Temp;        //   
    TL+=(TLByte&1)*Temp;        //   
    THByte>>=1;  TLByte>>=1;    //    
    Temp*=2;
  }
  //   
  if(THByte)    TH*=-1;         //      0,   
  if(TLByte)    TL*=-1;         //      0,   
  //      
  TempStr+=", TH="+IntToStr(TH)+" oC, TL="+IntToStr(TL)+" oC.";
  //     
  Form1->RichEdit9->Lines->Add(TempStr);       //   RichEdit9
  return;
}
//---------------------------------------------------------------------------
