//---------------------------------------------------------------------------
//      DS2502
//---------------------------------------------------------------------------
#pragma hdrstop
#include "DS2502.h"
#include "ProgressBar.h"        //   -
#include "MainProgram.h"        //    
#include "ChipFunctions.h"      //      
#include "PortFunctions.h"      //    
#include "CalcCRC.h"            //   CRC
#include "SendMsgFunctions.h"   //     
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---    (0xF0) (  Area1) -----------------------------
//---------------------------------------------------------------------------
// output:      Test - ,       (0xFF) + Success
DS2502_OUTPUT_DATA DS2502_ReadFromMemory()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS2502_OUTPUT_DATA OutputData;        //   
  unsigned int Address;           	//   
  unsigned char CRC8;                   //   CRC8

  OutputData.Test=0;
  OutputData.Success=false;             //  
  Address=0;                            //    ,    

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //   EEPROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xF0;                                  // Read EEPROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);
  //     CRC8
  CRC8=0;
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
    wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
  }
  //  TA1
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
    wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
  }
  //  TA2
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
    wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
  }
  //   CRC8
  //   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                // ReadByte_1W
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   
  rd_buf=ReadFrom();                                  // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                    //    -
                     ClosePort();
                     return OutputData;
                   }
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,rd_buf.Data[0]); //  CRC
    rd_buf.Data[0]=rd_buf.Data[0]>>1;   //  
  }
  //  CRC8  ,    
  if(CRC8)  SendMsgToLogForm(14,"");          //  CRC8
  //***    ***
  CRC8=0;       //  CRC8
  for(unsigned int i=0; i<SelectedChip.Area1Size; i++)  //     
  { //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                                  // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    SelectedChip.Area1[Address-SelectedChip.Area1Start]=rd_buf.Data[0];     //     Area1
    Sleep(1);
    //   CRC8
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,rd_buf.Data[0]); //  CRC
      rd_buf.Data[0]=rd_buf.Data[0]>>1;   //  
    }
    Address+=1;                                                         //  
    LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;      //    -
    Sleep(1);
  }
  //    CRC8
  //   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                // ReadByte_1W
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   
  rd_buf=ReadFrom();                                  // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                    //    -
                     ClosePort();
                     return OutputData;
                   }
  Sleep(1);
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,rd_buf.Data[0]); //  CRC
    rd_buf.Data[0]=rd_buf.Data[0]>>1;   //  
  }
  if(CRC8)  SendMsgToLogForm(14,"");          //  CRC8
  //         (Test)
  Sleep(1);
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     (Test)
  rd_buf=ReadFrom();                                    // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                      //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];
  Sleep(1);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;
}
//---------------------------------------------------------------------------
//---    (0xAA) (  Area2) ------------------------
//---------------------------------------------------------------------------
// output:      Test - ,       (0xFF) + Success
DS2502_OUTPUT_DATA DS2502_ReadFromStatus()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS2502_OUTPUT_DATA OutputData;        //   
  unsigned int Address;           	//   
  unsigned char CRC8;                   //   CRC8

  OutputData.Test=0;
  OutputData.Success=false;             //  
  Address=0;             //    ,    

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //   Status Bytes
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xAA;                                  // Read Status Bytes
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");       //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);
  //     CRC8
  CRC8=0;
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
    wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
  }
  //  TA1
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
    wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
  }
  //  TA2
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
    wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
  }
  //   CRC8
  //   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                // ReadByte_1W
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   
  rd_buf=ReadFrom();                                  // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                    //    -
                     ClosePort();
                     return OutputData;
                   }
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,rd_buf.Data[0]); //  CRC
    rd_buf.Data[0]=rd_buf.Data[0]>>1;   //  
  }
  //  CRC8  ,    
  if(CRC8)  SendMsgToLogForm(14,"");          //  CRC8
  //***    ***
  CRC8=0;       //  CRC8
  for(unsigned int i=0; i<SelectedChip.Area2Size; i++)          //     
  { //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                                  // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    SelectedChip.Area2[Address-SelectedChip.Area2Start]=rd_buf.Data[0];     //     Area2
    Sleep(1);
    //   CRC8
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,rd_buf.Data[0]); //  CRC
      rd_buf.Data[0]=rd_buf.Data[0]>>1;   //  
    }
    Address+=1;                                                         //  
    LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;      //    -
    Sleep(1);
  }
  //    CRC8
  //   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                // ReadByte_1W
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   
  rd_buf=ReadFrom();                                  // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                    //    -
                     ClosePort();
                     return OutputData;
                   }
  Sleep(1);
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,rd_buf.Data[0]); //  CRC
    rd_buf.Data[0]=rd_buf.Data[0]>>1;   //  
  }
  if(CRC8)  SendMsgToLogForm(14,"");          //  CRC8
  //         (Test)
  Sleep(1);
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     (Test)
  rd_buf=ReadFrom();                                    // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                      //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];
  Sleep(1);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;
}
//---------------------------------------------------------------------------
//---      CRC8 (0xC3) (  Area1) -
//---------------------------------------------------------------------------
// output:      Test - ,       (0xFF) + Success
DS2502_OUTPUT_DATA DS2502_ReadFromMemoryCRC8()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS2502_OUTPUT_DATA OutputData;        //   
  unsigned int Address;           	//   
  unsigned char CRC8;                   //   CRC8

  OutputData.Test=0;
  OutputData.Success=false;             //  
  Address=0;             //    ,    

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //   EEPROM + CRC8
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xC3;                                  // Read EEPROM + Generate CRC8
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);
  //     CRC8
  CRC8=0;
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
    wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
  }
  //  TA1
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
    wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
  }
  //  TA2
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
    wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
  }
  //   CRC8
  //   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                // ReadByte_1W
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   
  rd_buf=ReadFrom();                                  // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                    //    -
                     ClosePort();
                     return OutputData;
                   }
  //   CRC8
  for(unsigned int j=0;j<8;j++)
  { CRC8=CalcCRC8(CRC8,rd_buf.Data[0]); //  CRC
    rd_buf.Data[0]=rd_buf.Data[0]>>1;   //  
  }
  //  CRC8  ,    
  if(CRC8)  SendMsgToLogForm(14,"");          //  CRC8
  //***       CRC8 ***
  CRC8=0;       //  CRC8
  for(unsigned int i=0; i<SelectedChip.Area1Size; i++)          //     
  { //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                                  // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    SelectedChip.Area1[Address-SelectedChip.Area1Start]=rd_buf.Data[0];     //     Area1
    Sleep(1);
    //   CRC8
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,rd_buf.Data[0]); //  CRC
      rd_buf.Data[0]=rd_buf.Data[0]>>1;   //  
    }
    //   ,      CRC8
    if((i+1)%32==0)
    { //    CRC8
      //   
      wr_buf.Size=1;
      wr_buf.Data[0]=0x62;                                // ReadByte_1W
      if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                             LBar->Free();                //    -
                             ClosePort();
                             return OutputData;
                           }
      Sleep(1);
      //   
      rd_buf=ReadFrom();                                  // 
      if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                         LBar->Free();                    //    -
                         ClosePort();
                         return OutputData;
                       }
      Sleep(1);
      //   CRC8
      for(unsigned int j=0;j<8;j++)
      { CRC8=CalcCRC8(CRC8,rd_buf.Data[0]); //  CRC
        rd_buf.Data[0]=rd_buf.Data[0]>>1;   //  
      }
      if(CRC8)  SendMsgToLogForm(14,"");          //  CRC8
      CRC8=0;   //  CRC8   
    }
    Address+=1;                                                         //  
    LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;      //    -
    Sleep(1);
  }
  //         (Test)
  Sleep(1);
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     (Test)
  rd_buf=ReadFrom();                                    // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                      //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];
  Sleep(1);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;
}
//---------------------------------------------------------------------------
//---    (0x0F) (  Area1  Scratchpad) --------------
//---------------------------------------------------------------------------
// input:       Input.TA1, Input.TA2, Input.Size, Input.AreaNumber
// output:      Test - ,       (0xFF) + Success
DS2502_OUTPUT_DATA DS2502_WriteToMemory(DS2502_INPUT_DATA InputData)
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS2502_OUTPUT_DATA OutputData;        //   
  unsigned int Address;           	//   
  unsigned char CRC8;                   //   CRC8
  unsigned char TempByte;

  OutputData.Test=0;
  OutputData.Success=false;             //  
  Address=InputData.TA1+0x100*InputData.TA2;             //    ,    

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  switch(SelectedProgrammer)
  { case 1:     //   RH-0004
                //***************
                //  I/O    
                // *** I/O0, 2  , IO1-  ,     ***
                //  IO0ConfigInput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0C;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO1ConfigOutput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0F;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO2ConfigInput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x14;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                // ***     ***
                //  IO0Output0
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0D;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO1Output0
                wr_buf.Size=1;
                wr_buf.Data[0]=0x11;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO2Output0
                wr_buf.Size=1;
                wr_buf.Data[0]=0x15;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                break;
    case 2:     //   RH-0010
                //   
    default:    break;
  }
  //**************************************************************
  //***************     ******************
  //**************************************************************
  for(unsigned int n=0; n<InputData.Size; n++)          //     
  { //  Reset
    wr_buf.Size=1;
    wr_buf.Data[0]=0x60;
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");       //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //  Match ROM
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    wr_buf.Data[1]=0x55;                                  // Match ROM
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //  8  ROM-
    for(unsigned int i=0; i<8; i++)                       //   
    { wr_buf.Size=2;
      wr_buf.Data[0]=0x61;                                // SendByte_1W
      wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
      if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                             LBar->Free();                //    -
                             ClosePort();
                             return OutputData;
                           }
      Sleep(1);
    }
    //   EEPROM
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    wr_buf.Data[1]=0x0F;                                  // Write EEPROM
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(10);
    //     CRC8
    CRC8=0;
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
      wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
    }
    //  TA1
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    wr_buf.Data[1]=Address;                               //      TA1
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");       //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   CRC8
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
      wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
    }
    //  TA2
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    wr_buf.Data[1]=Address>>8;                            //    TA2
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");       //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   CRC8
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
      wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
    }
    //***    ***
    //   
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    switch(InputData.AreaNumber)
    { case 1:  wr_buf.Data[1]=SelectedChip.Area1[Address-SelectedChip.Area1Start];   //    
               break;
      default: wr_buf.Data[1]=SelectedChip.Area3[0];                                 //  
               break;
    }
    TempByte=wr_buf.Data[1];    //   
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   CRC8
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
      wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
    }
    //    CRC8
    //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                                  // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    Sleep(1);
    //   CRC8
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,rd_buf.Data[0]); //  CRC
      rd_buf.Data[0]=rd_buf.Data[0]>>1;   //  
    }
    if(CRC8)
    { SendMsgToLogForm(14,"");          //  CRC8
      LBar->Free();                     //    -
      return OutputData;                //     (    )
    }
    //   
    switch(SelectedProgrammer)
    { case 1:   //   RH-0004
                //  IO0ConfigOutput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0B;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                Sleep(1);
                //  IO0ConfigInput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0C;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                break;
      case 2:   //   RH-0010
                //  Get580us_Pulse_1W (0x69)
                wr_buf.Size=1;
                wr_buf.Data[0]=0x69;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                break;
      default:  break;
    }
    Sleep(10);
    //      
    //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                                  // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    Sleep(1);
    //     -    
    if(TempByte!=rd_buf.Data[0])        SendMsgToLogForm(105,""); //   (  )
    Address+=1;                                                   //  

    LBar->ProgressBar1->Position=100*(n+1)/InputData.Size;      //    -
    Sleep(1);
  }
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;
}
//---------------------------------------------------------------------------
//---     (0x55) (  Area2 -----------------------
//---------------------------------------------------------------------------
// input:       Input.TA1, Input.TA2, Input.Size
// output:      Test - ,       (0xFF) + Success
DS2502_OUTPUT_DATA DS2502_WriteToStatus(DS2502_INPUT_DATA InputData)
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS2502_OUTPUT_DATA OutputData;        //   
  unsigned int Address;           	//   
  unsigned char CRC8;                   //   CRC8
  unsigned char TempByte;

  OutputData.Test=0;
  OutputData.Success=false;             //  
  Address=InputData.TA1+0x100*InputData.TA2;             //    ,    

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  switch(SelectedProgrammer)
  { case 1:     //   RH-0004
                //***************
                //  I/O    
                // *** I/O0, 2  , IO1-  ,     ***
                //  IO0ConfigInput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0C;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO1ConfigOutput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0F;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO2ConfigInput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x14;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                // ***     ***
                //  IO0Output0
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0D;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO1Output0
                wr_buf.Size=1;
                wr_buf.Data[0]=0x11;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                //  IO2Output0
                wr_buf.Size=1;
                wr_buf.Data[0]=0x15;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                break;
    case 2:     //   RH-0010
                //   
    default:    break;
  }
  //**************************************************************
  //***************     ******************
  //**************************************************************
  for(unsigned int n=0; n<InputData.Size; n++)          //     
  { //  Reset
    wr_buf.Size=1;
    wr_buf.Data[0]=0x60;
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //  Match ROM
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    wr_buf.Data[1]=0x55;                                  // Match ROM
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //  8  ROM-
    for(unsigned int i=0; i<8; i++)                       //   
    { wr_buf.Size=2;
      wr_buf.Data[0]=0x61;                                // SendByte_1W
      wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
      if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                             LBar->Free();                //    -
                             ClosePort();
                             return OutputData;
                           }
      Sleep(1);
    }
    //   Status
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    wr_buf.Data[1]=0x55;                                  // Write Status
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(10);
    //     CRC8
    CRC8=0;
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
      wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
    }
    //  TA1
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    wr_buf.Data[1]=Address;                               //       TA1
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");       //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   CRC8
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
      wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
    }
    //  TA2
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    wr_buf.Data[1]=Address>>8;                            //       TA2
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");       //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   CRC8
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
      wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
    }
    //***    ***
    //   
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    wr_buf.Data[1]=SelectedChip.Area2[Address-SelectedChip.Area2Start];   //    
    TempByte=wr_buf.Data[1];    //   
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                  //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   CRC8
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,wr_buf.Data[1]); //  CRC
      wr_buf.Data[1]=wr_buf.Data[1]>>1;   //  
    }
    //    CRC8
    //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                                  // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    Sleep(1);
    //   CRC8
    for(unsigned int j=0;j<8;j++)
    { CRC8=CalcCRC8(CRC8,rd_buf.Data[0]); //  CRC
      rd_buf.Data[0]=rd_buf.Data[0]>>1;   //  
    }
    if(CRC8)
    { SendMsgToLogForm(14,"");          //  CRC8
      LBar->Free();                     //    -
      return OutputData;                //     (    )
    }
    //   
    switch(SelectedProgrammer)
    { case 1:   //   RH-0004
                //  IO0ConfigOutput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0B;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                Sleep(1);
                //  IO0ConfigInput
                wr_buf.Size=1;
                wr_buf.Data[0]=0x0C;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                break;
      case 2:   //   RH-0010
                //  Get580us_Pulse_1W (0x69)
                wr_buf.Size=1;
                wr_buf.Data[0]=0x69;
                if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                                       LBar->Free();            //    -
                                       ClosePort();
                                       return OutputData;
                                     }
                break;
      default:  break;
    }
    Sleep(10);
    //      
    //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                                  // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    Sleep(1);
    //     -    
    if(TempByte!=rd_buf.Data[0])        SendMsgToLogForm(105,""); //   (  )
    Address+=1;                                                         //  

    LBar->ProgressBar1->Position=100*(n+1)/InputData.Size;      //    -
    Sleep(1);
  }
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;
}
//---------------------------------------------------------------------------
