//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MainProgram.h"        //      
#include "ProgressBar.h"        //   -
#include "About.h"              //    About
#include "Schematic.h"          //    Schema
#include "PortFunctions.h"      //    
#include "WireFunctions.h"      //    1-Wire
#include "ChipFunctions.h"      //     
#include "FormFunctions.h"      //      
#include "SendMsgFunctions.h"   //     
#include "CalcCRC.h"            //   CRC
#include "DS2431.h"             //     DS2431 / DS28E07
#include "DS2430A.h"            //     DS2430A / DS1971
#include "DS24B33.h"            //     DS24B33
#include "DS18B20.h"            //     DS18B20, DS1822
#include "DS18S20.h"            //     DS18S20 / DS1920
#include "DS1991.h"             //     DS1991
#include "DS1992.h"             //     DS1992, DS1993, DS1995, DS1996
#include "DS2405.h"             //     DS2405
#include "DS2415.h"             //     DS2415, DS2417
#include "DS1994.h"             //     DS1994, DS1427
#include "DS1963L.h"            //     DS1963L, DS2423
#include "DS2890.h"             //     DS2890
#include "RW1990.h"             //     RW1990
#include "DS28E05.h"            //     DS28E05
#include "AN1990.h"             //     AN1990 / TM2004 
#include "DS2502.h"             //     DS2502 / DS1982
#include "DS2432.h"             //     DS2432 / DS1961S
#include "MAX31826.h"           //     MAX31826
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
//---   -------------------------------------------------
//---------------------------------------------------------------------------
TForm1 *Form1;  // 
//---------------------------------------------------------------------------
//---   COM- -----------------------------------------
//---------------------------------------------------------------------------
void OpenPort()
{ //  .     nt-  
  // "\\.\PortName",      \    2 
  char PortName[100]="\\\\.\\";
  strcat(PortName,Form1->ComboBox1->Text.c_str());
  OpenCom(PortName);                    //     
  if(Port!=INVALID_HANDLE_VALUE)
  { Form1->Button1->Enabled=false;
    Form1->Button2->Enabled=true;
    Form1->Button3->Enabled=true;
    EnableControlButtons();                     //   
    SendMsgToLogForm(4,AnsiString(PortName));   //  COM-
  }
  else  SendMsgToLogForm(2,"");                 // COM-  
}
//---------------------------------------------------------------------------
//---   COM- -----------------------------------------
//---------------------------------------------------------------------------
void ClosePort()
{ CloseHandle(Port);
  Port=INVALID_HANDLE_VALUE;
  Form1->Button1->Enabled=true;
  Form1->Button2->Enabled=false;
  Form1->Button3->Enabled=false;
  DisableControlButtons();              //   
  SendMsgToLogForm(5,"");               // COM- 
}
//---------------------------------------------------------------------------
//---    -----------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ Port                          = INVALID_HANDLE_VALUE;         //   
  SelectedChip.Family           = 0;                            //   
  SelectedChip.Modify           = 0;                            //     
  Form1->Panel2->Visible        = false;                        //   
  Form1->Panel3->Visible        = false;                        //      
  Form1->Timer1->Enabled        = false;                        //  
  Form1->AutoSize               = true;
  Button1->Enabled              = true;
  Button2->Enabled              = false;
  Button3->Enabled              = false;
  StringGrid1->Cells[0][0]      = "";
  StringGrid1->Cells[1][0]      = "ROM Number";
  StringGrid1->Cells[2][0]      = "Description";
  LoadOptions();                                                //      
  RenameFormElements();                                         //  
  RenameProgrammerMenu();                                       //      
}
//---------------------------------------------------------------------------
//---   COM- ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ OpenPort();
}
//---------------------------------------------------------------------------
//---   COM- ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ ClosePort();
}
//---------------------------------------------------------------------------
//---    COM- --------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{ //   ,    
  if(Port!=INVALID_HANDLE_VALUE) ClosePort();
}
//---------------------------------------------------------------------------
//---     EXIT ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{ if(Port!=INVALID_HANDLE_VALUE) ClosePort();
  SaveOptions();    //     
  Close();
}
//---------------------------------------------------------------------------
//---     ABOUT --------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{ AboutBox->Show();
}
//---------------------------------------------------------------------------
//---      1-WIRE --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{ int  DevCounter;      //   

  DevCounter=SearchDevices();
  Edit2->Text=IntToStr(DevCounter);
}
//---------------------------------------------------------------------------
//---       POPUP  ------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Select1Click(TObject *Sender)
{ int CurrentRow;
  unsigned char *InBuf, OutBuf[1];
  AnsiString StringROM, SubStr;

  CurrentRow=StringGrid1->Row;                  //    
  if((CurrentRow>0)&&(StringGrid1->Cells[0][CurrentRow]!=""))
  { //  ROM    
    StringROM=StringGrid1->Cells[1][CurrentRow];
    Edit3->Text=StringROM;
    //   
    SubStr=StringROM.SubString(1,2);            //  ROM[0] - family code
    InBuf=SubStr.c_str();
    HexToBin(InBuf,OutBuf,1);                   //     ()
    SelectedChip.Modify=0;                      //   -   
    InitChip(OutBuf[0]);                        //   ,  
    InitFormInf(OutBuf[0]);                     //      
    InitForm(OutBuf[0]);                        //      
  }
  else  SendMsgToLogForm(1,"");                 //  1 (    ROM)
}
//---------------------------------------------------------------------------
//---  PDF-   -----------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Chippdf1Click(TObject *Sender)
{ unsigned short ChipType;      //    
  AnsiString FilePath;          //   

  ChipType = SelectedChip.Family<<8 + SelectedChip.Modify;      //   
  FilePath="pdf\\";                                             //     
  switch(ChipType)
  { case 0x0001: FilePath += "RW1990.pdf";      //    
                 break;
    case 0x0002: FilePath += "AN1990.pdf";
                 break;
    case 0x0003: FilePath += "TM2004.pdf";      //    
                 break;
    case 0x2D00: FilePath += "DS2431.pdf";
                 break;
    case 0x2D01: FilePath += "DS28E07.pdf";
                 break;
    case 0x1400: FilePath += "DS2430A.pdf";
                 break;
    case 0x1401: FilePath += "DS1971.pdf";
                 break;
    case 0x2300: FilePath += "DS24B33.pdf";
                 break;
    case 0x2800: FilePath += "DS18B20.pdf";
                 break;
    case 0x1000: FilePath += "DS18S20.pdf";
                 break;
    case 0x1001: FilePath += "DS1920.pdf";
                 break;
    case 0x0200: FilePath += "DS1991.pdf";
                 break;
    case 0x8200: FilePath += "DS1425.pdf";
                 break;
    case 0x0800: FilePath += "DS1992-DS1993.pdf";
                 break;
    case 0x0600: FilePath += "DS1992-DS1993.pdf";
                 break;
    case 0x0A00: FilePath += "DS1995.pdf";
                 break;
    case 0x0C00: FilePath += "DS1996.pdf";
                 break;
    case 0x0500: FilePath += "DS2405.pdf";
                 break;
    case 0x2200: FilePath += "DS1822.pdf";
                 break;
    case 0x2400: FilePath += "DS2415.pdf";
                 break;
    case 0x2700: FilePath += "DS2417.pdf";
                 break;
    case 0x0400: FilePath += "DS1994.pdf";
                 break;
    case 0x0401: FilePath += "DS2404.pdf";
                 break;
    case 0x1A00: FilePath += "DS1963L.pdf";
                 break;
    case 0x1D00: FilePath += "DS2423.pdf";
                 break;
    case 0x2C00: FilePath += "DS2890.pdf";
                 break;
    case 0x3300: FilePath += "DS2432.pdf";
                 break;
    case 0x3301: FilePath += "DS1961S.pdf";
                 break;
    case 0x8400: FilePath += "DS1427.pdf";
                 break;
    case 0x0D00: FilePath += "DS28E05.pdf";
                 break;
    case 0x0900: FilePath += "DS2502.pdf";
                 break;
    case 0x0901: FilePath += "DS1982.pdf";
                 break;
    case 0x3B00: FilePath += "MAX31826.pdf";
                 break;
    default:     break;
  }
  if(FilePath.Length()>5 && FileExists(FilePath))
  {     ShellExecute(Form1->Handle,"open", FilePath.c_str(),NULL,NULL,SW_SHOWNORMAL);     //  pdf
  }
  else
  {     ShowMessage("Documentation is not found.");
        SendMsgToLogForm(156,"");                                       //   
  }
}
//---------------------------------------------------------------------------
//---  CRC8  ROM -----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button13Click(TObject *Sender)
{ char TempBuf[1], OutHexBuf[3];                //  
  unsigned char CurrentByte, CurrentBit;        //     
  unsigned char CRC8, TempByte;                 //   CRC8,  
  AnsiString TempString;                        //  

  GetDataToMemory(0,0);                         //  ROM   (    )
  CRC8=0x0;                                       //     CRC8
  //  CRC8   56 
  for(unsigned int i=0; i<56; i++)
  { CurrentByte=i/8; CurrentBit=i-8*CurrentByte;
    TempByte=SelectedChip.ROM[CurrentByte]>>CurrentBit; //        CRC
    CRC8=CalcCRC8(CRC8, TempByte);              //   CRC8
  }
  //     
  for(unsigned int i=0; i<8; i++)
  { CRC8=CalcCRC8(CRC8, 0x0);                   //   CRC8
  }
  //      
  CRC8 = (CRC8 & 0x55) << 1 | (CRC8 & 0xAA) >> 1;
  CRC8 = (CRC8 & 0x33) << 2 | (CRC8 & 0xCC) >> 2;
  CRC8 = (CRC8 & 0x0F) << 4 | (CRC8 & 0xF0) >> 4;
  //   CRC
  TempString=Form1->Edit3->Text;                //    
  TempString=TempString.SubString(1,21);        //  ,    
  TempBuf[0]=CRC8;                              //   CRC
  BinToHex(TempBuf,OutHexBuf,1);                //     ()
  OutHexBuf[2]=0;                               //    
  TempString+=UpperCase(OutHexBuf);             //        ROM
  Form1->Edit3->Text=TempString;                //    
}
//---------------------------------------------------------------------------
//---   ROM -----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit3KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";      //  
  char Symbol;                                  //   
  int Position;                                 //  

  Position=Form1->Edit3->SelStart;              //    
  switch(Key)
  { //  backspace ***********************************
    case 8:     Position-=1;                            //  
                if(Position<0)       Position=23;       //   <0,     
                else if(Position%3!=2)                  //      
                { Form1->Edit3->SelStart=Position;      //  
                  Form1->Edit3->SelLength=1;            //  1 
                  Symbol=0x46;                          //    F
                  Form1->Edit3->SelText=Symbol;         // 
                }
                //     
                Form1->Edit3->SelStart=Position;      //     
                Form1->Edit3->SelLength=0;            //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: Key=0x46;                    //   F,      
     //     ***********************
     default:   if(Position>22)       Position=-1;            //   >22,     
                else if(strchr(Charset1,Key)&&Position%3!=2)  //          
                { Form1->Edit3->SelStart=Position;            //     
                  Form1->Edit3->SelLength=1;                  //  1 
                  Symbol=Key;
                  Form1->Edit3->SelText=Symbol;               //    
                  Form1->Edit3->SelStart=Position;            //     
                  Form1->Edit3->SelLength=1;                  //  1 
                  Form1->Edit3->SelText=UpperCase(Form1->Edit3->SelText); //      
                }
                //     
                Position+=1;                          //   
                Form1->Edit3->SelStart=Position;      //     
                Form1->Edit3->SelLength=0;            //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditsKeyPress(TObject *Sender, char &Key)
{ Key=0;
}
//---------------------------------------------------------------------------
//---   TA1 -----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit4KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";      //  
  char Symbol;                                  //   
  int Position;                                 //  

  Position=Form1->Edit4->SelStart;              //    
  switch(Key)
  { //  backspace ***********************************
    case 8:     Position-=1;                            //  
                if(Position<0)       Position=2;        //   <0,     
                else
                { Form1->Edit4->SelStart=Position;      //  
                  Form1->Edit4->SelLength=1;            //  1 
                  Symbol=0x46;                          //    F
                  Form1->Edit4->SelText=Symbol;         // 
                }
                //     
                Form1->Edit4->SelStart=Position;        //     
                Form1->Edit4->SelLength=0;              //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: Key=0x46;                    //   F,      
     //     ***********************
     default:   if(Position>1)       Position=-1;             //   >1,     
                else if(strchr(Charset1,Key))                 //     
                { Form1->Edit4->SelStart=Position;            //     
                  Form1->Edit4->SelLength=1;                  //  1 
                  Symbol=Key;
                  Form1->Edit4->SelText=Symbol;               //    
                  Form1->Edit4->SelStart=Position;            //     
                  Form1->Edit4->SelLength=1;                  //  1 
                  Form1->Edit4->SelText=UpperCase(Form1->Edit4->SelText); //      
                }
                //     
                Position+=1;                          //   
                Form1->Edit4->SelStart=Position;      //     
                Form1->Edit4->SelLength=0;            //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   TA2 -----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit5KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";      //  
  char Symbol;                                  //   
  int Position;                                 //  

  Position=Form1->Edit5->SelStart;              //    
  switch(Key)
  { //  backspace ***********************************
    case 8:     Position-=1;                            //  
                if(Position<0)       Position=2;        //   <0,     
                else
                { Form1->Edit5->SelStart=Position;      //  
                  Form1->Edit5->SelLength=1;            //  1 
                  Symbol=0x46;                          //    F
                  Form1->Edit5->SelText=Symbol;         // 
                }
                //     
                Form1->Edit5->SelStart=Position;        //     
                Form1->Edit5->SelLength=0;              //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: Key=0x46;                    //   F,      
     //     ***********************
     default:   if(Position>1)       Position=-1;             //   >1,     
                else if(strchr(Charset1,Key))                 //     
                { Form1->Edit5->SelStart=Position;            //     
                  Form1->Edit5->SelLength=1;                  //  1 
                  Symbol=Key;
                  Form1->Edit5->SelText=Symbol;               //    
                  Form1->Edit5->SelStart=Position;            //     
                  Form1->Edit5->SelLength=1;                  //  1 
                  Form1->Edit5->SelText=UpperCase(Form1->Edit5->SelText); //      
                }
                //     
                Position+=1;                          //   
                Form1->Edit5->SelStart=Position;      //     
                Form1->Edit5->SelLength=0;            //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   E/S -----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit6KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";      //  
  char Symbol;                                  //   
  int Position;                                 //  

  Position=Form1->Edit6->SelStart;              //    
  switch(Key)
  { //  backspace ***********************************
    case 8:     Position-=1;                            //  
                if(Position<0)       Position=2;        //   <0,     
                else
                { Form1->Edit6->SelStart=Position;      //  
                  Form1->Edit6->SelLength=1;            //  1 
                  Symbol=0x46;                          //    F
                  Form1->Edit6->SelText=Symbol;         // 
                }
                //     
                Form1->Edit6->SelStart=Position;        //     
                Form1->Edit6->SelLength=0;              //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: Key=0x46;                    //   F,      
     //     ***********************
     default:   if(Position>1)       Position=-1;             //   >1,     
                else if(strchr(Charset1,Key))                 //     
                { Form1->Edit6->SelStart=Position;            //     
                  Form1->Edit6->SelLength=1;                  //  1 
                  Symbol=Key;
                  Form1->Edit6->SelText=Symbol;               //    
                  Form1->Edit6->SelStart=Position;            //     
                  Form1->Edit6->SelLength=1;                  //  1 
                  Form1->Edit6->SelText=UpperCase(Form1->Edit6->SelText); //      
                }
                //     
                Position+=1;                          //   
                Form1->Edit6->SelStart=Position;      //     
                Form1->Edit6->SelLength=0;            //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT1 (Area 1) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit1->SelStart;            //     
  LineNumber=PositionGlobal/46;                         //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber;           //    
  MaxLineNumber=(FormData.RE1Size-1)/8;                 //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<6)
                { PositionLocal=29;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<29)               //      hex
                { if ((PositionLocal-6)%3!=2)           //      
                  { //   
                    Form1->RichEdit1->SelStart=LineNumber*46+PositionLocal;     //  
                    Form1->RichEdit1->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit1->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit1->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit1->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit1->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           //  (TempBuf[0]      )
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit1->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit1->SelLength=1;      //  1 
                    Form1->RichEdit1->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<36)               //       
                { PositionLocal=44;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit1->SelStart=LineNumber*46+PositionLocal;       //  
                  Form1->RichEdit1->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit1->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  //   
                  Form1->RichEdit1->SelStart=LineNumber*46+6+3*CharPos;         //  
                  Form1->RichEdit1->SelLength=2;        //  2 
                  Form1->RichEdit1->SelText="FF";       // 
                }
                //     
                Form1->RichEdit1->SelStart=LineNumber*46+PositionLocal;         //     
                Form1->RichEdit1->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>5) && (PositionLocal<29))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>35)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>43)            //   > 43
                { PositionLocal=35;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>35)       //   > 35
                { //   
                  Form1->RichEdit1->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit1->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit1->SelText=Symbol;                             //    
                  Form1->RichEdit1->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit1->SelLength=1;                                //  1 
                  Form1->RichEdit1->SelText=UpperCase(Form1->RichEdit1->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit1->SelStart=LineNumber*46+6+3*CharPos;         //     
                  Form1->RichEdit1->SelLength=2;                                //  2 
                  Form1->RichEdit1->SelText=OutHexBuf;
                }
                else if(PositionLocal>28)       //   >28,
                { PositionLocal=5;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>5)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-6)%3!=2))            //          
                  { //   
                    Form1->RichEdit1->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit1->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit1->SelText=Symbol;                           //    
                    Form1->RichEdit1->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit1->SelLength=1;                              //  1 
                    Form1->RichEdit1->SelText=UpperCase(Form1->RichEdit1->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit1->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit1->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit1->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit1->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit1->SelLength=1;      //  1 
                    Form1->RichEdit1->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=5;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit1->SelStart=LineNumber*46+PositionLocal; //     
                Form1->RichEdit1->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEditsKeyPress(TObject *Sender, char &Key)
{ Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT2 (Area 1) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit2->SelStart;            //     
  LineNumber=PositionGlobal/46;                         //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber;           //    
  MaxLineNumber=(FormData.RE2Size-1)/8;           //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<6)
                { PositionLocal=29;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<29)               //      hex
                { if ((PositionLocal-6)%3!=2)           //      
                  { //   
                    Form1->RichEdit2->SelStart=LineNumber*46+PositionLocal;     //  
                    Form1->RichEdit2->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit2->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit2->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit2->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit2->SelText);                //    
                    InHexBuf=SubStr.c_str();           //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0]; 
                    //   
                    Form1->RichEdit2->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit2->SelLength=1;      //  1 
                    Form1->RichEdit2->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<36)               //       
                { PositionLocal=44;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit2->SelStart=LineNumber*46+PositionLocal;       //  
                  Form1->RichEdit2->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit2->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  //   
                  Form1->RichEdit2->SelStart=LineNumber*46+6+3*CharPos;         //  
                  Form1->RichEdit2->SelLength=2;        //  2 
                  Form1->RichEdit2->SelText="FF";       // 
                }
                //     
                Form1->RichEdit2->SelStart=LineNumber*46+PositionLocal;         //     
                Form1->RichEdit2->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>5) && (PositionLocal<29))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>35)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>43)            //   > 43
                { PositionLocal=35;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>35)       //   > 35
                { //   
                  Form1->RichEdit2->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit2->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit2->SelText=Symbol;                             //    
                  Form1->RichEdit2->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit2->SelLength=1;                                //  1 
                  Form1->RichEdit2->SelText=UpperCase(Form1->RichEdit2->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit2->SelStart=LineNumber*46+6+3*CharPos;         //     
                  Form1->RichEdit2->SelLength=2;                                //  2 
                  Form1->RichEdit2->SelText=OutHexBuf;
                }
                else if(PositionLocal>28)       //   >28,
                { PositionLocal=5;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>5)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-6)%3!=2))            //          
                  { //   
                    Form1->RichEdit2->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit2->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit2->SelText=Symbol;                           //    
                    Form1->RichEdit2->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit2->SelLength=1;                              //  1 
                    Form1->RichEdit2->SelText=UpperCase(Form1->RichEdit2->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit2->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit2->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit2->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit2->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit2->SelLength=1;      //  1 
                    Form1->RichEdit2->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=5;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit2->SelStart=LineNumber*46+PositionLocal; //     
                Form1->RichEdit2->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT3 (Area 2) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit3KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit3->SelStart;            //     
  LineNumber=PositionGlobal/46;                         //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber;           //    
  MaxLineNumber=(FormData.RE3Size-1)/8;           //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<6)
                { PositionLocal=29;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<29)               //      hex
                { if ((PositionLocal-6)%3!=2)           //      
                  { //   
                    Form1->RichEdit3->SelStart=LineNumber*46+PositionLocal;     //  
                    Form1->RichEdit3->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit3->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit3->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit3->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit3->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit3->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit3->SelLength=1;      //  1 
                    Form1->RichEdit3->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<36)               //       
                { PositionLocal=44;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit3->SelStart=LineNumber*46+PositionLocal;       //  
                  Form1->RichEdit3->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit3->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  //   
                  Form1->RichEdit3->SelStart=LineNumber*46+6+3*CharPos;         //  
                  Form1->RichEdit3->SelLength=2;        //  2 
                  Form1->RichEdit3->SelText="FF";       // 
                }
                //     
                Form1->RichEdit3->SelStart=LineNumber*46+PositionLocal;         //     
                Form1->RichEdit3->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>5) && (PositionLocal<29))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>35)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>43)            //   > 43
                { PositionLocal=35;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>35)       //   > 35
                { //   
                  Form1->RichEdit3->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit3->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit3->SelText=Symbol;                             //    
                  Form1->RichEdit3->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit3->SelLength=1;                                //  1 
                  Form1->RichEdit3->SelText=UpperCase(Form1->RichEdit3->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit3->SelStart=LineNumber*46+6+3*CharPos;         //     
                  Form1->RichEdit3->SelLength=2;                                //  2 
                  Form1->RichEdit3->SelText=OutHexBuf;
                }
                else if(PositionLocal>28)       //   >28,
                { PositionLocal=5;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>5)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-6)%3!=2))            //          
                  { //   
                    Form1->RichEdit3->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit3->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit3->SelText=Symbol;                           //    
                    Form1->RichEdit3->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit3->SelLength=1;                              //  1 
                    Form1->RichEdit3->SelText=UpperCase(Form1->RichEdit3->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit3->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit3->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit3->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit3->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit3->SelLength=1;      //  1 
                    Form1->RichEdit3->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=5;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit3->SelStart=LineNumber*46+PositionLocal; //     
                Form1->RichEdit3->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT4 (Area 2) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit4KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit4->SelStart;            //     
  LineNumber=PositionGlobal/46;                         //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber;           //    
  MaxLineNumber=(FormData.RE4Size-1)/8;           //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<6)
                { PositionLocal=29;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<29)               //      hex
                { if ((PositionLocal-6)%3!=2)           //      
                  { //   
                    Form1->RichEdit4->SelStart=LineNumber*46+PositionLocal;     //  
                    Form1->RichEdit4->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit4->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit4->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit4->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit4->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit4->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit4->SelLength=1;      //  1 
                    Form1->RichEdit4->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<36)               //       
                { PositionLocal=44;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit4->SelStart=LineNumber*46+PositionLocal;       //  
                  Form1->RichEdit4->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit4->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  //   
                  Form1->RichEdit4->SelStart=LineNumber*46+6+3*CharPos;         //  
                  Form1->RichEdit4->SelLength=2;        //  2 
                  Form1->RichEdit4->SelText="FF";       // 
                }
                //     
                Form1->RichEdit4->SelStart=LineNumber*46+PositionLocal;         //     
                Form1->RichEdit4->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>5) && (PositionLocal<29))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>35)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>43)            //   > 43
                { PositionLocal=35;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>35)       //   > 35
                { //   
                  Form1->RichEdit4->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit4->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit4->SelText=Symbol;                             //    
                  Form1->RichEdit4->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit4->SelLength=1;                                //  1 
                  Form1->RichEdit4->SelText=UpperCase(Form1->RichEdit4->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit4->SelStart=LineNumber*46+6+3*CharPos;         //     
                  Form1->RichEdit4->SelLength=2;                                //  2 
                  Form1->RichEdit4->SelText=OutHexBuf;
                }
                else if(PositionLocal>28)       //   >28,
                { PositionLocal=5;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>5)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-6)%3!=2))            //          
                  { //   
                    Form1->RichEdit4->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit4->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit4->SelText=Symbol;                           //    
                    Form1->RichEdit4->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit4->SelLength=1;                              //  1 
                    Form1->RichEdit4->SelText=UpperCase(Form1->RichEdit4->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit4->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit4->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit4->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit4->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit4->SelLength=1;      //  1 
                    Form1->RichEdit4->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=5;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit4->SelStart=LineNumber*46+PositionLocal; //     
                Form1->RichEdit4->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT5 (Area 3) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit5KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit5->SelStart;            //     
  LineNumber=PositionGlobal/46;                         //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber;           //    
  MaxLineNumber=(FormData.RE5Size-1)/8;      //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<6)
                { PositionLocal=29;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<29)               //      hex
                { if ((PositionLocal-6)%3!=2)           //      
                  { //   
                    Form1->RichEdit5->SelStart=LineNumber*46+PositionLocal;     //  
                    Form1->RichEdit5->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit5->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit5->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit5->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit5->SelText);                //    
                    InHexBuf=SubStr.c_str();           //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit5->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit5->SelLength=1;      //  1 
                    Form1->RichEdit5->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<36)               //       
                { PositionLocal=44;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit5->SelStart=LineNumber*46+PositionLocal;       //  
                  Form1->RichEdit5->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit5->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  //   
                  Form1->RichEdit5->SelStart=LineNumber*46+6+3*CharPos;         //  
                  Form1->RichEdit5->SelLength=2;        //  2 
                  Form1->RichEdit5->SelText="FF";       // 
                }
                //     
                Form1->RichEdit5->SelStart=LineNumber*46+PositionLocal;         //     
                Form1->RichEdit5->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>5) && (PositionLocal<29))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>35)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>43)            //   > 43
                { PositionLocal=35;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>35)       //   > 35
                { //   
                  Form1->RichEdit5->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit5->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit5->SelText=Symbol;                             //    
                  Form1->RichEdit5->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit5->SelLength=1;                                //  1 
                  Form1->RichEdit5->SelText=UpperCase(Form1->RichEdit5->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit5->SelStart=LineNumber*46+6+3*CharPos;         //     
                  Form1->RichEdit5->SelLength=2;                                //  2 
                  Form1->RichEdit5->SelText=OutHexBuf;
                }
                else if(PositionLocal>28)       //   >28,
                { PositionLocal=5;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>5)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-6)%3!=2))            //          
                  { //   
                    Form1->RichEdit5->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit5->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit5->SelText=Symbol;                           //    
                    Form1->RichEdit5->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit5->SelLength=1;                              //  1 
                    Form1->RichEdit5->SelText=UpperCase(Form1->RichEdit5->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit5->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit5->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit5->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit5->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit5->SelLength=1;      //  1 
                    Form1->RichEdit5->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=5;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit5->SelStart=LineNumber*46+PositionLocal; //     
                Form1->RichEdit5->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT6 (Area 3) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit6KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit6->SelStart;            //     
  LineNumber=PositionGlobal/46;                         //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber;           //    
  MaxLineNumber=(FormData.RE6Size-1)/8;           //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<6)
                { PositionLocal=29;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<29)               //      hex
                { if ((PositionLocal-6)%3!=2)           //      
                  { //   
                    Form1->RichEdit6->SelStart=LineNumber*46+PositionLocal;     //  
                    Form1->RichEdit6->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit6->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit6->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit6->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit6->SelText);                //    
                    InHexBuf=SubStr.c_str();         //      (  )
                    HexToBin(InHexBuf,TempBuf,1);     //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;      // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit6->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit6->SelLength=1;      //  1 
                    Form1->RichEdit6->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<36)               //       
                { PositionLocal=44;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit6->SelStart=LineNumber*46+PositionLocal;       //  
                  Form1->RichEdit6->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit6->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  //   
                  Form1->RichEdit6->SelStart=LineNumber*46+6+3*CharPos;         //  
                  Form1->RichEdit6->SelLength=2;        //  2 
                  Form1->RichEdit6->SelText="FF";       // 
                }
                //     
                Form1->RichEdit6->SelStart=LineNumber*46+PositionLocal;         //     
                Form1->RichEdit6->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>5) && (PositionLocal<29))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>35)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>43)            //   > 43
                { PositionLocal=35;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>35)       //   > 35
                { //   
                  Form1->RichEdit6->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit6->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit6->SelText=Symbol;                             //    
                  Form1->RichEdit6->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit6->SelLength=1;                                //  1 
                  Form1->RichEdit6->SelText=UpperCase(Form1->RichEdit6->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit6->SelStart=LineNumber*46+6+3*CharPos;         //     
                  Form1->RichEdit6->SelLength=2;                                //  2 
                  Form1->RichEdit6->SelText=OutHexBuf;
                }
                else if(PositionLocal>28)       //   >28,
                { PositionLocal=5;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>5)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-6)%3!=2))            //          
                  { //   
                    Form1->RichEdit6->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit6->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit6->SelText=Symbol;                           //    
                    Form1->RichEdit6->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit6->SelLength=1;                              //  1 
                    Form1->RichEdit6->SelText=UpperCase(Form1->RichEdit6->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit6->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit6->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit6->SelText);                //    
                    InHexBuf=SubStr.c_str();               //      (  )
                    HexToBin(InHexBuf,TempBuf,1);          //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit6->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit6->SelLength=1;      //  1 
                    Form1->RichEdit6->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=5;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit6->SelStart=LineNumber*46+PositionLocal; //     
                Form1->RichEdit6->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT7 (Area 4) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit7KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit7->SelStart;            //     
  LineNumber=PositionGlobal/46;                         //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber;           //    
  MaxLineNumber=(FormData.RE7Size-1)/8;           //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<6)
                { PositionLocal=29;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<29)               //      hex
                { if ((PositionLocal-6)%3!=2)           //      
                  { //   
                    Form1->RichEdit7->SelStart=LineNumber*46+PositionLocal;     //  
                    Form1->RichEdit7->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit7->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit7->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit7->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit7->SelText);                //    
                    InHexBuf=SubStr.c_str();         //      (  )
                    HexToBin(InHexBuf,TempBuf,1);     //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;      // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit7->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit7->SelLength=1;      //  1 
                    Form1->RichEdit7->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<36)               //       
                { PositionLocal=44;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit7->SelStart=LineNumber*46+PositionLocal;       //  
                  Form1->RichEdit7->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit7->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  //   
                  Form1->RichEdit7->SelStart=LineNumber*46+6+3*CharPos;         //  
                  Form1->RichEdit7->SelLength=2;        //  2 
                  Form1->RichEdit7->SelText="FF";       // 
                }
                //     
                Form1->RichEdit7->SelStart=LineNumber*46+PositionLocal;         //     
                Form1->RichEdit7->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>5) && (PositionLocal<29))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>35)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>43)            //   > 43
                { PositionLocal=35;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>35)       //   > 35
                { //   
                  Form1->RichEdit7->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit7->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit7->SelText=Symbol;                             //    
                  Form1->RichEdit7->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit7->SelLength=1;                                //  1 
                  Form1->RichEdit7->SelText=UpperCase(Form1->RichEdit7->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit7->SelStart=LineNumber*46+6+3*CharPos;         //     
                  Form1->RichEdit7->SelLength=2;                                //  2 
                  Form1->RichEdit7->SelText=OutHexBuf;
                }
                else if(PositionLocal>28)       //   >28,
                { PositionLocal=5;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>5)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-6)%3!=2))            //          
                  { //   
                    Form1->RichEdit7->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit7->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit7->SelText=Symbol;                           //    
                    Form1->RichEdit7->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit7->SelLength=1;                              //  1 
                    Form1->RichEdit7->SelText=UpperCase(Form1->RichEdit7->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit7->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit7->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit7->SelText);                //    
                    InHexBuf=SubStr.c_str();               //      (  )
                    HexToBin(InHexBuf,TempBuf,1);          //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit7->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit7->SelLength=1;      //  1 
                    Form1->RichEdit7->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=5;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit7->SelStart=LineNumber*46+PositionLocal; //     
                Form1->RichEdit7->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT8 (Area 4) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit8KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit8->SelStart;            //     
  LineNumber=PositionGlobal/46;                         //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber;           //    
  MaxLineNumber=(FormData.RE8Size-1)/8;           //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<6)
                { PositionLocal=29;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<29)               //      hex
                { if ((PositionLocal-6)%3!=2)           //      
                  { //   
                    Form1->RichEdit8->SelStart=LineNumber*46+PositionLocal;     //  
                    Form1->RichEdit8->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit8->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit8->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit8->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit8->SelText);                //    
                    InHexBuf=SubStr.c_str();         //      (  )
                    HexToBin(InHexBuf,TempBuf,1);     //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;      // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit8->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit8->SelLength=1;      //  1 
                    Form1->RichEdit8->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<36)               //       
                { PositionLocal=44;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit8->SelStart=LineNumber*46+PositionLocal;       //  
                  Form1->RichEdit8->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit8->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  //   
                  Form1->RichEdit8->SelStart=LineNumber*46+6+3*CharPos;         //  
                  Form1->RichEdit8->SelLength=2;        //  2 
                  Form1->RichEdit8->SelText="FF";       // 
                }
                //     
                Form1->RichEdit8->SelStart=LineNumber*46+PositionLocal;         //     
                Form1->RichEdit8->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>5) && (PositionLocal<29))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>35)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>43)            //   > 43
                { PositionLocal=35;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>35)       //   > 35
                { //   
                  Form1->RichEdit8->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit8->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit8->SelText=Symbol;                             //    
                  Form1->RichEdit8->SelStart=LineNumber*46+PositionLocal;       //     
                  Form1->RichEdit8->SelLength=1;                                //  1 
                  Form1->RichEdit8->SelText=UpperCase(Form1->RichEdit8->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-36;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit8->SelStart=LineNumber*46+6+3*CharPos;         //     
                  Form1->RichEdit8->SelLength=2;                                //  2 
                  Form1->RichEdit8->SelText=OutHexBuf;
                }
                else if(PositionLocal>28)       //   >28,
                { PositionLocal=5;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>5)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-6)%3!=2))            //          
                  { //   
                    Form1->RichEdit8->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit8->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit8->SelText=Symbol;                           //    
                    Form1->RichEdit8->SelStart=LineNumber*46+PositionLocal;     //     
                    Form1->RichEdit8->SelLength=1;                              //  1 
                    Form1->RichEdit8->SelText=UpperCase(Form1->RichEdit8->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-6)/3;        //    ,   
                    Form1->RichEdit8->SelStart=46*LineNumber+6+3*CharPos;       //      (  )
                    Form1->RichEdit8->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit8->SelText);                //    
                    InHexBuf=SubStr.c_str();               //      (  )
                    HexToBin(InHexBuf,TempBuf,1);          //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit8->SelStart=LineNumber*46+36+CharPos;        //  
                    Form1->RichEdit8->SelLength=1;      //  1 
                    Form1->RichEdit8->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=5;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit8->SelStart=LineNumber*46+PositionLocal; //     
                Form1->RichEdit8->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//***************************************************************************
//***      ********************************************
//***************************************************************************
//---------------------------------------------------------------------------
//---   How to connect... ---------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button16Click(TObject *Sender)
{ Application->CreateForm(__classid(TSchema),&Schema);              //     
  Schema->ShowModal();                                              //     
  Schema->Free();                                                   //    
}
//---------------------------------------------------------------------------
//---   BUTTON4 -------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{ AnsiString TempStr;                           //  
  char *InHexBuf, TempBuf[1], OutHexBuf[3];     //  

  switch(SelectedChip.Family)
  { case 0x0:   //       ROM
                switch(SelectedChip.Modify)
                { case 1:  //-------------------------------------------
                           //   RW1990,   WRITE ROM
                           //-------------------------------------------
                           //   
                           RW1990_OUTPUT_DATA RW1990_OutputData;        //     RW1990
                           SendMsgToLogForm(153, Form1->Edit3->Text);   //   ROM
                           //  
                           GetDataToMemory(0,0);                        //  ROM   (    )
                           if(Port!=INVALID_HANDLE_VALUE)
                           { RW1990_OutputData=RW1990_WriteROM();       //   ROM
                             if(RW1990_OutputData.Success)      SendMsgToLogForm(106,"");  //    
                             else                               SendMsgToLogForm(105,"");  //     
                           }
                           else    SendMsgToLogForm(2,"");    // . COM-  
                           break;
                  case 2:  //-------------------------------------------
                           //   AN1990,   WRITE ROM
                  case 3:  //-------------------------------------------
                           //   TM2004,   WRITE ROM
                           //-------------------------------------------
                           //   
                           AN1990_OUTPUT_DATA AN1990_OutputData;        //     AN1990
                           SendMsgToLogForm(153, Form1->Edit3->Text);   //   ROM
                           //  
                           GetDataToMemory(0,0);                        //  ROM   (    )
                           if(Port!=INVALID_HANDLE_VALUE)
                           { AN1990_OutputData=AN1990_WriteROM();       //   ROM
                             if(AN1990_OutputData.Success)      SendMsgToLogForm(106,"");  //    
                             else                               SendMsgToLogForm(105,"");  //     
                           }
                           else    SendMsgToLogForm(2,"");    // . COM-  
                           break;
                  default: break;
                }
                break;
    case 0x2:   //--------------------------------------------------
                //   DS1991,   WRITE SCRATCHPAD
    case 0x82:  //-------------------------------------------------
                //   DS1425,   WRITE SCRATCHPAD
                //--------------------------------------------------
                //   
                DS1991_OUTPUT_DATA DS1991_OutputData; //     DS1991
                SendMsgToLogForm(116,"");    //    
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //       ( DS1991 Scratchpad   Area4)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(7,4);        //    RichEdit7  Scratchpad
                           break;
                  case 1:  GetDataToMemory(8,4);        //    RichEdit8  Scratchpad
                           break;
                  default: break;
                }
                //     Area4  1-Wire
                if(Port!=INVALID_HANDLE_VALUE)
                { DS1991_OutputData=DS1991_WriteToScratchpad();
                  if(DS1991_OutputData.Success)         SendMsgToLogForm(106,"");  //   scratchpad  
                  else                                  SendMsgToLogForm(105,"");  //   scratchpad   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x4:   //--------------------------------------------------
                //   DS1994,   WRITE SCRATCHPAD
    case 0x84:  //--------------------------------------------------
                //   DS1427,   WRITE SCRATCHPAD
                //--------------------------------------------------
                //   
                DS1994_INPUT_DATA DS1994_InputData;     //     DS1994
                DS1994_OUTPUT_DATA DS1994_OutputData;   //     DS1994
                SendMsgToLogForm(116,"");    //    
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1994_InputData.TA1=TempBuf[0];        //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1994_InputData.TA2=TempBuf[0];        //   TA2
                //           ( DS1994 Scratchpad   Area3)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(5,3);        //    RichEdit5  Scratchpad
                           break;
                  case 1:  GetDataToMemory(6,3);        //    RichEdit6  Scratchpad
                           break;
                  default: break;
                }
                //    1-Wire    (Test)  
                DS1994_InputData.AreaNumber=3;                  //  -  Area3
                DS1994_InputData.Size=SelectedChip.Area3Size;   //    
                if(Port!=INVALID_HANDLE_VALUE)
                { DS1994_OutputData=DS1994_WriteToScratchpad(DS1994_InputData);
                  if(DS1994_OutputData.Success) SendMsgToLogForm(106,"");  //   scratchpad  
                  else                          SendMsgToLogForm(105,"");  //   scratchpad   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x5:   //--------------------------------------------
                //   DS2405,   READ STATE
                //--------------------------------------------
                //   
                DS2405_OUTPUT_DATA DS2405_OutputData; //     DS2405
                SendMsgToLogForm(137,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //   
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2405_OutputData=DS2405_ReadState();
                  if(DS2405_OutputData.Success)
                  { TempBuf[0]=DS2405_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);      //     ()
                    OutHexBuf[2]=0;                     //    
                    Form1->Edit4->Text = OutHexBuf;
                    SendMsgToLogForm(108,"");              //   
                  }
                  else  SendMsgToLogForm(107,"");  //    
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x6 :  //--------------------------------------------------
                //   DS1993,   WRITE SCRATCHPAD
    case 0x8 :  //--------------------------------------------------
                //   DS1992,   WRITE SCRATCHPAD
    case 0xA :  //--------------------------------------------------
                //   DS1995,   WRITE SCRATCHPAD
    case 0xC :  //--------------------------------------------------
                //   DS1996,   WRITE SCRATCHPAD
                //--------------------------------------------------
                //   
                DS1992_INPUT_DATA DS1992_InputData;   //     DS1992
                DS1992_OUTPUT_DATA DS1992_OutputData; //     DS1992
                SendMsgToLogForm(116,"");    //    
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1992_InputData.TA1=TempBuf[0];        //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1992_InputData.TA2=TempBuf[0];        //   TA2
                //           ( DS1992 Scratchpad   Area2)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);        //    RichEdit3  Scratchpad
                           break;
                  case 1:  GetDataToMemory(4,2);        //    RichEdit4  Scratchpad
                           break;
                  default: break;
                }
                //     Area2  1-Wire    (Test)  
                DS1992_InputData.AreaNumber=2;
                DS1992_InputData.Size=SelectedChip.Area2Size;
                if(Port!=INVALID_HANDLE_VALUE)
                { DS1992_OutputData=DS1992_WriteToScratchpad(DS1992_InputData);
                  if(DS1992_OutputData.Success)
                  { TempBuf[0]=DS1992_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);      //     ()
                    OutHexBuf[2]=0;                     //    
                    Form1->Edit7->Text = OutHexBuf;
                    SendMsgToLogForm(106,"");                //   scratchpad  
                  }
                  else  SendMsgToLogForm(105,"");            //   scratchpad   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x9:   //-----------------------------------------------------
                //   DS2502 / DS1982,   WRITE DATA
                //-----------------------------------------------------
                //   
                DS2502_INPUT_DATA DS2502_InputData;     //     DS2502
                DS2502_OUTPUT_DATA DS2502_OutputData;   //     DS2502
                SendMsgToLogForm(121,"");    //    EPROM
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                DS2502_InputData.TA1=0;                 //   TA1
                DS2502_InputData.TA2=0;                 //   TA2
                //           ( DS2502 EPROM   Area1)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);        //    RichEdit1  EPROM
                           break;
                  case 1:  GetDataToMemory(2,1);        //    RichEdit2  EPROM
                           break;
                  default: break;
                }
                //    1-Wire
                DS2502_InputData.AreaNumber=1;                  // EPROM -  Area1
                DS2502_InputData.Size=SelectedChip.Area1Size;   //    EPROM
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2502_OutputData=DS2502_WriteToMemory(DS2502_InputData);
                  if(DS2502_OutputData.Success) SendMsgToLogForm(106,"");                //   EPROM  
                  else                          SendMsgToLogForm(105,"");            //   EPROM   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0xD:   //---------------------------------------------------
                //   DS28E05,   WRITE DATA MEMORY
                //---------------------------------------------------
                //   
                DS28E05_INPUT_DATA DS28E05_InputData;     //     DS28E05
                DS28E05_OUTPUT_DATA DS28E05_OutputData;   //     DS28E05
                SendMsgToLogForm(121,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                //          
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);        //    RichEdit1  Data
                           break;
                  case 1:  GetDataToMemory(2,1);        //    RichEdit2  Data
                           break;
                  default: break;
                }
                //      1-Wire    (Test)  
                //       
                DS28E05_InputData.AreaNumber=1;                                 //        
                //   6 
                for(unsigned char i=0; i<7; i++)
                { //    -   
                  if(Port!=INVALID_HANDLE_VALUE)
                  { //     
                    DS28E05_InputData.PB=i<<4;                                  //   PB
                    DS28E05_OutputData=DS28E05_WriteToMemory(DS28E05_InputData);
                  }
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //   -  
                  if(DS28E05_OutputData.Success==false)                 //    
                  { SendMsgToLogForm(105,"");    //  
                    return;
                  }
                  else          //    -    Test
                  { //    Test
                    TempBuf[0]=DS28E05_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                  }
                }
                SendMsgToLogForm(106,"");    //   
                break;
    case 0x10:  //---------------------------------------------------
                //   DS18S20,   WRITE SCRATCHPAD
                //---------------------------------------------------
                //   
                DS18S20_OUTPUT_DATA DS18S20_OutputData; //     DS18S20
                SendMsgToLogForm(116,"");    //    
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //       ( DS18S20 Scratchpad   Area1)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);        //    RichEdit1  Scratchpad
                           break;
                  case 1:  GetDataToMemory(2,1);        //    RichEdit2  Scratchpad
                           break;
                  default: break;
                }
                //     Area1  1-Wire
                if(Port!=INVALID_HANDLE_VALUE)
                { DS18S20_OutputData=DS18S20_WriteToScratchpad();
                  if(DS18S20_OutputData.Success)        SendMsgToLogForm(106,"");  //   scratchpad  
                  else                                  SendMsgToLogForm(105,"");  //   scratchpad   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x14:  //---------------------------------------------------
                //   DS2430A,   WRITE SCRATCHPAD
                //---------------------------------------------------
                //   
                DS2430_INPUT_DATA DS2430_InputData;     //     DS2430
                DS2430_OUTPUT_DATA DS2430_OutputData;   //     DS2430
                SendMsgToLogForm(116,"");    //    
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //           ( DS2430 Data Scratchpad   Area2)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,2);        //    RichEdit1  Scratchpad
                           break;
                  case 1:  GetDataToMemory(2,2);        //    RichEdit2  Scratchpad
                           break;
                  default: break;
                }
                //     Area2  1-Wire
                DS2430_InputData.AreaNumber=2;
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2430_OutputData=DS2430_WriteToScratchpad(DS2430_InputData);
                  if(DS2430_OutputData.Success)         SendMsgToLogForm(106,"");    //   scratchpad  
                  else                                  SendMsgToLogForm(105,"");    //   scratchpad   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x1A:  //---------------------------------------------------
                //   DS1963L,   WRITE SCRATCHPAD
    case 0x1D:  //---------------------------------------------------
                //   DS2423,   WRITE SCRATCHPAD
                //---------------------------------------------------
                //   
                DS1963L_INPUT_DATA DS1963L_InputData;   //     DS1963L
                DS1963L_OUTPUT_DATA DS1963L_OutputData; //     DS1963L
                SendMsgToLogForm(116,"");    //    
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1963L_InputData.TA1=TempBuf[0];       //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1963L_InputData.TA2=TempBuf[0];       //   TA2
                //           ( DS1963L Scratchpad   Area2)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);        //    RichEdit3  Scratchpad
                           break;
                  case 1:  GetDataToMemory(4,2);        //    RichEdit4  Scratchpad
                           break;
                  default: break;
                }
                //     Area2  1-Wire    (Test)  
                DS1963L_InputData.AreaNumber=2;
                DS1963L_InputData.Size=SelectedChip.Area2Size;
                if(Port!=INVALID_HANDLE_VALUE)
                { DS1963L_OutputData=DS1963L_WriteToScratchpad(DS1963L_InputData);
                  if(DS1963L_OutputData.Success)
                  { TempBuf[0]=DS1963L_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);      //     ()
                    OutHexBuf[2]=0;                     //    
                    Form1->Edit7->Text = OutHexBuf;
                    SendMsgToLogForm(106,"");                //   scratchpad  
                  }
                  else  SendMsgToLogForm(105,"");            //   scratchpad   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x23:  //---------------------------------------------------
                //   DS24B33,   WRITE SCRATCHPAD
                //---------------------------------------------------
                //   
                DS24B33_INPUT_DATA DS24B33_InputData;   //     DS24B33
                DS24B33_OUTPUT_DATA DS24B33_OutputData; //     DS24B33
                SendMsgToLogForm(116,"");    //    
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS24B33_InputData.TA1=TempBuf[0];       //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS24B33_InputData.TA2=TempBuf[0];       //   TA2
                //           ( DS24B33 Scratchpad   Area2)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);        //    RichEdit3  Scratchpad
                           break;
                  case 1:  GetDataToMemory(4,2);        //    RichEdit4  Scratchpad
                           break;
                  default: break;
                }
                //     Area2  1-Wire    (Test)  
                DS24B33_InputData.AreaNumber=2;
                DS24B33_InputData.Size=SelectedChip.Area2Size;
                if(Port!=INVALID_HANDLE_VALUE)
                { DS24B33_OutputData=DS24B33_WriteToScratchpad(DS24B33_InputData);
                  if(DS24B33_OutputData.Success)
                  { TempBuf[0]=DS24B33_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);      //     ()
                    OutHexBuf[2]=0;                     //    
                    Form1->Edit7->Text = OutHexBuf;
                    SendMsgToLogForm(106,"");                //   scratchpad  
                  }
                  else  SendMsgToLogForm(105,"");            //   scratchpad   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x24:   //--------------------------------------------
                //   DS2415,   WRITE CLOCK
    case 0x27:   //--------------------------------------------
                //   DS2417,   WRITE CLOCK
                //---------------------------------------------
                //   
                DS2415_OUTPUT_DATA DS2415_OutputData; //     DS2415
                SendMsgToLogForm(142,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //       ( DS2415    Area1)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);        //    RichEdit1  Area1
                           break;
                  case 1:  GetDataToMemory(2,1);        //    RichEdit2  Area1
                           break;
                  default: break;
                }
                //     Area1  1-Wire
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2415_OutputData=DS2415_WriteClock();
                  if(DS2415_OutputData.Success)         SendMsgToLogForm(106,"");  //    
                  else                                  SendMsgToLogForm(105,"");  //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x22:  //---------------------------------------------------
                //   DS1822,   WRITE SCRATCHPAD
    case 0x28:  //---------------------------------------------------
                //   DS18B20,   WRITE SCRATCHPAD
                //---------------------------------------------------
                //   
                DS18B20_OUTPUT_DATA DS18B20_OutputData; //     DS18B20
                SendMsgToLogForm(116,"");    //    
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //       ( DS18B20 Scratchpad   Area1)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);        //    RichEdit1  Scratchpad
                           break;
                  case 1:  GetDataToMemory(2,1);        //    RichEdit2  Scratchpad
                           break;
                  default: break;
                }
                //     Area1  1-Wire
                if(Port!=INVALID_HANDLE_VALUE)
                { DS18B20_OutputData=DS18B20_WriteToScratchpad();
                  if(DS18B20_OutputData.Success)        SendMsgToLogForm(106,"");    //   scratchpad  
                  else                                  SendMsgToLogForm(105,"");    //   scratchpad   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x2C:  //------------------------------------------------
                //   DS2890,   WRITE POSITION
                //------------------------------------------------
                //   
                DS2890_INPUT_DATA DS2890_InputData;     //     DS2890
                DS2890_OUTPUT_DATA DS2890_OutputData;   //     DS2890
                SendMsgToLogForm(142,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                TempStr=LowerCase(Form1->Edit4->Text);  //  Position  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2890_InputData.Position=TempBuf[0];   //   Position
                //   WritePosition    (Test)  
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2890_OutputData=DS2890_WritePosition(DS2890_InputData);
                  if(DS2890_OutputData.Success==true && DS2890_OutputData.Test==0)
                        SendMsgToLogForm(106,"");  //   
                  else  SendMsgToLogForm(105,"");  //    
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x2D:  //--------------------------------------------------
                //   DS2431,   WRITE SCRATCHPAD
                //--------------------------------------------------
                //   
                DS2431_INPUT_DATA DS2431_InputData;     //     DS2431
                DS2431_OUTPUT_DATA DS2431_OutputData;   //     DS2431
                SendMsgToLogForm(116,"");    //    
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2431_InputData.TA1=TempBuf[0];        //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2431_InputData.TA2=TempBuf[0];        //   TA2
                //           ( DS2431 Scratchpad   Area3)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(5,3);        //    RichEdit5  Scratchpad
                           break;
                  case 1:  GetDataToMemory(6,3);        //    RichEdit6  Scratchpad
                           break;
                  default: break;
                }
                //    1-Wire    (Test)  
                DS2431_InputData.AreaNumber=3;                  //  -  Area3
                DS2431_InputData.Size=SelectedChip.Area3Size;   //    
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2431_OutputData=DS2431_WriteToScratchpad(DS2431_InputData);
                  if(DS2431_OutputData.Success)
                  { TempBuf[0]=DS2431_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);      //     ()
                    OutHexBuf[2]=0;                     //    
                    Form1->Edit7->Text = OutHexBuf;
                    SendMsgToLogForm(106,"");                //   scratchpad  
                  }
                  else  SendMsgToLogForm(105,"");            //   scratchpad   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x33:  //--------------------------------------------------
                //   DS2432,   WRITE SCRATCHPAD
                //--------------------------------------------------
                //   
                DS2432_INPUT_DATA DS2432_InputData;     //     DS2432
                DS2432_OUTPUT_DATA DS2432_OutputData;   //     DS2432
                SendMsgToLogForm(116,"");    //    
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2432_InputData.TA1=TempBuf[0];        //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2432_InputData.TA2=TempBuf[0];        //   TA2
                //           ( DS2432 Scratchpad   Area4)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(7,4);        //    RichEdit7  Scratchpad
                           break;
                  case 1:  GetDataToMemory(8,4);        //    RichEdit8  Scratchpad
                           break;
                  default: break;
                }
                //    1-Wire    (Test)  
                DS2432_InputData.AreaNumber=4;                  //  -  Area4
                DS2432_InputData.Size=SelectedChip.Area4Size;   //    
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2432_OutputData=DS2432_WriteToScratchpad(DS2432_InputData);
                  if(DS2432_OutputData.Success)
                  { TempBuf[0]=DS2432_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);      //     ()
                    OutHexBuf[2]=0;                     //    
                    Form1->Edit7->Text = OutHexBuf;
                    SendMsgToLogForm(106,"");                //   scratchpad  
                  }
                  else  SendMsgToLogForm(105,"");            //   scratchpad   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x3B:  //--------------------------------------------------
                //   MAX31826,   CONVERT T
                //--------------------------------------------------
                //   
                MAX31826_OUTPUT_DATA MAX31826_OutputData;     //     MAX31826
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { MAX31826_OutputData = MAX31826_ConvertT();    //  
                  if(MAX31826_OutputData.Success) SendMsgToLogForm(151,"");       //  Convert T  
                  else                            SendMsgToLogForm(150,"");       //  Convert T   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---   BUTTON5 -------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{ char TempBuf[1], OutHexBuf[3];        //  

  switch(SelectedChip.Family)
  { case 0x0:   //       ROM
                switch(SelectedChip.Modify)
                { case 1:  //------------------------------------------
                           //   RW1990,   READ ROM
                           //------------------------------------------
                           //   
                           RW1990_OUTPUT_DATA RW1990_OutputData;        //     RW1990
                           SendMsgToLogForm(154,"");                       //   ROM
                           //  
                           if(Port!=INVALID_HANDLE_VALUE)
                           { RW1990_OutputData=RW1990_ReadROM();        //  ROM
                             if(RW1990_OutputData.Success)
                             {  PlaceDataToForm(0,0);   //   ROM   (    )
                                SendMsgToLogForm(108,"");  //    
                             }
                             else SendMsgToLogForm(107,"");  //     
                           }
                           else    SendMsgToLogForm(2,"");    // . COM-  
                           break;
                  case 2:  //------------------------------------------
                           //   AN1990,   READ ROM
                  case 3:  //------------------------------------------
                           //   TM2004,   READ ROM
                           //------------------------------------------
                           //   
                           AN1990_OUTPUT_DATA AN1990_OutputData;        //     AN1990
                           SendMsgToLogForm(154,"");                       //   ROM
                           //  
                           if(Port!=INVALID_HANDLE_VALUE)
                           { AN1990_OutputData=AN1990_ReadROM();        //  ROM
                             if(AN1990_OutputData.Success)
                             {  PlaceDataToForm(0,0);   //   ROM   (    )
                                SendMsgToLogForm(108,"");  //    
                             }
                             else SendMsgToLogForm(107,"");  //     
                           }
                           else    SendMsgToLogForm(2,"");    // . COM-  
                           break;
                  default: break;
                }
                break;
    case 0x2:   //--------------------------------------------------
                //   DS1991,   READ SCRATCHPAD
    case 0x82:  //--------------------------------------------------
                //   DS1425,   READ SCRATCHPAD
                //--------------------------------------------------
                //   
                DS1991_OUTPUT_DATA DS1991_OutputData; //     1W
                SendMsgToLogForm(117,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS1991_OutputData=DS1991_ReadFromScratchpad();      //    Scratchpad
                  if(DS1991_OutputData.Success)          //   
                  { //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(7,4);      //  Area4  RichEdit7
                               break;
                      case 1:  PlaceDataToForm(8,4);      //  Area4  RichEdit8
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  SendMsgToLogForm(107,"");                  //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x4:   //-------------------------------------------------
                //   DS1994,   READ SCRATCHPAD
    case 0x84:  //-------------------------------------------------
                //   DS1427,   READ SCRATCHPAD
                //-------------------------------------------------
                //   
                DS1994_OUTPUT_DATA DS1994_OutputData;   //     1W
                SendMsgToLogForm(117,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS1994_OutputData=DS1994_ReadFromScratchpad();  //    Scratchpad
                  if(DS1994_OutputData.Success)           //   
                  { //    Test
                    TempBuf[0]=DS1994_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    //    E/S
                    TempBuf[0]=DS1994_OutputData.ES;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit6->Text = OutHexBuf;
                    //    TA2
                    TempBuf[0]=DS1994_OutputData.TA2;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit5->Text = OutHexBuf;
                    //    TA1
                    TempBuf[0]=DS1994_OutputData.TA1;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit4->Text = OutHexBuf;
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(5,3);
                               break;
                      case 1:  PlaceDataToForm(6,3);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  else  SendMsgToLogForm(107,"");            //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x5:   //----------------------------------------------
                //   DS2405,   TOGGLE STATE
                //----------------------------------------------
                //   
                DS2405_OUTPUT_DATA DS2405_OutputData; //     DS2405
                SendMsgToLogForm(138,"");    //  
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //   
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2405_OutputData=DS2405_ToggleState();
                  if(DS2405_OutputData.Success)
                  { TempBuf[0]=DS2405_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);      //     ()
                    OutHexBuf[2]=0;                     //    
                    Form1->Edit4->Text = OutHexBuf;
                    SendMsgToLogForm(139,"");              //   
                  }
                  else  SendMsgToLogForm(140,"");  //    
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x6:   //-------------------------------------------------
                //   DS1993,   READ SCRATCHPAD
    case 0x8:   //-------------------------------------------------
                //   DS1992,   READ SCRATCHPAD
    case 0xA:   //-------------------------------------------------
                //   DS1995,   READ SCRATCHPAD
    case 0xC:   //-------------------------------------------------
                //   DS1996,   READ SCRATCHPAD
                //-------------------------------------------------
                //   
                DS1992_OUTPUT_DATA DS1992_OutputData;   //     1W
                SendMsgToLogForm(117,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS1992_OutputData=DS1992_ReadFromScratchpad();        //    Scratchpad
                  if(DS1992_OutputData.Success)           //   
                  { //    Test
                    TempBuf[0]=DS1992_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    //    E/S
                    TempBuf[0]=DS1992_OutputData.ES;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit6->Text = OutHexBuf;
                    //    TA2
                    TempBuf[0]=DS1992_OutputData.TA2;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit5->Text = OutHexBuf;
                    //    TA1
                    TempBuf[0]=DS1992_OutputData.TA1;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit4->Text = OutHexBuf;
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(3,2);
                               break;
                      case 1:  PlaceDataToForm(4,2);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  else SendMsgToLogForm(107,"");       //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x9:   //----------------------------------------------------
                //   DS2502 / DS1982,   READ DATA
                //----------------------------------------------------
                //   
                DS2502_OUTPUT_DATA DS2502_OutputData;   //     1W
                SendMsgToLogForm(124,"");    //   EPROM
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2502_OutputData=DS2502_ReadFromMemory();  //    Scratchpad
                  if(DS2502_OutputData.Success)           //   
                  { //    Test
                    TempBuf[0]=DS2502_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(1,1);
                               break;
                      case 1:  PlaceDataToForm(2,1);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //   
                  }
                  else  SendMsgToLogForm(107,"");            //    
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0xD:   //--------------------------------------------
                //   DS28E05,   READ DATA
                //--------------------------------------------
                //   
                DS28E05_INPUT_DATA DS28E05_InputData;     //     1W
                DS28E05_OUTPUT_DATA DS28E05_OutputData;   //     1W
                SendMsgToLogForm(143,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS28E05_InputData.AreaNumber=1;                       //    1
                  DS28E05_InputData.Size=SelectedChip.Area1Size;        //     1
                  DS28E05_InputData.TA1=SelectedChip.Area1Start;        //     
                  DS28E05_InputData.TA2=SelectedChip.Area1Start>>8;     //     
                  DS28E05_OutputData=DS28E05_ReadFromMemory(DS28E05_InputData); //    
                  if(DS28E05_OutputData.Success)           //   
                  { //    Test
                    TempBuf[0]=DS28E05_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(1,1);
                               break;
                      case 1:  PlaceDataToForm(2,1);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  else SendMsgToLogForm(107,"");       //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x10:  //--------------------------------------------------
                //   DS18S20,   READ SCRATCHPAD
                //--------------------------------------------------
                //   
                DS18S20_OUTPUT_DATA DS18S20_OutputData; //     1W
                SendMsgToLogForm(117,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS18S20_OutputData=DS18S20_ReadFromScratchpad();      //    Scratchpad
                  if(DS18S20_OutputData.Success)          //   
                  { //        
                    DS18S20_DecodeThresholds();
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(1,1);      //  Area1  RichEdit1
                               break;
                      case 1:  PlaceDataToForm(2,1);      //  Area1  RichEdit2
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  SendMsgToLogForm(107,"");                  //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x14:  //--------------------------------------------------
                //   DS2430A,   READ SCRATCHPAD
                //--------------------------------------------------
                //   
                DS2430_OUTPUT_DATA DS2430_OutputData;   //     1W
                SendMsgToLogForm(117,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                {  DS2430_OutputData=DS2430_ReadFromScratchpad();  //    Data Scratchpad
                   if(DS2430_OutputData.Success)           //   
                   { //      
                     switch(Form1->PageControl1->TabIndex)
                     { case 0:  PlaceDataToForm(1,2);
                                break;
                       case 1:  PlaceDataToForm(2,2);
                                break;
                       default: break;
                     }
                     SendMsgToLogForm(108,"");               //    
                   }
                   else SendMsgToLogForm(107,"");            //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x1A:  //--------------------------------------------------
                //   DS1963L,   READ SCRATCHPAD
    case 0x1D:  //--------------------------------------------------
                //   DS2423,   READ SCRATCHPAD
                //--------------------------------------------------
                //   
                DS1963L_OUTPUT_DATA DS1963L_OutputData;   //     1W
                SendMsgToLogForm(117,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS1963L_OutputData=DS1963L_ReadFromScratchpad();        //    Scratchpad
                  if(DS1963L_OutputData.Success)           //   
                  { //    Test
                    TempBuf[0]=DS1963L_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    //    E/S
                    TempBuf[0]=DS1963L_OutputData.ES;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit6->Text = OutHexBuf;
                    //    TA2
                    TempBuf[0]=DS1963L_OutputData.TA2;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit5->Text = OutHexBuf;
                    //    TA1
                    TempBuf[0]=DS1963L_OutputData.TA1;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit4->Text = OutHexBuf;
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(3,2);
                               break;
                      case 1:  PlaceDataToForm(4,2);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  else SendMsgToLogForm(107,"");       //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x23:  //--------------------------------------------------
                //   DS24B33,   READ SCRATCHPAD
                //--------------------------------------------------
                //   
                DS24B33_OUTPUT_DATA DS24B33_OutputData;   //     1W
                SendMsgToLogForm(117,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS24B33_OutputData=DS24B33_ReadFromScratchpad();        //    Scratchpad
                  if(DS24B33_OutputData.Success)           //   
                  { //    Test
                    TempBuf[0]=DS24B33_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    //    E/S
                    TempBuf[0]=DS24B33_OutputData.ES;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit6->Text = OutHexBuf;
                    //    TA2
                    TempBuf[0]=DS24B33_OutputData.TA2;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit5->Text = OutHexBuf;
                    //    TA1
                    TempBuf[0]=DS24B33_OutputData.TA1;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit4->Text = OutHexBuf;
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(3,2);
                               break;
                      case 1:  PlaceDataToForm(4,2);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  else SendMsgToLogForm(107,"");       //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x24:  //--------------------------------------------
                //   DS2415,   READ CLOCK
    case 0x27:  //--------------------------------------------
                //   DS2417,   READ CLOCK
                //--------------------------------------------
                //   
                DS2415_OUTPUT_DATA DS2415_OutputData; //     1W
                SendMsgToLogForm(143,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2415_OutputData=DS2415_ReadClock();      //  
                  if(DS2415_OutputData.Success)          //   
                  { //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(1,1);      //  Area1  RichEdit1
                               break;
                      case 1:  PlaceDataToForm(2,1);      //  Area1  RichEdit2
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  SendMsgToLogForm(107,"");                  //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x22:  //--------------------------------------------------
                //   DS1822,   READ SCRATCHPAD
    case 0x28:  //--------------------------------------------------
                //   DS18B20,   READ SCRATCHPAD
                //--------------------------------------------------
                //   
                DS18B20_OUTPUT_DATA DS18B20_OutputData; //     1W
                SendMsgToLogForm(117,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS18B20_OutputData=DS18B20_ReadFromScratchpad();        //    Scratchpad
                  if(DS18B20_OutputData.Success)          //   
                  { //        
                    DS18B20_DecodeConfigAndThresholds();
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(1,1);      //  Area1  RichEdit1
                               break;
                      case 1:  PlaceDataToForm(2,1);      //  Area1  RichEdit2
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  else SendMsgToLogForm(107,"");             //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x2C:  //-----------------------------------------------
                //   DS2890,   READ POSITION
                //-----------------------------------------------
                //   
                DS2890_OUTPUT_DATA DS2890_OutputData;   //     1W
                SendMsgToLogForm(143,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2890_OutputData=DS2890_ReadPosition();  //  
                  if(DS2890_OutputData.Success)           //   
                  { //    Position
                    TempBuf[0]=DS2890_OutputData.Position;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit4->Text = OutHexBuf;
                    //    Control
                    TempBuf[0]=DS2890_OutputData.Control;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit5->Text = OutHexBuf;
                    SendMsgToLogForm(108,"");                //    
                  }
                  else  SendMsgToLogForm(107,"");            //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x2D:  //-------------------------------------------------
                //   DS2431,   READ SCRATCHPAD
                //-------------------------------------------------
                //   
                DS2431_OUTPUT_DATA DS2431_OutputData;   //     1W
                SendMsgToLogForm(117,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2431_OutputData=DS2431_ReadFromScratchpad();  //    Scratchpad
                  if(DS2431_OutputData.Success)           //   
                  { //    Test
                    TempBuf[0]=DS2431_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    //    E/S
                    TempBuf[0]=DS2431_OutputData.ES;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit6->Text = OutHexBuf;
                    //    TA2
                    TempBuf[0]=DS2431_OutputData.TA2;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit5->Text = OutHexBuf;
                    //    TA1
                    TempBuf[0]=DS2431_OutputData.TA1;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit4->Text = OutHexBuf;
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(5,3);
                               break;
                      case 1:  PlaceDataToForm(6,3);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  else  SendMsgToLogForm(107,"");            //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x33:  //-------------------------------------------------
                //   DS2432,   READ SCRATCHPAD
                //-------------------------------------------------
                //   
                DS2432_OUTPUT_DATA DS2432_OutputData;   //     1W
                SendMsgToLogForm(117,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2432_OutputData=DS2432_ReadFromScratchpad();  //    Scratchpad
                  if(DS2432_OutputData.Success)           //   
                  { //    Test
                    TempBuf[0]=DS2432_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    //    E/S
                    TempBuf[0]=DS2432_OutputData.ES;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit6->Text = OutHexBuf;
                    //    TA2
                    TempBuf[0]=DS2432_OutputData.TA2;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit5->Text = OutHexBuf;
                    //    TA1
                    TempBuf[0]=DS2432_OutputData.TA1;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit4->Text = OutHexBuf;
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(7,4);
                               break;
                      case 1:  PlaceDataToForm(8,4);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  else  SendMsgToLogForm(107,"");            //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x3B:  //-----------------------------------------------------
                //   MAX31826,   Read Scratchpad 1
                //-----------------------------------------------------
                //   
                MAX31826_OUTPUT_DATA MAX31826_OutputData;   //     1W
                MAX31826_INPUT_DATA MAX31826_InputData;     //     1W
                float MAX31826_TempValue;                   // 
                //  
                GetDataToMemory(0,0);                       //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { SendMsgToLogForm(117,"Scratchpad 1");                                   //   
                  MAX31826_InputData.AreaNumber = 3;
                  MAX31826_OutputData = MAX31826_ReadFromScratchpad(MAX31826_InputData);  //    Scratchpad 1
                  if(MAX31826_OutputData.Success)           //   
                  { //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(5,3);
                               break;
                      case 1:  PlaceDataToForm(6,3);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"Scratchpad 1");                //    
                    MAX31826_TempValue = MAX31826_DecodeTemperature();
                    Form1->Edit7->Text = FloatToStrF(MAX31826_TempValue, ffFixed, 7, 7);      //    Edit4
                  }
                  else  SendMsgToLogForm(107,"Scratchpad 1");            //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---   BUTTON6 -------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{ AnsiString TempStr;                           //  
  char *InHexBuf, TempBuf[1], OutHexBuf[3];     //  

  switch(SelectedChip.Family)
  { case 0x0:   //       ROM
                switch(SelectedChip.Modify)
                { case 2:  //-------------------------------------------
                           //   AN1990,   BLOCK ROM
                  case 3:  //-------------------------------------------
                           //   TM2004,   BLOCK ROM
                           //-------------------------------------------
                           //   
                           AN1990_OUTPUT_DATA AN1990_OutputData;        //     AN1990
                           SendMsgToLogForm(157, Form1->Edit3->Text);   //   ROM
                           //  
                           GetDataToMemory(0,0);                        //  ROM   (    )
                           if(Port!=INVALID_HANDLE_VALUE)
                           { AN1990_OutputData=AN1990_BlockROM();       //   ROM
                             if(AN1990_OutputData.Success)      SendMsgToLogForm(159,"");  //   
                             else                               SendMsgToLogForm(158,"");  //    
                           }
                           else    SendMsgToLogForm(2,"");    // . COM-  
                           break;
                  case 1:  //   RW1990
                  default: break;
                }
                break;
    case 0x2:   //------------------------------------------------------------
                //   DS1991,   COPY SCRATCHPAD TO MEMORY
    case 0x82:  //------------------------------------------------------------
                //   DS1425,   COPY SCRATCHPAD TO MEMORY
                //------------------------------------------------------------
                //   
                DS1991_OUTPUT_DATA DS1991_OutputData; //     DS1991
                DS1991_INPUT_DATA DS1991_InputData;   //     DS1991
                unsigned char DS1991_Done;            //   
                SendMsgToLogForm(118,"");    //     EEPROM
                //  
                DS1991_Done=0;                        //      
                GetDataToMemory(0,0);                   //  ROM   (    )
                for(unsigned int DS1991_i=0; DS1991_i<3; DS1991_i++)
                { DS1991_InputData.AreaNumber=0;        //  ,     
                  switch(DS1991_i)
                  { case 0: if(Form1->CheckBox1->Checked==true) DS1991_InputData.AreaNumber=1;  // ,     subkey1
                            break;
                    case 1: if(Form1->CheckBox2->Checked==true) DS1991_InputData.AreaNumber=2;  // ,     subkey2
                            break;
                    case 2: if(Form1->CheckBox3->Checked==true) DS1991_InputData.AreaNumber=3;  // ,     subkey3
                            break;
                    default: break;
                  }
                  if(DS1991_InputData.AreaNumber!=0)    //   
                  { if(Port!=INVALID_HANDLE_VALUE)
                    { DS1991_OutputData=DS1991_CopyScratchpadToMemory(DS1991_InputData);  //   Copy to Scratchpad
                      if(DS1991_OutputData.Success)         SendMsgToLogForm(110,"");        //     EEPROM  
                      else                                  SendMsgToLogForm(109,"");        //       EEPROM  
                    }
                    else    SendMsgToLogForm(2,"");    // . COM-  
                    DS1991_Done+=1;           //    
                  }
                }
                if(DS1991_Done==0)      SendMsgToLogForm(133,"");  //     ,     
                break;
    case 0x4:   //-----------------------------------------------------------
                //   DS1994,   COPY SCRATCHPAD TO MEMORY
    case 0x84:  //-----------------------------------------------------------
                //   DS1427,   COPY SCRATCHPAD TO MEMORY
                //-----------------------------------------------------------
                //   
                DS1994_OUTPUT_DATA DS1994_OutputData;   //     DS1994
                DS1994_INPUT_DATA DS1994_InputData;     //     DS1994
                SendMsgToLogForm(118,"");    //     EEPROM
                //  
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1994_InputData.TA1=TempBuf[0];        //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1994_InputData.TA2=TempBuf[0];        //   TA2
                TempStr=LowerCase(Form1->Edit6->Text);  //  ES  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1994_InputData.ES=TempBuf[0];         //   ES
                //   Copy to Scratchpad
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)  DS1994_OutputData=DS1994_CopyScratchpadToMemory(DS1994_InputData);
                else    //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                //   -     
                if(Form1->CheckBox4->Checked==true)
                { DS1994_InputData.ES |= 0x80;  //   AA (7-)
                  //    
                  if(Port!=INVALID_HANDLE_VALUE)  DS1994_OutputData=DS1994_CopyScratchpadToMemory(DS1994_InputData);
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //    
                  if(Port!=INVALID_HANDLE_VALUE)  DS1994_OutputData=DS1994_CopyScratchpadToMemory(DS1994_InputData);
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                }
                if(DS1994_OutputData.Success) SendMsgToLogForm(110,"");    //     EEPROM  
                else                          SendMsgToLogForm(109,"");    //       EEPROM  
                break;
    case 0x6:   //-----------------------------------------------------------
                //   DS1993,   COPY SCRATCHPAD TO MEMORY
    case 0x8:   //-----------------------------------------------------------
                //   DS1992,   COPY SCRATCHPAD TO MEMORY
    case 0xA:   //-----------------------------------------------------------
                //   DS1995,   COPY SCRATCHPAD TO MEMORY
    case 0xC:   //-----------------------------------------------------------
                //   DS1996,   COPY SCRATCHPAD TO MEMORY
                //-----------------------------------------------------------
                //   
                DS1992_INPUT_DATA DS1992_InputData;   //     DS1992
                DS1992_OUTPUT_DATA DS1992_OutputData; //     DS1992
                SendMsgToLogForm(118,"");    //     EEPROM
                //  
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1992_InputData.TA1=TempBuf[0];        //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1992_InputData.TA2=TempBuf[0];        //   TA2
                TempStr=LowerCase(Form1->Edit6->Text);  //  ES  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1992_InputData.ES=TempBuf[0];         //   ES
                //   Copy to Scratchpad    (Test)  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                {  DS1992_OutputData=DS1992_CopyScratchpadToMemory(DS1992_InputData);
                   if(DS1992_OutputData.Success)
                   { //  Test  
                     TempBuf[0]=DS1992_OutputData.Test;
                     BinToHex(TempBuf,OutHexBuf,1);        //     ()
                     OutHexBuf[2]=0;                       //    
                     Form1->Edit7->Text = OutHexBuf;
                     SendMsgToLogForm(110,"");    //     EEPROM  
                   }
                   else    SendMsgToLogForm(109,"");    //       EEPROM  
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x9:   //--------------------------------------------------------------
                //   DS2502 / DS1982,   READ DATA WITH CRC8
                //--------------------------------------------------------------
                //   
                DS2502_OUTPUT_DATA DS2502_OutputData;   //     1W
                SendMsgToLogForm(124,"");    //   EPROM
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2502_OutputData=DS2502_ReadFromMemoryCRC8();  //    EPROM    CRC8
                  if(DS2502_OutputData.Success)           //   
                  { //    Test
                    TempBuf[0]=DS2502_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(1,1);
                               break;
                      case 1:  PlaceDataToForm(2,1);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //   
                  }
                  else  SendMsgToLogForm(107,"");            //    
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0xD:   //------------------------------------------------------------
                //   DS28E05,   WRITE ADMINISTRATIVE DATA
                //------------------------------------------------------------
                //   
                DS28E05_INPUT_DATA DS28E05_InputData;     //     DS28E05
                DS28E05_OUTPUT_DATA DS28E05_OutputData;   //     DS28E05
                SendMsgToLogForm(121,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                //          
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);        //    RichEdit3  Administrative Data
                           break;
                  case 1:  GetDataToMemory(4,2);        //    RichEdit4  Administrative Data
                           break;
                  default: break;
                }
                //      1-Wire    (Test)  
                //       
                DS28E05_InputData.AreaNumber=2;                                 //        
                //  7 
                //    -   
                if(Port!=INVALID_HANDLE_VALUE)
                { //     
                  DS28E05_InputData.PB=7<<4;                                  //   PB
                  DS28E05_OutputData=DS28E05_WriteToMemory(DS28E05_InputData);
                }
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                //   -  
                if(DS28E05_OutputData.Success==false)   //    
                { SendMsgToLogForm(105,"");    //  
                  return;
                }
                else            //    -    Test
                { //    Test
                  TempBuf[0]=DS28E05_OutputData.Test;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit7->Text = OutHexBuf;
                }
                SendMsgToLogForm(106,"");    //   
                break;
    case 0x10:  //------------------------------------------------------------
                //   DS18S20,   COPY SCRATCHPAD TO MEMORY
                //------------------------------------------------------------
                //   
                DS18S20_OUTPUT_DATA DS18S20_OutputData; //     DS18B20
                SendMsgToLogForm(118,"");    //     EEPROM
                //  
                //   Copy to Scratchpad
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS18S20_OutputData=DS18S20_CopyScratchpadToMemory();
                  if(DS18S20_OutputData.Success)        SendMsgToLogForm(110,"");   //     EEPROM  
                  else                                  SendMsgToLogForm(109,"");    //       EEPROM  
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x14:  //------------------------------------------------------------
                //   DS2430A,   COPY SCRATCHPAD TO MEMORY
                //------------------------------------------------------------
                //   
                DS2430_OUTPUT_DATA DS2430_OutputData;   //     DS2430A
                SendMsgToLogForm(118,"");    //     EEPROM
                //  
                //   Copy to Scratchpad
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2430_OutputData=DS2430_CopyScratchpadToMemory();
                  if(DS2430_OutputData.Success)         SendMsgToLogForm(110,"");   //     EEPROM  
                  else                                  SendMsgToLogForm(109,"");    //       EEPROM  
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x1A:  //------------------------------------------------------------
                //   DS1963L,   COPY SCRATCHPAD TO MEMORY
    case 0x1D:  //------------------------------------------------------------
                //   DS2423,   COPY SCRATCHPAD TO MEMORY
                //------------------------------------------------------------
                //   
                DS1963L_INPUT_DATA DS1963L_InputData;   //     DS1963L
                DS1963L_OUTPUT_DATA DS1963L_OutputData; //     DS1963L
                SendMsgToLogForm(118,"");    //     EEPROM
                //  
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1963L_InputData.TA1=TempBuf[0];        //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1963L_InputData.TA2=TempBuf[0];        //   TA2
                TempStr=LowerCase(Form1->Edit6->Text);  //  ES  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS1963L_InputData.ES=TempBuf[0];         //   ES
                //   Copy to Scratchpad    (Test)  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                {  DS1963L_OutputData=DS1963L_CopyScratchpadToMemory(DS1963L_InputData);
                   if(DS1963L_OutputData.Success)
                   { //  Test  
                     TempBuf[0]=DS1963L_OutputData.Test;
                     BinToHex(TempBuf,OutHexBuf,1);        //     ()
                     OutHexBuf[2]=0;                       //    
                     Form1->Edit7->Text = OutHexBuf;
                     SendMsgToLogForm(110,"");    //     EEPROM  
                   }
                   else    SendMsgToLogForm(109,"");    //       EEPROM  
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x23:  //------------------------------------------------------------
                //   DS24B33,   COPY SCRATCHPAD TO MEMORY
                //------------------------------------------------------------
                //   
                DS24B33_INPUT_DATA DS24B33_InputData;   //     DS24B33
                DS24B33_OUTPUT_DATA DS24B33_OutputData; //     DS24B33
                SendMsgToLogForm(118,"");    //     EEPROM
                //  
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS24B33_InputData.TA1=TempBuf[0];        //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS24B33_InputData.TA2=TempBuf[0];        //   TA2
                TempStr=LowerCase(Form1->Edit6->Text);  //  ES  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS24B33_InputData.ES=TempBuf[0];         //   ES
                //   Copy to Scratchpad    (Test)  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                {  DS24B33_OutputData=DS24B33_CopyScratchpadToMemory(DS24B33_InputData);
                   if(DS24B33_OutputData.Success)
                   { //  Test  
                     TempBuf[0]=DS24B33_OutputData.Test;
                     BinToHex(TempBuf,OutHexBuf,1);        //     ()
                     OutHexBuf[2]=0;                       //    
                     Form1->Edit7->Text = OutHexBuf;
                     SendMsgToLogForm(110,"");    //     EEPROM  
                   }
                   else    SendMsgToLogForm(109,"");    //       EEPROM  
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x22:  //------------------------------------------------------------
                //   DS1822,   COPY SCRATCHPAD TO MEMORY
    case 0x28:  //------------------------------------------------------------
                //   DS18B20,   COPY SCRATCHPAD TO MEMORY
                //------------------------------------------------------------
                //   
                DS18B20_OUTPUT_DATA DS18B20_OutputData; //     DS18B20
                SendMsgToLogForm(118,"");    //     EEPROM
                //  
                //   Copy to Scratchpad
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS18B20_OutputData=DS18B20_CopyScratchpadToMemory();
                  if(DS18B20_OutputData.Success)        SendMsgToLogForm(110,"");   //     EEPROM  
                  else                                  SendMsgToLogForm(109,"");    //       EEPROM  
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x2C:  //-------------------------------------------
                //   DS2890,   INCREMENT
                //-------------------------------------------
                //   
                DS2890_OUTPUT_DATA DS2890_OutputData;   //     1W
                SendMsgToLogForm(149,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2890_OutputData=DS2890_Increment();   //  
                  if(DS2890_OutputData.Success)           //   
                  { //    Position
                    TempBuf[0]=DS2890_OutputData.Position;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit4->Text = OutHexBuf;
                    SendMsgToLogForm(151,"");                //   
                  }
                  else  SendMsgToLogForm(150,"");            //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x2D:  //-----------------------------------------------------------
                //   DS2431,   COPY SCRATCHPAD TO MEMORY
                //-----------------------------------------------------------
                //   
                DS2431_OUTPUT_DATA DS2431_OutputData;   //     DS2431
                DS2431_INPUT_DATA DS2431_InputData;     //     DS2431
                SendMsgToLogForm(118,"");    //     EEPROM
                //  
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2431_InputData.TA1=TempBuf[0];        //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2431_InputData.TA2=TempBuf[0];        //   TA2
                TempStr=LowerCase(Form1->Edit6->Text);  //  ES  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2431_InputData.ES=TempBuf[0];         //   ES
                //   Copy to Scratchpad    (Test)  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2431_OutputData=DS2431_CopyScratchpadToMemory(DS2431_InputData);
                  if(DS2431_OutputData.Success)
                  { TempBuf[0]=DS2431_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    SendMsgToLogForm(110,"");    //     EEPROM  
                  }
                  else    SendMsgToLogForm(109,"");    //       EEPROM  
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x33:  //-----------------------------------------------------------
                //   DS2432,   COPY SCRATCHPAD TO MEMORY
                //-----------------------------------------------------------
                //   
                DS2432_OUTPUT_DATA DS2432_OutputData;   //     DS2432
                DS2432_INPUT_DATA DS2432_InputData;     //     DS2432
                SendMsgToLogForm(118,"");    //     EEPROM
                //  
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2432_InputData.TA1=TempBuf[0];        //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2432_InputData.TA2=TempBuf[0];        //   TA2
                TempStr=LowerCase(Form1->Edit6->Text);  //  ES  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2432_InputData.ES=TempBuf[0];         //   ES
                //   Copy to Scratchpad    (Test)  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //        
                //  ,   ,  Data  Register    ,
                //   Secret   ,         
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);        //    RichEdit1  Data
                           GetDataToMemory(3,2);        //    RichEdit3  Secret
                           GetDataToMemory(5,3);        //    RichEdit5  Register
                           GetDataToMemory(7,4);        //    RichEdit7  Scratchpad
                           break;
                  case 1:  GetDataToMemory(2,1);        //    RichEdit2  Data
                           GetDataToMemory(4,2);        //    RichEdit4  Secret
                           GetDataToMemory(6,3);        //    RichEdit6  Register
                           GetDataToMemory(8,4);        //    RichEdit8  Scratchpad
                           break;
                  default: break;
                }
                //  
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2432_OutputData=DS2432_CopyScratchpadToMemory(DS2432_InputData);
                  if(DS2432_OutputData.Success)
                  { TempBuf[0]=DS2432_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    SendMsgToLogForm(110,"");    //     EEPROM  
                  }
                  else    SendMsgToLogForm(109,"");    //       EEPROM  
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x3B:  //-----------------------------------------------------
                //   MAX31826,   READ POWER SUPPLY
                //-----------------------------------------------------
                //   
                MAX31826_OUTPUT_DATA MAX31826_OutputData; //     MAX31826
                SendMsgToLogForm(126,"");           //    
                //  
                GetDataToMemory(0,0);                        //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)  MAX31826_OutputData=MAX31826_ReadPowerSupply();
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(MAX31826_OutputData.Success)  //   
                { //  
                  if(MAX31826_OutputData.Test==0)               SendMsgToLogForm(112,"");    //  
                  else if(MAX31826_OutputData.Test==0xFF)       SendMsgToLogForm(113,"");    //  
                  else                                          SendMsgToLogForm(114,"");    //     
                }
                else    SendMsgToLogForm(107,"");    //  
                break;
    case 0x5:   //   DS2405
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---   BUTTON7 -------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{ AnsiString TempStr;                           //  
  char *InHexBuf, TempBuf[1], OutHexBuf[3];     //  
  unsigned int TempAddr;                        //   

  switch(SelectedChip.Family)
  { case 0x0:   //       ROM
                switch(SelectedChip.Modify)
                { case 1:  //   RW1990
                  case 2:  //   AN1990
                  case 3:  //   TM2004
                  default: break;
                }
                break;
    case 0x2:   //------------------------------------------------------
                //   DS1991,   WRITE DATA TO SUBKEY
    case 0x82:  //------------------------------------------------------
                //   DS1425,   WRITE DATA TO SUBKEY
                //------------------------------------------------------
                //   
                DS1991_OUTPUT_DATA DS1991_OutputData; //     DS1991
                DS1991_INPUT_DATA DS1991_InputData;   //     DS1991
                unsigned char DS1991_Done;            //   
                SendMsgToLogForm(134,"");    //   
                //  
                DS1991_Done=0;                        //      
                GetDataToMemory(0,0);                   //  ROM   (    )
                for(unsigned int DS1991_i=0; DS1991_i<3; DS1991_i++)
                { DS1991_InputData.AreaNumber=0;        //  ,     
                  if(DS1991_i==0)
                  { if(Form1->CheckBox1->Checked==true)         // ,     subkey1
                    { DS1991_InputData.AreaNumber=1;            // 
                      switch(Form1->PageControl1->TabIndex)
                      { case 0:  GetDataToMemory(1,1);          //    RichEdit1  Area1
                                 break;
                        case 1:  GetDataToMemory(2,1);          //    RichEdit2  Area1
                                 break;
                        default: break;
                      }
                    }
                  }
                  else if(DS1991_i==1)
                  { if(Form1->CheckBox1->Checked==true)         // ,     subkey2
                    { DS1991_InputData.AreaNumber=2;            // 
                      switch(Form1->PageControl1->TabIndex)
                      { case 0:  GetDataToMemory(3,2);          //    RichEdit3  Area2
                                 break;
                        case 1:  GetDataToMemory(4,2);          //    RichEdit4  Area2
                                 break;
                        default: break;
                      }
                    }
                  }
                  else
                  { if(Form1->CheckBox1->Checked==true)         // ,     subkey3
                    { DS1991_InputData.AreaNumber=3;            // 
                      switch(Form1->PageControl1->TabIndex)
                      { case 0:  GetDataToMemory(5,3);          //    RichEdit5  Area3
                                 break;
                        case 1:  GetDataToMemory(6,3);          //    RichEdit6  Area3
                                 break;
                        default: break;
                      }
                    }
                  }
                  if(DS1991_InputData.AreaNumber!=0)    //   
                  { if(Port!=INVALID_HANDLE_VALUE)
                    { DS1991_OutputData=DS1991_WriteSubKey(DS1991_InputData);   //   Write SubKey
                      if(DS1991_OutputData.Success)         SendMsgToLogForm(106,"");        //    
                      else                                  SendMsgToLogForm(105,"");        //      
                    }
                    else    SendMsgToLogForm(2,"");    // . COM-  
                    DS1991_Done+=1;           //    
                  }
                }
                if(DS1991_Done==0)      SendMsgToLogForm(133,"");  //     ,     
                break;
    case 0x4:   //---------------------------------------------------
                //   DS1994,   WRITE DATA MEMORY
    case 0x84:  //---------------------------------------------------
                //   DS1427,   WRITE DATA MEMORY
                //---------------------------------------------------
                //   
                DS1994_INPUT_DATA DS1994_InputData;       //     DS1994
                DS1994_OUTPUT_DATA DS1994_OutputData;     //     DS1994
                SendMsgToLogForm(121,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                //          
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);        //    RichEdit1  Data
                           break;
                  case 1:  GetDataToMemory(2,1);        //    RichEdit2  Data
                           break;
                  default: break;
                }
                //      1-Wire      (Test)  
                //     ,   ,    
                for(unsigned int i=0; i<SelectedChip.Area1Size/SelectedChip.Area3Size; i++)
                { //       
                  DS1994_InputData.Size=SelectedChip.Area3Size;                         //     
                  DS1994_InputData.AreaNumber=1;                                        //        
                  //    -       
                  if(Port!=INVALID_HANDLE_VALUE)
                  { TempAddr=SelectedChip.Area1Start+i*SelectedChip.Area3Size;          //       
                    DS1994_InputData.TA1=TempAddr;                                      //   TA1
                    DS1994_InputData.TA2=TempAddr>>8;                                   //   TA2
                    DS1994_OutputData=DS1994_WriteToScratchpad(DS1994_InputData);
                  }
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //    -  
                  if(Port!=INVALID_HANDLE_VALUE)  DS1994_OutputData=DS1994_ReadFromScratchpad();        //    Scratchpad
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //          
                  //   -  
                  if(DS1994_OutputData.Success==false)
                  {     SendMsgToLogForm(105,"");    //  
                        return;
                  }
                  //     -    
                  DS1994_InputData.TA1=DS1994_OutputData.TA1;
                  DS1994_InputData.TA2=DS1994_OutputData.TA2;
                  DS1994_InputData.ES=DS1994_OutputData.ES;
                  if(Port!=INVALID_HANDLE_VALUE)  DS1994_OutputData=DS1994_CopyScratchpadToMemory(DS1994_InputData);
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  if(DS1994_OutputData.Success==false)
                  {     SendMsgToLogForm(105,"");    //  
                        return;
                  }
                }
                SendMsgToLogForm(106,"");    //   
                break;
    case 0x6:   //---------------------------------------------------
                //   DS1993,   WRITE DATA MEMORY
    case 0x8:   //---------------------------------------------------
                //   DS1992,   WRITE DATA MEMORY
    case 0xA:   //---------------------------------------------------
                //   DS1995,   WRITE DATA MEMORY
    case 0xC:   //---------------------------------------------------
                //   DS1996,   WRITE DATA MEMORY
                //---------------------------------------------------
                //   
                DS1992_INPUT_DATA DS1992_InputData;           //     DS1992
                DS1992_OUTPUT_DATA DS1992_OutputData;         //     DS1992
                SendMsgToLogForm(121,"");    //    EEPROM
                //  
                GetDataToMemory(0,0);                           //  ROM   (    )
                //          
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);                //    RichEdit1  Data
                           break;
                  case 1:  GetDataToMemory(2,1);                //    RichEdit2  Data
                           break;
                  default: break;
                }
                //      1-Wire      (Test)  
                //     ,   ,    
                for(unsigned int i=0; i<SelectedChip.Area1Size/SelectedChip.Area2Size; i++)
                { //       
                  DS1992_InputData.Size=SelectedChip.Area2Size;                //     
                  DS1992_InputData.AreaNumber=1;                               //        
                  //    -       
                  if(Port!=INVALID_HANDLE_VALUE)
                  { TempAddr=SelectedChip.Area1Start+i*SelectedChip.Area2Size;  //       
                    DS1992_InputData.TA1=TempAddr;                             //   TA1
                    DS1992_InputData.TA2=TempAddr>>8;                          //   TA2
                    DS1992_OutputData=DS1992_WriteToScratchpad(DS1992_InputData);
                  }
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //    -  
                  if(Port!=INVALID_HANDLE_VALUE)  DS1992_OutputData=DS1992_ReadFromScratchpad();      //    Scratchpad
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //          
                  //   -  
                  if(DS1992_OutputData.Success==false)
                  {     SendMsgToLogForm(105,"");    //   
                        return;
                  }
                  //     -    
                  DS1992_InputData.TA1=DS1992_OutputData.TA1;
                  DS1992_InputData.TA2=DS1992_OutputData.TA2;
                  DS1992_InputData.ES=DS1992_OutputData.ES;
                  if(Port!=INVALID_HANDLE_VALUE)  DS1992_OutputData=DS1992_CopyScratchpadToMemory(DS1992_InputData);
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  if(DS1992_OutputData.Success)
                  { TempBuf[0]=DS1992_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);          //     ()
                    OutHexBuf[2]=0;                         //    
                    Form1->Edit7->Text = OutHexBuf;         //  Test  
                  }
                  else
                  {     SendMsgToLogForm(105,"");    //   
                        return;
                  }
                }
                SendMsgToLogForm(106,"");    //   
                break;
    case 0x9:   //-------------------------------------------------------
                //   DS2502 / DS1982,   WRITE STATUS
                //-------------------------------------------------------
                //   
                DS2502_INPUT_DATA DS2502_InputData;     //     DS2502
                DS2502_OUTPUT_DATA DS2502_OutputData;   //     DS2502
                SendMsgToLogForm(121,"");    //    EPROM
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                DS2502_InputData.TA1=0;                 //   TA1
                DS2502_InputData.TA2=0;                 //   TA2
                //           ( DS2502 STATUS   Area2)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);        //    RichEdit3  Status
                           break;
                  case 1:  GetDataToMemory(4,2);        //    RichEdit4  Status
                           break;
                  default: break;
                }
                //    1-Wire
                DS2502_InputData.Size=SelectedChip.Area2Size;   //    Status Bytes
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2502_OutputData=DS2502_WriteToStatus(DS2502_InputData);
                  if(DS2502_OutputData.Success) SendMsgToLogForm(106,"");                //  Status Bytes  
                  else                          SendMsgToLogForm(105,"");            //  Status Bytes   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0xD:   //-----------------------------------------------------------
                //   DS28E05,   READ ADMINISTRATIVE DATA
                //-----------------------------------------------------------
                //   
                DS28E05_INPUT_DATA DS28E05_InputData;     //     1W
                DS28E05_OUTPUT_DATA DS28E05_OutputData;   //     1W
                SendMsgToLogForm(143,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS28E05_InputData.AreaNumber=2;                       //    2
                  DS28E05_InputData.Size=SelectedChip.Area2Size;        //     2
                  DS28E05_InputData.TA1=SelectedChip.Area2Start;        //     
                  DS28E05_InputData.TA2=SelectedChip.Area2Start>>8;     //     
                  DS28E05_OutputData=DS28E05_ReadFromMemory(DS28E05_InputData); //    
                  if(DS28E05_OutputData.Success)           //   
                  { //    Test
                    TempBuf[0]=DS28E05_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(3,2);
                               break;
                      case 1:  PlaceDataToForm(4,2);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //    
                  }
                  else SendMsgToLogForm(107,"");       //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x10:  //--------------------------------------------------------
                //   DS18S20,   START CYCLING POLLING
                //--------------------------------------------------------
                //   
                DS18S20_OUTPUT_DATA DS18S20_OutputData;         //     DS18S20
                SendMsgToLogForm(119,"");    //   
                /* fixed */
                GetDataToMemory(0,0);                        //  ROM   (    )
                //   
                if(Port!=INVALID_HANDLE_VALUE)
                { DS18S20_OutputData=DS18S20_ReadPowerSupply();   //   
                  //     -  
                  if((DS18S20_OutputData.Success)&&(DS18S20_OutputData.Test==0xFF))     //     
                  { Form1->Timer1->Enabled=true;                  //  
                    SendMsgToLogForm(103,"");        //    
                  }
                  else    SendMsgToLogForm(111,""); //     - ,        
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x14:  //-------------------------------------------------------------
                //   DS2430A,   WRITE APPLICATION REGISTER
                //-------------------------------------------------------------
                //   
                DS2430_OUTPUT_DATA DS2430_OutputData;   //     DS2430
                SendMsgToLogForm(120,"");    //    Application Register
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //           ( DS2430 Application Register   Area3)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,3);        //    RichEdit3  Application Register
                           break;
                  case 1:  GetDataToMemory(4,3);        //    RichEdit4  Application Register
                           break;
                  default: break;
                }
                //     Area3  1-Wire
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2430_OutputData=DS2430_WriteToApplRegister();
                  if(DS2430_OutputData.Success)         SendMsgToLogForm(106,"");    //   appl.register  
                  else                                  SendMsgToLogForm(105,"");    //   appl.register   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x1A:  //----------------------------------------------------
                //   DS1963L,   WRITE DATA MEMORY
    case 0x1D:  //----------------------------------------------------
                //   DS2423,   WRITE DATA MEMORY
                //----------------------------------------------------
                //   
                DS1963L_INPUT_DATA DS1963L_InputData;           //     DS1963L
                DS1963L_OUTPUT_DATA DS1963L_OutputData;         //     DS1963L
                SendMsgToLogForm(121,"");    //    EEPROM
                //  
                GetDataToMemory(0,0);                           //  ROM   (    )
                //          
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);                //    RichEdit1  Data
                           break;
                  case 1:  GetDataToMemory(2,1);                //    RichEdit2  Data
                           break;
                  default: break;
                }
                //      1-Wire      (Test)  
                //     ,   ,    
                for(unsigned int i=0; i<SelectedChip.Area1Size/SelectedChip.Area2Size; i++)
                { //       
                  DS1963L_InputData.Size=SelectedChip.Area2Size;                //     
                  DS1963L_InputData.AreaNumber=1;                               //        
                  //    -       
                  if(Port!=INVALID_HANDLE_VALUE)
                  { TempAddr=SelectedChip.Area1Start+i*SelectedChip.Area2Size;  //       
                    DS1963L_InputData.TA1=TempAddr;                             //   TA1
                    DS1963L_InputData.TA2=TempAddr>>8;                          //   TA2
                    DS1963L_OutputData=DS1963L_WriteToScratchpad(DS1963L_InputData);
                  }
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //    -  
                  if(Port!=INVALID_HANDLE_VALUE)  DS1963L_OutputData=DS1963L_ReadFromScratchpad();      //    Scratchpad
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //          
                  //   -      AA  PF
                  TempBuf[0]=(DS1963L_OutputData.ES>>5)&0x5;                    //   AA  PF (  ???)
                  if((DS1963L_OutputData.Success==false) || (TempBuf[0]!=0))
                  {     SendMsgToLogForm(105,"");    //   
                        return;
                  }
                  //     -    
                  DS1963L_InputData.TA1=DS1963L_OutputData.TA1;
                  DS1963L_InputData.TA2=DS1963L_OutputData.TA2;
                  DS1963L_InputData.ES=DS1963L_OutputData.ES;
                  if(Port!=INVALID_HANDLE_VALUE)  DS1963L_OutputData=DS1963L_CopyScratchpadToMemory(DS1963L_InputData);
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  if(DS1963L_OutputData.Success)
                  { TempBuf[0]=DS1963L_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);          //     ()
                    OutHexBuf[2]=0;                         //    
                    Form1->Edit7->Text = OutHexBuf;         //  Test  
                  }
                  else
                  {     SendMsgToLogForm(105,"");    //   
                        return;
                  }
                }
                SendMsgToLogForm(106,"");    //   
                break;
    case 0x23:  //----------------------------------------------------
                //   DS24B33,   WRITE DATA MEMORY
                //----------------------------------------------------
                //   
                DS24B33_INPUT_DATA DS24B33_InputData;           //     DS24B33
                DS24B33_OUTPUT_DATA DS24B33_OutputData;         //     DS24B33
                SendMsgToLogForm(121,"");    //    EEPROM
                //  
                GetDataToMemory(0,0);                           //  ROM   (    )
                //          
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);                //    RichEdit1  Data
                           break;
                  case 1:  GetDataToMemory(2,1);                //    RichEdit2  Data
                           break;
                  default: break;
                }
                //      1-Wire      (Test)  
                //     ,   ,    
                for(unsigned int i=0; i<SelectedChip.Area1Size/SelectedChip.Area2Size; i++)
                { //       
                  DS24B33_InputData.Size=SelectedChip.Area2Size;                //     
                  DS24B33_InputData.AreaNumber=1;                               //        
                  //    -       
                  if(Port!=INVALID_HANDLE_VALUE)
                  { TempAddr=SelectedChip.Area1Start+i*SelectedChip.Area2Size;  //       
                    DS24B33_InputData.TA1=TempAddr;                             //   TA1
                    DS24B33_InputData.TA2=TempAddr>>8;                          //   TA2
                    DS24B33_OutputData=DS24B33_WriteToScratchpad(DS24B33_InputData);
                  }
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //    -  
                  if(Port!=INVALID_HANDLE_VALUE)  DS24B33_OutputData=DS24B33_ReadFromScratchpad();      //    Scratchpad
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //          
                  //   -      AA  PF
                  TempBuf[0]=(DS24B33_OutputData.ES>>5)&0x5;                            //   AA  PF
                  if((DS24B33_OutputData.Success==false) || (TempBuf[0]!=0))
                  {     SendMsgToLogForm(105,"");    //   
                        return;
                  }
                  //     -    
                  DS24B33_InputData.TA1=DS24B33_OutputData.TA1;
                  DS24B33_InputData.TA2=DS24B33_OutputData.TA2;
                  DS24B33_InputData.ES=DS24B33_OutputData.ES;
                  if(Port!=INVALID_HANDLE_VALUE)  DS24B33_OutputData=DS24B33_CopyScratchpadToMemory(DS24B33_InputData);
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  if(DS24B33_OutputData.Success)
                  { TempBuf[0]=DS24B33_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);          //     ()
                    OutHexBuf[2]=0;                         //    
                    Form1->Edit7->Text = OutHexBuf;         //  Test  
                  }
                  else
                  {     SendMsgToLogForm(105,"");    //   
                        return;
                  }
                }
                SendMsgToLogForm(106,"");    //   
                break;
    case 0x22:  //--------------------------------------------------------
                //   DS1822,   START CYCLING POLLING
    case 0x28:  //--------------------------------------------------------
                //   DS18B20,   START CYCLING POLLING
                //--------------------------------------------------------
                //   
                DS18B20_OUTPUT_DATA DS18B20_OutputData;         //     DS18B20
                SendMsgToLogForm(119,"");    //   
                /* fixed */
                GetDataToMemory(0,0);                        //  ROM   (    )
                //   
                if(Port!=INVALID_HANDLE_VALUE)
                { DS18B20_OutputData=DS18B20_ReadPowerSupply();   //   
                  //     -  
                  if((DS18B20_OutputData.Success)&&(DS18B20_OutputData.Test==0xFF))             //     
                  { Form1->Timer1->Enabled=true;                //  
                    SendMsgToLogForm(103,"");        //    
                  }
                  else    SendMsgToLogForm(111,""); //     - ,        
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x2C:  //-------------------------------------------
                //   DS2890,   DECREMENT
                //-------------------------------------------
                //   
                DS2890_OUTPUT_DATA DS2890_OutputData;   //     1W
                SendMsgToLogForm(149,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2890_OutputData=DS2890_Decrement();   //  
                  if(DS2890_OutputData.Success)           //   
                  { //    Position
                    TempBuf[0]=DS2890_OutputData.Position;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit4->Text = OutHexBuf;
                    SendMsgToLogForm(151,"");                //   
                  }
                  else  SendMsgToLogForm(150,"");            //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x2D:  //-----------------------------------------------------
                //   DS2431,   WRITE REGISTER PAGE
                //-----------------------------------------------------
                //   
                DS2431_INPUT_DATA DS2431_InputData;     //     DS2431
                DS2431_OUTPUT_DATA DS2431_OutputData;   //     DS2431
                SendMsgToLogForm(122,"");    //    EEPROM  
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //          
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);        //    RichEdit3  Registers
                           break;
                  case 1:  GetDataToMemory(4,2);        //    RichEdit4  Registers
                           break;
                  default: break;
                }
                //      1-Wire      (Test)  
                //     ,   ,    
                for(unsigned int i=0; i<SelectedChip.Area2Size/SelectedChip.Area3Size; i++)
                { //       
                  DS2431_InputData.Size=SelectedChip.Area3Size;                 //     
                  DS2431_InputData.AreaNumber=2;                                //        
                  //    -       
                  if(Port!=INVALID_HANDLE_VALUE)
                  { TempAddr=SelectedChip.Area2Start+i*SelectedChip.Area3Size;  //       
                    DS2431_InputData.TA1=TempAddr;                              //   TA1
                    DS2431_InputData.TA2=TempAddr>>8;                           //   TA2
                    DS2431_OutputData=DS2431_WriteToScratchpad(DS2431_InputData);
                  }
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //    -  
                  if(Port!=INVALID_HANDLE_VALUE)  DS2431_OutputData=DS2431_ReadFromScratchpad();        //    Scratchpad
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //   -      AA  PF
                  TempBuf[0]=(DS2431_OutputData.ES>>5)&0x5;                     //   AA  PF
                  if((DS2431_OutputData.Success==false) || (TempBuf[0]!=0))
                  {     SendMsgToLogForm(105,"");    //   
                        return;
                  }
                  //          
                  //     -    
                  DS2431_InputData.TA1=DS2431_OutputData.TA1;
                  DS2431_InputData.TA2=DS2431_OutputData.TA2;
                  DS2431_InputData.ES=DS2431_OutputData.ES;
                  if(Port!=INVALID_HANDLE_VALUE)  DS2431_OutputData=DS2431_CopyScratchpadToMemory(DS2431_InputData);
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  if(DS2431_OutputData.Success)
                  { TempBuf[0]=DS2431_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);          //     ()
                    OutHexBuf[2]=0;                         //    
                    Form1->Edit7->Text = OutHexBuf;         //  Test  
                  }
                  else
                  {     SendMsgToLogForm(105,"");    //   
                        return;
                  }
                }
                SendMsgToLogForm(106,"");    //   
                break;
    case 0x33:  //-----------------------------------------------------
                //   DS2432,   WRITE REGISTER PAGE
                //-----------------------------------------------------
                //   
                DS2432_INPUT_DATA DS2432_InputData;     //     DS2432
                DS2432_OUTPUT_DATA DS2432_OutputData;   //     DS2432
                unsigned char   RegisterTemp[8];        //    Register Page
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //    Secret (Data   MAC (  Register Page)  )
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);        //    RichEdit3  Secret
                           break;
                  case 1:  GetDataToMemory(4,2);        //    RichEdit4  Secret
                           break;
                  default: break;
                }
                //         Register Page
                DS2432_InputData.TA1=SelectedChip.Area3Start;   //  TA1
                DS2432_InputData.TA2=SelectedChip.Area3Start>>8;//  TA2
                DS2432_InputData.AreaNumber=3;                  //      
                DS2432_InputData.Size=SelectedChip.Area3Size;   //    
                if(Port!=INVALID_HANDLE_VALUE)  DS2432_OutputData=DS2432_ReadFromMemory(DS2432_InputData);      //   
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS2432_OutputData.Success)                   //   
                { //      
                  for(unsigned char i=0; i<8; i++)
                  {     RegisterTemp[i]=SelectedChip.Area3[i];
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else
                {       SendMsgToLogForm(107,"");    //     
                        return;
                }
                //     scratchpad
                SendMsgToLogForm(116,"");    //    
                DS2432_InputData.TA1=SelectedChip.Area3Start;   //   TA1
                DS2432_InputData.TA2=0;                 //   TA2
                //           ( DS2432 Register Page   Area3)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(5,3);        //    RichEdit5  Scratchpad
                           break;
                  case 1:  GetDataToMemory(6,3);        //    RichEdit6  Scratchpad
                           break;
                  default: break;
                }
                //    1-Wire    (Test)  
                DS2432_InputData.AreaNumber=3;                  // Register Page -  Area3
                DS2432_InputData.Size=SelectedChip.Area3Size;   //  register page   
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2432_OutputData=DS2432_WriteToScratchpad(DS2432_InputData);
                  if(DS2432_OutputData.Success)
                  { TempBuf[0]=DS2432_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);      //     ()
                    OutHexBuf[2]=0;                     //    
                    Form1->Edit7->Text = OutHexBuf;
                    SendMsgToLogForm(106,"");                //   scratchpad  
                  }
                  else
                  {  SendMsgToLogForm(105,"");            //   scratchpad   
                     return;
                  }
                }
                else
                {    SendMsgToLogForm(2,"");    // . COM-  
                     return;
                }
                //   ,     (TA1, TA2, ES)
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2432_OutputData=DS2432_ReadFromScratchpad();  //    Scratchpad
                  if(DS2432_OutputData.Success)           //   
                  { DS2432_InputData.ES=DS2432_OutputData.ES;      //  E/S
                    DS2432_InputData.TA2=DS2432_OutputData.TA2;    //  TA2
                    DS2432_InputData.TA1=DS2432_OutputData.TA1;    //  TA1
                    SendMsgToLogForm(108,"");                //    
                  }
                  else
                  {  SendMsgToLogForm(107,"");            //     
                     return;
                  }
                }
                else
                {    SendMsgToLogForm(2,"");    // . COM-  
                     return;
                }
                //    Register Page (   MAC)
                for(unsigned char i=0; i<8; i++)
                {     SelectedChip.Area3[i]=RegisterTemp[i];
                }
                //     
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2432_OutputData=DS2432_CopyScratchpadToMemory(DS2432_InputData);
                  if(DS2432_OutputData.Success)
                  { TempBuf[0]=DS2432_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    SendMsgToLogForm(110,"");    //     EEPROM  
                  }
                  else    SendMsgToLogForm(109,"");    //       EEPROM  
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x3B:  //------------------------------------------------------
                //   MAX31826,   WRITE SCRATCHPAD 2
                //------------------------------------------------------
                //   
                MAX31826_INPUT_DATA MAX31826_InputData;     //     MAX31826
                MAX31826_OUTPUT_DATA MAX31826_OutputData;   //     MAX31826
                SendMsgToLogForm(116,"");    //    
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                TempStr=LowerCase(Form1->Edit4->Text);  //  SA  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                MAX31826_InputData.SA=TempBuf[0];       //   SA
                //           ( MAX31826 Scratchpad 2   Area2)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);        //    RichEdit3  Scratchpad
                           break;
                  case 1:  GetDataToMemory(4,2);        //    RichEdit4  Scratchpad
                           break;
                  default: break;
                }
                //    1-Wire
                MAX31826_InputData.AreaNumber=2;                  //  2 -  Area2
                MAX31826_InputData.Size=SelectedChip.Area2Size;   //    
                if(Port!=INVALID_HANDLE_VALUE)
                { MAX31826_OutputData=MAX31826_WriteToScratchpad(MAX31826_InputData);
                  if(MAX31826_OutputData.Success) SendMsgToLogForm(106,"");  //   scratchpad  
                  else                          SendMsgToLogForm(105,"");  //   scratchpad   
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x5:   //   DS2405
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---   BUTTON8 -------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
{ AnsiString TempStr;                           //  
  char *InHexBuf, TempBuf[1], OutHexBuf[3];     //  

  switch(SelectedChip.Family)
  { case 0x0:   //       ROM
                switch(SelectedChip.Modify)
                { case 1:  //   RW1990
                  case 2:  //   AN1990
                  case 3:  //   TM2004
                  default: break;
                }
                break;
    case 0x2:   //-------------------------------------------------------
                //   DS1991,   READ DATA FROM SUBKEY
    case 0x82:  //-------------------------------------------------------
                //   DS1425,   READ DATA FROM SUBKEY
                //-------------------------------------------------------
                //   
                DS1991_OUTPUT_DATA DS1991_OutputData; //     DS1991
                DS1991_INPUT_DATA DS1991_InputData;   //     DS1991
                unsigned char DS1991_Done;            //   
                SendMsgToLogForm(135,"");    //   
                //  
                DS1991_Done=0;                        //      
                GetDataToMemory(0,0);                   //  ROM   (    )
                for(unsigned int DS1991_i=0; DS1991_i<3; DS1991_i++)
                { DS1991_InputData.AreaNumber=0;        //  ,     
                  switch(DS1991_i)
                  { case 0: if(Form1->CheckBox1->Checked==true) DS1991_InputData.AreaNumber=1;  // ,    subkey1
                            break;
                    case 1: if(Form1->CheckBox2->Checked==true) DS1991_InputData.AreaNumber=2;  // ,    subkey2
                            break;
                    case 2: if(Form1->CheckBox3->Checked==true) DS1991_InputData.AreaNumber=3;  // ,    subkey3
                            break;
                    default: break;
                  }
                  if(DS1991_InputData.AreaNumber!=0)    //   
                  { if(Port!=INVALID_HANDLE_VALUE)
                    { DS1991_OutputData=DS1991_ReadSubKey(DS1991_InputData);    //   Read SubKey
                      if(DS1991_OutputData.Success)
                      { SendMsgToLogForm(108,"");          //    
                        //     RichEdit
                        if(DS1991_i==0)                 //    1
                        {  switch(Form1->PageControl1->TabIndex)
                           { case 0:  PlaceDataToForm(1,1);      //  Area1  RichEdit1
                                      break;
                             case 1:  PlaceDataToForm(2,1);      //  Area1  RichEdit2
                                      break;
                             default: break;
                           }
                        }
                        else if(DS1991_i==1)            //    2
                        {  switch(Form1->PageControl1->TabIndex)
                           { case 0:  PlaceDataToForm(3,2);      //  Area2  RichEdit3
                                      break;
                             case 1:  PlaceDataToForm(4,2);      //  Area2  RichEdit4
                                      break;
                             default: break;
                           }
                        }
                        else                            //    3
                        {  switch(Form1->PageControl1->TabIndex)
                           { case 0:  PlaceDataToForm(5,3);      //  Area3  RichEdit5
                                      break;
                             case 1:  PlaceDataToForm(6,3);      //  Area3  RichEdit6
                                      break;
                             default: break;
                           }
                        }
                      }
                      else                                  SendMsgToLogForm(107,"");        //      
                    }
                    else    SendMsgToLogForm(2,"");    // . COM-  
                    DS1991_Done+=1;           //    
                  }
                }
                if(DS1991_Done==0)      SendMsgToLogForm(133,"");  //     ,     
                break;
    case 0x4:   //--------------------------------------------------------
                //   DS1994,   WRITE TIMEKEEPING REGS
    case 0x84:  //--------------------------------------------------------
                //   DS1427,   WRITE TIMEKEEPING REGS
                //--------------------------------------------------------
                //   
                DS1994_INPUT_DATA DS1994_InputData;       //     DS1994
                DS1994_OUTPUT_DATA DS1994_OutputData;     //     DS1994
                unsigned int TempAddr;                    //   
                unsigned char DS1994_SelectData;          //      
                bool DS1994_NeedMore;                     // ,     

                SendMsgToLogForm(144,"");                    //     timekeeping registers
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                //          
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);        //    RichEdit3  Timekeeping Regs
                           break;
                  case 1:  GetDataToMemory(4,2);        //    RichEdit4  Timekeeping Regs
                           break;
                  default: break;
                }
                DS1994_InputData.AreaNumber=2;          //        Timekeeping Registers
                DS1994_NeedMore=false;                  // -    
                //   ,    
                DS1994_SelectData=0;
                if(Form1->CheckBox1->Checked==true)     DS1994_SelectData += 1; //  
                if(Form1->CheckBox2->Checked==true)     DS1994_SelectData += 2; //  
                if(Form1->CheckBox3->Checked==true)     DS1994_SelectData += 4; //  
                //      1-Wire  
                switch(DS1994_SelectData)
                { case 1:       //   Status
                                DS1994_InputData.Size=1;                //    1 
                                TempAddr=SelectedChip.Area2Start;       //       
                                break;
                  case 2:       //   Control
                                DS1994_InputData.Size=1;                //    1 
                                TempAddr=SelectedChip.Area2Start+1;     //       
                                break;
                  case 3:       //  Status + Control
                                DS1994_InputData.Size=2;                //    2 
                                TempAddr=SelectedChip.Area2Start;       //       
                                break;
                  case 4:       //  ,  Status  Control
                                DS1994_InputData.Size=SelectedChip.Area2Size-2; //    32-2 
                                TempAddr=SelectedChip.Area2Start+2;     //       
                                break;
                  case 5:       //   Status,      Control
                                DS1994_InputData.Size=1;                //    1 
                                TempAddr=SelectedChip.Area2Start;       //       
                                DS1994_NeedMore=true;                   //    
                                break;
                  case 6:       //  ,  Status
                                DS1994_InputData.Size=SelectedChip.Area2Size-1; //    32-1 
                                TempAddr=SelectedChip.Area2Start+1;     //       
                                break;
                  case 7:       //  
                                DS1994_InputData.Size=SelectedChip.Area2Size; //    32 
                                TempAddr=SelectedChip.Area2Start;     //       
                                break;
                  default:      //  ,         
                                SendMsgToLogForm(145,"");    //    /
                                return;
                }
                DS1994_Write_Timekeeping_Regs_Label1:
                //    -       
                if(Port!=INVALID_HANDLE_VALUE)
                { DS1994_InputData.TA1=TempAddr;                                      //   TA1
                  DS1994_InputData.TA2=TempAddr>>8;                                   //   TA2
                  DS1994_OutputData=DS1994_WriteToScratchpad(DS1994_InputData);
                }
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                //    -  
                if(Port!=INVALID_HANDLE_VALUE)  DS1994_OutputData=DS1994_ReadFromScratchpad();        //    Scratchpad
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                //          
                //   -  
                if(DS1994_OutputData.Success==false)
                {     SendMsgToLogForm(105,"");    //  
                      return;
                }
                //     -    
                DS1994_InputData.TA1=DS1994_OutputData.TA1;
                DS1994_InputData.TA2=DS1994_OutputData.TA2;
                DS1994_InputData.ES=DS1994_OutputData.ES;
                if(Port!=INVALID_HANDLE_VALUE)  DS1994_OutputData=DS1994_CopyScratchpadToMemory(DS1994_InputData);
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                //   -     
                if(Form1->CheckBox4->Checked==true)
                { DS1994_InputData.ES |= 0x80;  //   AA (7-)
                  //    
                  if(Port!=INVALID_HANDLE_VALUE)  DS1994_OutputData=DS1994_CopyScratchpadToMemory(DS1994_InputData);
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //    
                  if(Port!=INVALID_HANDLE_VALUE)  DS1994_OutputData=DS1994_CopyScratchpadToMemory(DS1994_InputData);
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                }
                if(DS1994_OutputData.Success==false)
                {     SendMsgToLogForm(105,"");    //  
                      return;
                }
                if(DS1994_NeedMore==true)       //      Control
                { DS1994_NeedMore=false;
                  DS1994_InputData.Size=SelectedChip.Area2Size-2; //    32-2 
                  TempAddr=SelectedChip.Area2Start+2;     //       
                  goto DS1994_Write_Timekeeping_Regs_Label1;
                }
                SendMsgToLogForm(106,"");    //   
                break;
    case 0x6:   //--------------------------------------------------
                //   DS1993,   READ DATA MEMORY
    case 0x8:   //--------------------------------------------------
                //   DS1992,   READ DATA MEMORY
    case 0xA:   //--------------------------------------------------
                //   DS1995,   READ DATA MEMORY
    case 0xC:   //--------------------------------------------------
                //   DS1996,   READ DATA MEMORY
                //--------------------------------------------------
                //   
                DS1992_OUTPUT_DATA DS1992_OutputData;           //     DS1992
                DS1992_INPUT_DATA DS1992_InputData;             //     DS1992
                SendMsgToLogForm(124,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                DS1992_InputData.TA1=SelectedChip.Area1Start;          //  TA1
                DS1992_InputData.TA2=SelectedChip.Area1Start>>8;       //  TA2
                if(Port!=INVALID_HANDLE_VALUE)  DS1992_OutputData=DS1992_ReadFromMemory(DS1992_InputData); //   
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS1992_OutputData.Success)                          //   
                { //    Test
                  TempBuf[0]=DS1992_OutputData.Test;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit7->Text = OutHexBuf;
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(1,1);
                             break;
                    case 1:  PlaceDataToForm(2,1);
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //     
                break;
    case 0x9:   //------------------------------------------------------
                //   DS2502 / DS1982,   READ STATUS
                //------------------------------------------------------
                //   
                DS2502_OUTPUT_DATA DS2502_OutputData;   //     1W
                SendMsgToLogForm(127,"");    //   Status
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2502_OutputData=DS2502_ReadFromStatus();  //    Status
                  if(DS2502_OutputData.Success)           //   
                  { //    Test
                    TempBuf[0]=DS2502_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(3,2);
                               break;
                      case 1:  PlaceDataToForm(4,2);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"");                //   
                  }
                  else  SendMsgToLogForm(107,"");            //    
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x10:  //-------------------------------------------------------
                //   DS18S20,   STOP CYCLING POLLING
                //-------------------------------------------------------
                SendMsgToLogForm(123,"");           //   
                Form1->Timer1->Enabled=false;    //  
                SendMsgToLogForm(104,"");           //  
                break;
    case 0x14:  //----------------------------------------------
                //   DS2430,   WRITE EEPROM
                //----------------------------------------------
                //   
                DS2430_INPUT_DATA DS2430_InputData;     //     DS2430
                DS2430_OUTPUT_DATA DS2430_OutputData;   //     DS2430
                SendMsgToLogForm(121,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //          
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);        //    RichEdit1  Data
                           break;
                  case 1:  GetDataToMemory(2,1);        //    RichEdit2  Data
                           break;
                  default: break;
                }
                //     Area1  1-Wire  Scratchpad
                DS2430_InputData.AreaNumber=1;
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2430_OutputData=DS2430_WriteToScratchpad(DS2430_InputData);
                }
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                //           
                //     EEPROM
                if(Port!=INVALID_HANDLE_VALUE)  DS2430_OutputData=DS2430_CopyScratchpadToMemory();
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS2430_OutputData.Success)   SendMsgToLogForm(106,"");    //   
                else                            SendMsgToLogForm(105,"");    //   
                break;
    case 0x1A:  //---------------------------------------------------
                //   DS1963L,   READ DATA MEMORY
    case 0x1D:  //---------------------------------------------------
                //   DS2423,   READ DATA MEMORY
                //---------------------------------------------------
                //   
                DS1963L_OUTPUT_DATA DS1963L_OutputData;           //     DS1963L
                DS1963L_INPUT_DATA DS1963L_InputData;             //     DS1963L
                SendMsgToLogForm(124,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                DS1963L_InputData.TA1=SelectedChip.Area1Start;          //  TA1
                DS1963L_InputData.TA2=SelectedChip.Area1Start>>8;       //  TA2
                if(Port!=INVALID_HANDLE_VALUE)  DS1963L_OutputData=DS1963L_ReadFromMemory(DS1963L_InputData); //   
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS1963L_OutputData.Success)                          //   
                { //    Test
                  TempBuf[0]=DS1963L_OutputData.Test;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit7->Text = OutHexBuf;
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(1,1);
                             break;
                    case 1:  PlaceDataToForm(2,1);
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //     
                break;
    case 0x23:  //---------------------------------------------------
                //   DS24B33,   READ DATA MEMORY
                //---------------------------------------------------
                //   
                DS24B33_OUTPUT_DATA DS24B33_OutputData;           //     DS24B33
                DS24B33_INPUT_DATA DS24B33_InputData;             //     DS24B33
                SendMsgToLogForm(124,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                DS24B33_InputData.TA1=SelectedChip.Area1Start;          //  TA1
                DS24B33_InputData.TA2=SelectedChip.Area1Start>>8;       //  TA2
                if(Port!=INVALID_HANDLE_VALUE)  DS24B33_OutputData=DS24B33_ReadFromMemory(DS24B33_InputData); //   
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS24B33_OutputData.Success)                          //   
                { //    Test
                  TempBuf[0]=DS24B33_OutputData.Test;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit7->Text = OutHexBuf;
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(1,1);
                             break;
                    case 1:  PlaceDataToForm(2,1);
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //     
                break;
    case 0x22:  //-------------------------------------------------------
                //   DS1822,   STOP CYCLING POLLING
    case 0x28:  //-------------------------------------------------------
                //   DS18B20,   STOP CYCLING POLLING
                //-------------------------------------------------------
                SendMsgToLogForm(123,"");           //   
                Form1->Timer1->Enabled=false;   //  
                SendMsgToLogForm(104,"");           //  
                break;
    case 0x2C:  //--------------------------------------------------------
                //   DS2890,   WRITE CONTROL REGISTER
                //--------------------------------------------------------
                //   
                DS2890_INPUT_DATA DS2890_InputData;     //     DS2890
                DS2890_OUTPUT_DATA DS2890_OutputData;   //     DS2890
                SendMsgToLogForm(142,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                TempStr=LowerCase(Form1->Edit5->Text);  //  Control  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2890_InputData.Control=TempBuf[0];    //   Control
                //   WriteControl    (Test)  
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2890_OutputData=DS2890_WriteControl(DS2890_InputData);
                  if(DS2890_OutputData.Success==true && DS2890_OutputData.Test==0)
                        SendMsgToLogForm(106,"");  //   
                  else  SendMsgToLogForm(105,"");  //    
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x2D:  //----------------------------------------------------
                //   DS2431,   READ REGISTER PAGE
                //----------------------------------------------------
                //   
                DS2431_OUTPUT_DATA DS2431_OutputData;           //     DS2431
                DS2431_INPUT_DATA DS2431_InputData;             //     DS2431
                SendMsgToLogForm(125,"");           //    EEPROM  
                //  
                GetDataToMemory(0,0);                 //  ROM   (    )
                DS2431_InputData.TA1=SelectedChip.Area2Start;   //  TA1
                DS2431_InputData.TA2=SelectedChip.Area2Start>>8;//  TA2
                DS2431_InputData.AreaNumber=2;                  //      
                DS2431_InputData.Size=SelectedChip.Area2Size;   //    
                if(Port!=INVALID_HANDLE_VALUE)  DS2431_OutputData=DS2431_ReadFromMemory(DS2431_InputData);      //   
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS2431_OutputData.Success)                   //   
                { //    Test
                  TempBuf[0]=DS2431_OutputData.Test;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit7->Text = OutHexBuf;
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(3,2);
                             break;
                    case 1:  PlaceDataToForm(4,2);
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //     
                break;
    case 0x33:  //----------------------------------------------------
                //   DS2432,   READ REGISTER PAGE
                //----------------------------------------------------
                //   
                DS2432_OUTPUT_DATA DS2432_OutputData;           //     DS2432
                DS2432_INPUT_DATA DS2432_InputData;             //     DS2432
                SendMsgToLogForm(125,"");           //    EEPROM  
                //  
                GetDataToMemory(0,0);                 //  ROM   (    )
                DS2432_InputData.TA1=SelectedChip.Area3Start;   //  TA1
                DS2432_InputData.TA2=SelectedChip.Area3Start>>8;//  TA2
                DS2432_InputData.AreaNumber=3;                  //      
                DS2432_InputData.Size=SelectedChip.Area3Size;   //    
                if(Port!=INVALID_HANDLE_VALUE)  DS2432_OutputData=DS2432_ReadFromMemory(DS2432_InputData);      //   
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS2432_OutputData.Success)                   //   
                { //    Test
                  TempBuf[0]=DS2432_OutputData.Test;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit7->Text = OutHexBuf;
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(5,3);
                             break;
                    case 1:  PlaceDataToForm(6,3);
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //     
                break;
    case 0x3B:  //-----------------------------------------------------
                //   MAX31826,   Read Scratchpad 2
                //-----------------------------------------------------
                //   
                MAX31826_OUTPUT_DATA MAX31826_OutputData;   //     1W
                MAX31826_INPUT_DATA MAX31826_InputData;     //     1W
                //  
                GetDataToMemory(0,0);                       //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { SendMsgToLogForm(117,"Scratchpad 2");                //   
                  TempStr=LowerCase(Form1->Edit4->Text);  //  SA  
                  InHexBuf=TempStr.c_str();               //       (  )
                  HexToBin(InHexBuf,TempBuf,1);           //     ()
                  MAX31826_InputData.SA=TempBuf[0];       //   SA
                  MAX31826_InputData.AreaNumber = 2;
                  MAX31826_OutputData = MAX31826_ReadFromScratchpad(MAX31826_InputData);  //    Scratchpad 2
                  if(MAX31826_OutputData.Success)           //   
                  { //      
                    switch(Form1->PageControl1->TabIndex)
                    { case 0:  PlaceDataToForm(3,2);
                               break;
                      case 1:  PlaceDataToForm(4,2);
                               break;
                      default: break;
                    }
                    SendMsgToLogForm(108,"Scratchpad 2");                //    
                  }
                  else  SendMsgToLogForm(107,"Scratchpad 2");            //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x5:   //   DS2405
    case 0xD:   //   DS28E05
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---   BUTTON9 -------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{ AnsiString TempStr;                           //  
  char *InHexBuf, TempBuf[1], OutHexBuf[3];     //  
  unsigned int TempAddr;                        //   

  switch(SelectedChip.Family)
  { case 0x0:   //       ROM
                switch(SelectedChip.Modify)
                { case 1:  //   RW1990
                  case 2:  //   AN1990
                  case 3:  //   TM2004
                  default: break;
                }
                break;
    case 0x2:   //----------------------------------------------------------
                //   DS1991,   WRITE PASSWORD TO SUBKEY
    case 0x82:   //----------------------------------------------------------
                //   DS1425,   WRITE PASSWORD TO SUBKEY
                //----------------------------------------------------------
                //   
                DS1991_OUTPUT_DATA DS1991_OutputData; //     DS1991
                DS1991_INPUT_DATA DS1991_InputData;   //     DS1991
                unsigned char DS1991_Done;            //   
                SendMsgToLogForm(136,"");    //    
                //  
                DS1991_Done=0;                        //      
                GetDataToMemory(0,0);                   //  ROM   (    )
                for(unsigned int DS1991_i=0; DS1991_i<3; DS1991_i++)
                { DS1991_InputData.AreaNumber=0;        //  ,     
                  if(DS1991_i==0)
                  { if(Form1->CheckBox1->Checked==true)         // ,     subkey1
                    { DS1991_InputData.AreaNumber=1;            // 
                      switch(Form1->PageControl1->TabIndex)
                      { case 0:  GetDataToMemory(1,1);          //    RichEdit1  Area1
                                 break;
                        case 1:  GetDataToMemory(2,1);          //    RichEdit2  Area1
                                 break;
                        default: break;
                      }
                    }
                  }
                  else if(DS1991_i==1)
                  { if(Form1->CheckBox1->Checked==true)         // ,     subkey2
                    { DS1991_InputData.AreaNumber=2;            // 
                      switch(Form1->PageControl1->TabIndex)
                      { case 0:  GetDataToMemory(3,2);          //    RichEdit3  Area2
                                 break;
                        case 1:  GetDataToMemory(4,2);          //    RichEdit4  Area2
                                 break;
                        default: break;
                      }
                    }
                  }
                  else
                  { if(Form1->CheckBox1->Checked==true)         // ,     subkey3
                    { DS1991_InputData.AreaNumber=3;            // 
                      switch(Form1->PageControl1->TabIndex)
                      { case 0:  GetDataToMemory(5,3);          //    RichEdit5  Area3
                                 break;
                        case 1:  GetDataToMemory(6,3);          //    RichEdit6  Area3
                                 break;
                        default: break;
                      }
                    }
                  }
                  if(DS1991_InputData.AreaNumber!=0)    //   
                  { if(Port!=INVALID_HANDLE_VALUE)
                    { DS1991_OutputData=DS1991_WritePassword(DS1991_InputData);   //   Write Password
                      if(DS1991_OutputData.Success)         SendMsgToLogForm(106,"");        //    
                      else                                  SendMsgToLogForm(105,"");        //      
                    }
                    else    SendMsgToLogForm(2,"");    // . COM-  
                    DS1991_Done+=1;           //    
                  }
                }
                if(DS1991_Done==0)      SendMsgToLogForm(133,"");  //     ,     
                break;
    case 0x4:   //--------------------------------------------------
                //   DS1994,   READ DATA MEMORY
    case 0x84:  //--------------------------------------------------
                //   DS1427,   READ DATA MEMORY
                //--------------------------------------------------
                //   
                DS1994_OUTPUT_DATA DS1994_OutputData;           //     DS1994
                DS1994_INPUT_DATA DS1994_InputData;             //     DS1994
                SendMsgToLogForm(124,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                DS1994_InputData.TA1=SelectedChip.Area1Start;          //  TA1
                DS1994_InputData.TA2=SelectedChip.Area1Start>>8;       //  TA2
                DS1994_InputData.AreaNumber=1;                         //      
                DS1994_InputData.Size=SelectedChip.Area1Size;          //    
                if(Port!=INVALID_HANDLE_VALUE)  DS1994_OutputData=DS1994_ReadFromMemory(DS1994_InputData); //   
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS1994_OutputData.Success)                          //   
                { //    Test
                  TempBuf[0]=DS1994_OutputData.Test;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit7->Text = OutHexBuf;
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(1,1);      //  Area1  RichEdit1
                             break;
                    case 1:  PlaceDataToForm(2,1);      //  Area1  RichEdit2
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //  
                break;
    case 0x9:   //-----------------------------------------------------------
                //   DS2502 / DS1982,   WRITE SCRATCHPAD
                //-----------------------------------------------------------
                //   
                DS2502_INPUT_DATA DS2502_InputData;     //     DS2502
                DS2502_OUTPUT_DATA DS2502_OutputData;   //     DS2502
                SendMsgToLogForm(121,"");    //    EPROM
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                TempStr=LowerCase(Form1->Edit4->Text);  //  TA1  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2502_InputData.TA1=TempBuf[0];        //   TA1
                TempStr=LowerCase(Form1->Edit5->Text);  //  TA2  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                DS2502_InputData.TA2=TempBuf[0];        //   TA2
                //    Scratchpad      Area3
                TempStr=LowerCase(Form1->Edit6->Text);  //  Scratchpad  
                InHexBuf=TempStr.c_str();               //       (  )
                HexToBin(InHexBuf,TempBuf,1);           //     ()
                SelectedChip.Area3[0]=TempBuf[0];       //   Scratchpad
                //    1-Wire
                DS2502_InputData.AreaNumber=3;                  //   scratchpad    Area3
                DS2502_InputData.Size=1;                        //  Scratchpad 1 
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2502_OutputData=DS2502_WriteToMemory(DS2502_InputData);
                  if(DS2502_OutputData.Success) SendMsgToLogForm(106,"");            //    
                  else                          SendMsgToLogForm(105,"");            //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x10:  //----------------------------------------------------
                //   DS18S20,   READ POWER SUPPLY
                //----------------------------------------------------
                //   
                DS18S20_OUTPUT_DATA DS18S20_OutputData; //     DS18S20
                SendMsgToLogForm(126,"");           //    
                /* fixed */
                GetDataToMemory(0,0);                        //  ROM   (    )
                //  
                if(Port!=INVALID_HANDLE_VALUE)  DS18S20_OutputData=DS18S20_ReadPowerSupply();
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS18S20_OutputData.Success)  //   
                { //  
                  if(DS18S20_OutputData.Test==0)                SendMsgToLogForm(112,"");    //  
                  else if(DS18S20_OutputData.Test==0xFF)        SendMsgToLogForm(113,"");    //  
                  else                                          SendMsgToLogForm(114,"");    //     
                }
                else    SendMsgToLogForm(107,"");    //  
                break;
    case 0x14:  //-------------------------------------------------------
                //   DS2430A,   READ STATUS REGISTER
                //-------------------------------------------------------
                //   
                DS2430_OUTPUT_DATA DS2430_OutputData;   //     DS2430A
                SendMsgToLogForm(127,"");           //    
                //  
                //   ReadFromStatusRegister    (Test)  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)  DS2430_OutputData=DS2430_ReadFromStatusRegister();
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS2430_OutputData.Success)
                { TempBuf[0]=DS2430_OutputData.Status;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit4->Text = OutHexBuf;
                  SendMsgToLogForm(108,"");    //   
                }
                else    SendMsgToLogForm(107,"");    //  
                break;
    case 0x1A:  //----------------------------------------------------------------
                //   DS1963L,   READ DATA MEMORY AND COUNTERS
    case 0x1D:  //----------------------------------------------------------------
                //   DS2423,   READ DATA MEMORY AND COUNTERS
                //----------------------------------------------------------------
                //   
                DS1963L_OUTPUT_DATA DS1963L_OutputData;           //     DS1963L
                DS1963L_INPUT_DATA DS1963L_InputData;             //     DS1963L
                SendMsgToLogForm(124,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                DS1963L_InputData.TA1=SelectedChip.Area1Start;          //  TA1
                DS1963L_InputData.TA2=SelectedChip.Area1Start>>8;       //  TA2
                if(Port!=INVALID_HANDLE_VALUE)  DS1963L_OutputData=DS1963L_ReadFromMemoryC(DS1963L_InputData); //   
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS1963L_OutputData.Success)                          //   
                { //    Test
                  TempBuf[0]=DS1963L_OutputData.Test;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit7->Text = OutHexBuf;
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(1,1);      //    RichEdit1  Area1
                             PlaceDataToForm(5,3);      //    RichEdit5  Area3
                             break;
                    case 1:  PlaceDataToForm(2,1);      //    RichEdit2  Area1
                             PlaceDataToForm(6,3);      //    RichEdit6  Area3
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //     
                break;
    case 0x22:  //----------------------------------------------------
                //   DS1822,   READ POWER SUPPLY
    case 0x28:  //----------------------------------------------------
                //   DS18B20,   READ POWER SUPPLY
                //----------------------------------------------------
                //   
                DS18B20_OUTPUT_DATA DS18B20_OutputData; //     DS18B20
                SendMsgToLogForm(126,"");           //    
                /* fixed */
                GetDataToMemory(0,0);                        //  ROM   (    )
                //  
                if(Port!=INVALID_HANDLE_VALUE)  DS18B20_OutputData=DS18B20_ReadPowerSupply();
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS18B20_OutputData.Success)  //   
                { //  
                  if(DS18B20_OutputData.Test==0)                SendMsgToLogForm(112,"");    //  
                  else if(DS18B20_OutputData.Test==0xFF)        SendMsgToLogForm(113,"");    //  
                  else                                          SendMsgToLogForm(114,"");    //     
                }
                else    SendMsgToLogForm(107,"");    //  
                break;
    case 0x2C:  //-------------------------------------------------------
                //   DS2890,   READ CONTROL REGISTER
                //-------------------------------------------------------
                //   
                DS2890_OUTPUT_DATA DS2890_OutputData;   //     1W
                SendMsgToLogForm(143,"");    //   
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2890_OutputData=DS2890_ReadControl(); //  
                  if(DS2890_OutputData.Success)           //   
                  { //    Feature
                    TempBuf[0]=DS2890_OutputData.Feature;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit6->Text = OutHexBuf;
                    //    Control
                    TempBuf[0]=DS2890_OutputData.Control;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit5->Text = OutHexBuf;
                    SendMsgToLogForm(108,"");                //    
                  }
                  else  SendMsgToLogForm(107,"");            //     
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x2D:  //---------------------------------------------------
                //   DS2431,   WRITE DATA MEMORY
                //---------------------------------------------------
                //   
                DS2431_INPUT_DATA DS2431_InputData;       //     DS2431
                DS2431_OUTPUT_DATA DS2431_OutputData;     //     DS2431
                SendMsgToLogForm(121,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                //          
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);        //    RichEdit1  Data
                           break;
                  case 1:  GetDataToMemory(2,1);        //    RichEdit2  Data
                           break;
                  default: break;
                }
                //      1-Wire      (Test)  
                //     ,   ,    
                for(unsigned int i=0; i<SelectedChip.Area1Size/SelectedChip.Area3Size; i++)
                { //       
                  DS2431_InputData.Size=SelectedChip.Area3Size;                         //     
                  DS2431_InputData.AreaNumber=1;                                        //        
                  //    -       
                  if(Port!=INVALID_HANDLE_VALUE)
                  { TempAddr=SelectedChip.Area1Start+i*SelectedChip.Area3Size;          //       
                    DS2431_InputData.TA1=TempAddr;                                      //   TA1
                    DS2431_InputData.TA2=TempAddr>>8;                                   //   TA2
                    DS2431_OutputData=DS2431_WriteToScratchpad(DS2431_InputData);
                  }
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //    -  
                  if(Port!=INVALID_HANDLE_VALUE)  DS2431_OutputData=DS2431_ReadFromScratchpad();        //    Scratchpad
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //          
                  //   -      AA  PF
                  TempBuf[0]=(DS2431_OutputData.ES>>5)&0x5;                             //   AA  PF
                  if((DS2431_OutputData.Success==false) || (TempBuf[0]!=0))
                  {     SendMsgToLogForm(105,"");    //  
                        return;
                  }
                  //     -    
                  DS2431_InputData.TA1=DS2431_OutputData.TA1;
                  DS2431_InputData.TA2=DS2431_OutputData.TA2;
                  DS2431_InputData.ES=DS2431_OutputData.ES;
                  if(Port!=INVALID_HANDLE_VALUE)  DS2431_OutputData=DS2431_CopyScratchpadToMemory(DS2431_InputData);
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  if(DS2431_OutputData.Success)
                  { TempBuf[0]=DS2431_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);          //     ()
                    OutHexBuf[2]=0;                         //    
                    Form1->Edit7->Text = OutHexBuf;         //  Test  
                  }
                  else
                  {     SendMsgToLogForm(105,"");    //  
                        return;
                  }
                }
                SendMsgToLogForm(106,"");    //   
                break;
    case 0x33:  //---------------------------------------------------
                //   DS2432,   WRITE DATA MEMORY
                //---------------------------------------------------
                //   
                DS2432_INPUT_DATA DS2432_InputData;     //     DS2432
                DS2432_OUTPUT_DATA DS2432_OutputData;   //     DS2432
                unsigned char   DataTemp[128];          //    Data
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //    Secret (  MAC)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);        //    RichEdit3  Secret
                           break;
                  case 1:  GetDataToMemory(4,2);        //    RichEdit4  Secret
                           break;
                  default: break;
                }
                //    0  16 (   128 ,    8,   128/8=16 )
                for(unsigned int i=0; i<(SelectedChip.Area1Size/SelectedChip.Area4Size); i++)
                { //          Data
                  DS2432_InputData.TA1=SelectedChip.Area1Start;   //  TA1
                  DS2432_InputData.TA2=SelectedChip.Area1Start>>8;//  TA2
                  DS2432_InputData.AreaNumber=1;                  //      
                  DS2432_InputData.Size=SelectedChip.Area1Size;   //    
                  if(Port!=INVALID_HANDLE_VALUE)  DS2432_OutputData=DS2432_ReadFromMemory(DS2432_InputData);      //   
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  if(DS2432_OutputData.Success)                   //   
                  { //      
                    for(unsigned char j=0; j<128; j++)
                    {     DataTemp[j]=SelectedChip.Area1[j];
                    }
                    SendMsgToLogForm(108,"");    //   
                  }
                  else
                  {       SendMsgToLogForm(107,"");    //     
                          return;
                  }
                  //           ( DS2432 Data Memory   Area1)
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  GetDataToMemory(1,1);        //    RichEdit1  EEPROM
                             break;
                    case 1:  GetDataToMemory(2,1);        //    RichEdit2  EEPROM
                             break;
                    default: break;
                  }
                 //      scratchpad
                  SendMsgToLogForm(116,"");    //    
                  DS2432_InputData.TA1=SelectedChip.Area1Start+8*i;     //   TA1
                  DS2432_InputData.TA2=0;                               //   TA2
                  //    1-Wire
                  DS2432_InputData.AreaNumber=1;                  // Data Memory -  Area1
                  DS2432_InputData.Size=SelectedChip.Area4Size;   //    
                  if(Port!=INVALID_HANDLE_VALUE)
                  { DS2432_OutputData=DS2432_WriteToScratchpad(DS2432_InputData);
                    if(DS2432_OutputData.Success)
                    { TempBuf[0]=DS2432_OutputData.Test;
                      BinToHex(TempBuf,OutHexBuf,1);      //     ()
                      OutHexBuf[2]=0;                     //    
                      Form1->Edit7->Text = OutHexBuf;
                      SendMsgToLogForm(106,"");           //   scratchpad  
                    }
                    else
                    {  SendMsgToLogForm(105,"");            //   scratchpad   
                       return;
                    }
                  }
                  else
                  {    SendMsgToLogForm(2,"");    // . COM-  
                       return;
                  }
                  //   ,     (TA1, TA2, ES)
                  if(Port!=INVALID_HANDLE_VALUE)
                  { DS2432_OutputData=DS2432_ReadFromScratchpad();  //    Scratchpad
                    if(DS2432_OutputData.Success)           //   
                    { DS2432_InputData.ES=DS2432_OutputData.ES;      //  E/S
                      DS2432_InputData.TA2=DS2432_OutputData.TA2;    //  TA2
                      DS2432_InputData.TA1=DS2432_OutputData.TA1;    //  TA1
                      SendMsgToLogForm(108,"");                //    
                    }
                    else
                    {  SendMsgToLogForm(107,"");            //     
                       return;
                    }
                  }
                  else
                  {    SendMsgToLogForm(2,"");    // . COM-  
                       return;
                  }
                  //     Data
                  for(unsigned char i=0; i<128; i++)
                  {     SelectedChip.Area1[i]=DataTemp[i];
                  }
                  //     
                  if(Port!=INVALID_HANDLE_VALUE)
                  { DS2432_OutputData=DS2432_CopyScratchpadToMemory(DS2432_InputData);
                    if(DS2432_OutputData.Success)
                    { TempBuf[0]=DS2432_OutputData.Test;
                      BinToHex(TempBuf,OutHexBuf,1);        //     ()
                      OutHexBuf[2]=0;                       //    
                      Form1->Edit7->Text = OutHexBuf;
                      SendMsgToLogForm(110,"");    //     EEPROM  
                    }
                    else
                    {    SendMsgToLogForm(109,"");    //       EEPROM  
                         return;
                    }
                  }
                  else
                  {    SendMsgToLogForm(2,"");    // . COM-  
                       return;
                  }
                }
                break;
    case 0x3B:  //-----------------------------------------------------
                //   MAX31826,   WRITE DATA MEMORY
                //-----------------------------------------------------
                //   
                MAX31826_INPUT_DATA MAX31826_InputData;       //     MAX31826
                MAX31826_OUTPUT_DATA MAX31826_OutputData;     //     MAX31826
                SendMsgToLogForm(121,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                //          
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);        //    RichEdit1  Data
                           break;
                  case 1:  GetDataToMemory(2,1);        //    RichEdit2  Data
                           break;
                  default: break;
                }
                //      1-Wire  
                //     ,   ,    
                for(unsigned int i=0; i<SelectedChip.Area1Size/SelectedChip.Area2Size; i++)
                { //       
                  MAX31826_InputData.Size=SelectedChip.Area2Size;                         //     
                  MAX31826_InputData.AreaNumber=1;                                        //        
                  //    -       
                  if(Port!=INVALID_HANDLE_VALUE)
                  { TempAddr=SelectedChip.Area1Start+i*SelectedChip.Area2Size;          //       
                    MAX31826_InputData.SA=TempAddr;                                      //   SA
                    MAX31826_OutputData=MAX31826_WriteToScratchpad(MAX31826_InputData);
                  }
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //    -  
                  MAX31826_InputData.AreaNumber=2;
                  MAX31826_InputData.SA=TempAddr;
                  if(Port!=INVALID_HANDLE_VALUE)  MAX31826_OutputData=MAX31826_ReadFromScratchpad(MAX31826_InputData);        //    Scratchpad 2
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //          
                  if(MAX31826_OutputData.Success==false)
                  {     SendMsgToLogForm(105,"");    //  
                        return;
                  }
                  //     -    
                  if(Port!=INVALID_HANDLE_VALUE)  MAX31826_OutputData=MAX31826_CopyScratchpadToMemory();
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  if(!MAX31826_OutputData.Success)
                  {     SendMsgToLogForm(105,"");    //  
                        return;
                  }
                }
                SendMsgToLogForm(106,"");    //   
                break;
    case 0x5:   //   DS2405
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0xD:   //   DS28E05
    case 0x23:  //   DS24B33
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---   BUTTON10 ------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button10Click(TObject *Sender)
{ char TempBuf[1], OutHexBuf[3];        //  

  switch(SelectedChip.Family)
  { case 0x0:   //       ROM
                switch(SelectedChip.Modify)
                { case 1:  //   RW1990
                  case 2:  //   AN1990
                  case 3:  //   TM2004
                  default: break;
                }
                break;
    case 0x10:  //----------------------------------------------
                //   DS18S20,   READ EEPROM
                //----------------------------------------------
                //   
                DS18S20_OUTPUT_DATA DS18S20_OutputData; //     1W
                SendMsgToLogForm(124,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //   recall
                if(Port!=INVALID_HANDLE_VALUE)  DS18S20_OutputData=DS18S20_RecallE2();
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS18S20_OutputData.Success)          //  
                { //  read scratchpad
                  if(Port!=INVALID_HANDLE_VALUE)  DS18S20_OutputData=DS18S20_ReadFromScratchpad();
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                }
                else  //     recall - 
                { SendMsgToLogForm(107,"");    //  
                  return;
                }
                if(DS18S20_OutputData.Success)          //    recall   
                { //        
                  DS18S20_DecodeThresholds();
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(1,1);      //  Area1  RichEdit1
                             break;
                    case 1:  PlaceDataToForm(2,1);      //  Area1  RichEdit2
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //  
                }
                else      SendMsgToLogForm(107,"");    //  
                break;
    case 0x4:   //------------------------------------------------------------
                //   DS1994,   READ TIMEKEEPING REGISTERS
    case 0x84:  //------------------------------------------------------------
                //   DS1427,   READ TIMEKEEPING REGISTERS
                //------------------------------------------------------------
                //   
                DS1994_OUTPUT_DATA DS1994_OutputData;           //     DS1994
                DS1994_INPUT_DATA DS1994_InputData;             //     DS1994
                unsigned int TempAddr;                          //   
                unsigned char DS1994_SelectData;          //      
                bool DS1994_NeedMore;                     // ,     

                SendMsgToLogForm(146,"");           //     Timekeeping Registers
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                DS1994_InputData.AreaNumber=2;          //      Timekeeping Registers
                DS1994_NeedMore=false;                  // -    
                //   ,    
                DS1994_SelectData=0;
                if(Form1->CheckBox1->Checked==true)     DS1994_SelectData += 1; //  
                if(Form1->CheckBox2->Checked==true)     DS1994_SelectData += 2; //  
                if(Form1->CheckBox3->Checked==true)     DS1994_SelectData += 4; //  
                switch(DS1994_SelectData)
                { case 1:       //   Status
                                DS1994_InputData.Size=1;                //    1 
                                TempAddr=SelectedChip.Area2Start;       //       
                                break;
                  case 2:       //   Control
                                DS1994_InputData.Size=1;                //    1 
                                TempAddr=SelectedChip.Area2Start+1;     //       
                                break;
                  case 3:       //  Status + Control
                                DS1994_InputData.Size=2;                //    2 
                                TempAddr=SelectedChip.Area2Start;       //       
                                break;
                  case 4:       //  ,  Status  Control
                                DS1994_InputData.Size=SelectedChip.Area2Size-2; //    32-2 
                                TempAddr=SelectedChip.Area2Start+2;     //       
                                break;
                  case 5:       //   Status,      Control
                                DS1994_InputData.Size=1;                //    1 
                                TempAddr=SelectedChip.Area2Start;       //       
                                DS1994_NeedMore=true;                   //    
                                break;
                  case 6:       //  ,  Status
                                DS1994_InputData.Size=SelectedChip.Area2Size-1; //    32-1 
                                TempAddr=SelectedChip.Area2Start+1;     //       
                                break;
                  case 7:       //  
                                DS1994_InputData.Size=SelectedChip.Area2Size; //    32 
                                TempAddr=SelectedChip.Area2Start;     //       
                                break;
                  default:      //  ,         
                                SendMsgToLogForm(145,"");    //    /
                                return;
                }
                DS1994_Read_Timekeeping_Regs_Label1:
                //    -     
                if(Port!=INVALID_HANDLE_VALUE)
                { DS1994_InputData.TA1=TempAddr;                                      //   TA1
                  DS1994_InputData.TA2=TempAddr>>8;                                   //   TA2
                  DS1994_OutputData=DS1994_ReadFromMemory(DS1994_InputData);
                }
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS1994_NeedMore==true)       //      Control
                { DS1994_NeedMore=false;
                  DS1994_InputData.Size=SelectedChip.Area2Size-2; //    32-2 
                  TempAddr=SelectedChip.Area2Start+2;     //       
                  goto DS1994_Read_Timekeeping_Regs_Label1;
                }
                if(DS1994_OutputData.Success)                          //   
                { //    Test
                  TempBuf[0]=DS1994_OutputData.Test;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit7->Text = OutHexBuf;
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(3,2);      //  Area2  RichEdit3
                             break;
                    case 1:  PlaceDataToForm(4,2);      //  Area2  RichEdit4
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //  
                break;
    case 0x14:  //------------------------------------------------------------
                //   DS2430A,   READ APPLICATION REGISTER
                //------------------------------------------------------------
                //   
                DS2430_OUTPUT_DATA DS2430_OutputData;   //     1W
                SendMsgToLogForm(128,"");           //     Appl.Register
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //    
                //   ReadFromStatusRegister    (Test)  
                if(Port!=INVALID_HANDLE_VALUE)  DS2430_OutputData=DS2430_ReadFromStatusRegister();
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                //       Status   , 
                //  Application Register,        Area3
                if(Port!=INVALID_HANDLE_VALUE)  DS2430_OutputData=DS2430_ReadFromApplRegister();        //    Application Register
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS2430_OutputData.Success)           //   
                { //   Status Register
                  TempBuf[0]=DS2430_OutputData.Status;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit4->Text = OutHexBuf;
                  //       (  3)
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(3,3);   //    Area3  RichEdit3
                             break;
                    case 1:  PlaceDataToForm(4,3);   //    Area3  RichEdit4
                             break;
                    default: SendMsgToLogForm(107,"");    //  
                             return;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //  
                break;
    case 0x22:  //----------------------------------------------
                //   DS1822,   READ EEPROM
    case 0x28:  //----------------------------------------------
                //   DS18B20,   READ EEPROM
                //----------------------------------------------
                //   
                DS18B20_OUTPUT_DATA DS18B20_OutputData; //     1W
                SendMsgToLogForm(124,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //   recall
                if(Port!=INVALID_HANDLE_VALUE)  DS18B20_OutputData=DS18B20_RecallE2();
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS18B20_OutputData.Success)          //  
                { //  read scratchpad
                  if(Port!=INVALID_HANDLE_VALUE)  DS18B20_OutputData=DS18B20_ReadFromScratchpad();
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                }
                if(DS18B20_OutputData.Success)          //    recall  
                { //        
                  DS18B20_DecodeConfigAndThresholds();
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(1,1);      //  Area1  RichEdit1
                             break;
                    case 1:  PlaceDataToForm(2,1);      //  Area1  RichEdit1
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //  
                break;
    case 0x2D:  //--------------------------------------------------
                //   DS2431,   READ DATA MEMORY
                //--------------------------------------------------
                //   
                DS2431_OUTPUT_DATA DS2431_OutputData;           //     DS2431
                DS2431_INPUT_DATA DS2431_InputData;             //     DS2431
                SendMsgToLogForm(124,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                DS2431_InputData.TA1=SelectedChip.Area1Start;          //  TA1
                DS2431_InputData.TA2=SelectedChip.Area1Start>>8;       //  TA2
                DS2431_InputData.AreaNumber=1;                         //      
                DS2431_InputData.Size=SelectedChip.Area1Size;          //    
                if(Port!=INVALID_HANDLE_VALUE)  DS2431_OutputData=DS2431_ReadFromMemory(DS2431_InputData); //   
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS2431_OutputData.Success)                          //   
                { //    Test
                  TempBuf[0]=DS2431_OutputData.Test;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit7->Text = OutHexBuf;
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(1,1);
                             break;
                    case 1:  PlaceDataToForm(2,1);
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //  
                break;
    case 0x33:  //--------------------------------------------------
                //   DS2432,   READ DATA MEMORY
                //--------------------------------------------------
                //   
                DS2432_OUTPUT_DATA DS2432_OutputData;           //     DS2432
                DS2432_INPUT_DATA DS2432_InputData;             //     DS2432
                SendMsgToLogForm(124,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                DS2432_InputData.TA1=SelectedChip.Area1Start;          //  TA1
                DS2432_InputData.TA2=SelectedChip.Area1Start>>8;       //  TA2
                DS2432_InputData.AreaNumber=1;                         //      
                DS2432_InputData.Size=SelectedChip.Area1Size;          //    
                if(Port!=INVALID_HANDLE_VALUE)  DS2432_OutputData=DS2432_ReadFromMemory(DS2432_InputData); //   
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS2432_OutputData.Success)                          //   
                { //    Test
                  TempBuf[0]=DS2432_OutputData.Test;
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  Form1->Edit7->Text = OutHexBuf;
                  //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(1,1);
                             break;
                    case 1:  PlaceDataToForm(2,1);
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //  
                break;
    case 0x3B:  //--------------------------------------------------
                //   MAX31826,   READ DATA MEMORY
                //--------------------------------------------------
                //   
                MAX31826_OUTPUT_DATA MAX31826_OutputData;           //     MAX31826
                MAX31826_INPUT_DATA MAX31826_InputData;             //     MAX31826
                SendMsgToLogForm(124,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                     //  ROM   (    )
                MAX31826_InputData.SA=0;          //  SA
                MAX31826_InputData.AreaNumber=1;                         //      
                MAX31826_InputData.Size=SelectedChip.Area1Size;          //    
                if(Port!=INVALID_HANDLE_VALUE)  MAX31826_OutputData=MAX31826_ReadFromMemory(MAX31826_InputData); //   
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(MAX31826_OutputData.Success)                          //   
                { //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(1,1);
                             break;
                    case 1:  PlaceDataToForm(2,1);
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //  
                break;
    case 0x2:   //   DS1991
    case 0x5:   //   DS2405
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0x9:   //   DS2502 / DS1982
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0xD:   //   DS28E05
    case 0x1A:  //   DS1963L
    case 0x1D:  //   DS2423
    case 0x23:  //   DS24B33
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    case 0x2C:  //   DS2890
    case 0x82:  //   DS1425
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---   BUTTON11 ------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button11Click(TObject *Sender)
{ char TempBuf[1], OutHexBuf[3];                //  

  switch(SelectedChip.Family)
  { case 0x0:   //       ROM
                switch(SelectedChip.Modify)
                { case 1:  //   RW1990
                  case 2:  //   AN1990
                  case 3:  //   TM2004
                  default: break;
                }
                break;
    case 0x14:  //----------------------------------------------
                //   DS2430A,   READ EEPROM
                //----------------------------------------------
                //   
                DS2430_OUTPUT_DATA DS2430_OutputData;   //     1W
                SendMsgToLogForm(124,"");           //     EEPROM
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)  DS2430_OutputData=DS2430_ReadFromMemory();      //    Data EEPROM
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS2430_OutputData.Success)           //   
                { //      
                  switch(Form1->PageControl1->TabIndex)
                  { case 0:  PlaceDataToForm(1,1);
                             break;
                    case 1:  PlaceDataToForm(2,1);
                             break;
                    default: break;
                  }
                  SendMsgToLogForm(108,"");    //   
                }
                else      SendMsgToLogForm(107,"");    //  
                break;
    case 0x33:  //-----------------------------------------------------
                //   DS2432,   WRITE SECRET MEMORY
                //-----------------------------------------------------
                //   
                DS2432_INPUT_DATA DS2432_InputData;     //     DS2432
                DS2432_OUTPUT_DATA DS2432_OutputData;   //     DS2432
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //      scratchpad
                SendMsgToLogForm(116,"");    //    
                DS2432_InputData.TA1=SelectedChip.Area2Start;   //   TA1
                DS2432_InputData.TA2=0;                 //   TA2
                //           ( DS2432 Register Page   Area3)
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);        //    RichEdit3  Secret
                           break;
                  case 1:  GetDataToMemory(4,2);        //    RichEdit4  Secret
                           break;
                  default: break;
                }
                //    1-Wire    (Test)  
                DS2432_InputData.AreaNumber=2;                  // Secret -  Area2
                DS2432_InputData.Size=SelectedChip.Area2Size;   //     
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2432_OutputData=DS2432_WriteToScratchpad(DS2432_InputData);
                  if(DS2432_OutputData.Success)
                  { TempBuf[0]=DS2432_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);      //     ()
                    OutHexBuf[2]=0;                     //    
                    Form1->Edit7->Text = OutHexBuf;
                    SendMsgToLogForm(106,"");                //   scratchpad  
                  }
                  else
                  {  SendMsgToLogForm(105,"");            //   scratchpad   
                     return;
                  }
                }
                else
                {    SendMsgToLogForm(2,"");    // . COM-  
                     return;
                }
                //   ,     (TA1, TA2, ES)
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2432_OutputData=DS2432_ReadFromScratchpad();  //    Scratchpad
                  if(DS2432_OutputData.Success)           //   
                  { DS2432_InputData.ES=DS2432_OutputData.ES;      //  E/S
                    DS2432_InputData.TA2=DS2432_OutputData.TA2;    //  TA2
                    DS2432_InputData.TA1=DS2432_OutputData.TA1;    //  TA1
                    SendMsgToLogForm(108,"");                //    
                  }
                  else
                  {  SendMsgToLogForm(107,"");            //     
                     return;
                  }
                }
                else
                {    SendMsgToLogForm(2,"");    // . COM-  
                     return;
                }
                //      
                if(Port!=INVALID_HANDLE_VALUE)
                { DS2432_OutputData=DS2432_LoadFirstSecret(DS2432_InputData);
                  if(DS2432_OutputData.Success)
                  { TempBuf[0]=DS2432_OutputData.Test;
                    BinToHex(TempBuf,OutHexBuf,1);        //     ()
                    OutHexBuf[2]=0;                       //    
                    Form1->Edit7->Text = OutHexBuf;
                    SendMsgToLogForm(166,"");    //     
                  }
                  else    SendMsgToLogForm(165,"");    //       
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x3B:  //-----------------------------------------------------
                //   MAX31826,   Lock Low Memory
                //-----------------------------------------------------
                //   
                MAX31826_INPUT_DATA MAX31826_InputData;     //     MAX31826
                MAX31826_OUTPUT_DATA MAX31826_OutputData;   //     MAX31826
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //   
                SendMsgToLogForm(168," Low Memory");    //   
                MAX31826_InputData.SA=0x80;             //     
                if(Port!=INVALID_HANDLE_VALUE)
                { MAX31826_OutputData=MAX31826_LockMemory(MAX31826_InputData);
                  if(MAX31826_OutputData.Success)
                  { SendMsgToLogForm(151,"");           // ,  Low Memory  
                  }
                  else
                  {  SendMsgToLogForm(150,"");          // ,      
                     return;
                  }
                }
                else
                {    SendMsgToLogForm(2,"");    // . COM-  
                     return;
                }
                break;
    case 0x2:   //   DS1991
    case 0x4:   //   DS1994(DS2404)
    case 0x5:   //   DS2405
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0x9:   //   DS2502 / DS1982
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0xD:   //   DS28E05
    case 0x10:  //   DS18S20
    case 0x1A:  //   DS1963L
    case 0x1D:  //   DS2423
    case 0x22:  //   DS1822
    case 0x23:  //   DS24B33
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    case 0x28:  //   DS18B20
    case 0x2C:  //   DS2890
    case 0x2D:  //   DS2431
    case 0x82:  //   DS1425
    case 0x84:  //   DS1427(DS2404S)
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---   BUTTON12 ------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button12Click(TObject *Sender)
{ char TempBuf[1], OutHexBuf[3];                //  

  switch(SelectedChip.Family)
  { case 0x0:   //       ROM
                switch(SelectedChip.Modify)
                { case 1:  //   RW1990
                  case 2:  //   AN1990
                  case 3:  //   TM2004
                  default: break;
                }
                break;
    case 0x14:  //------------------------------------------------------------
                //   DS2430A,   COPY APPL.REGISTER & LOCK
                //------------------------------------------------------------
                //   
                DS2430_OUTPUT_DATA DS2430_OutputData;   //     DS2430A
                //  
                //    
                if (Application->MessageBox("Copy & Lock Application register? Are you sure?", "Warning", MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2|MB_APPLMODAL) == IDYES)
                { SendMsgToLogForm(129,"");           //   Appl.Register  OTP
                  //   Copy Appl.Register & Lock
                  GetDataToMemory(0,0);                   //  ROM   (    )
                  if(Port!=INVALID_HANDLE_VALUE)  DS2430_OutputData=DS2430_CopyAndLockApplRegister();
                  else  //    -    
                  { SendMsgToLogForm(2,"");    // . COM-  
                    return;
                  }
                  //  
                  if(DS2430_OutputData.Success)         SendMsgToLogForm(110,"");   //   
                  else                                  SendMsgToLogForm(109,"");    //  
                }
                else    SendMsgToLogForm(115,"");    //  
                break;
    case 0x33:  //-----------------------------------------------------
                //   DS2432,   REFRESH DATA MEMORY
                //-----------------------------------------------------
                //   
                DS2432_INPUT_DATA DS2432_InputData;     //     DS2432
                DS2432_OUTPUT_DATA DS2432_OutputData;   //     DS2432
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //    0  16 (   128 ,    8 - 128/8=16)
                for(unsigned int i=0; i<(SelectedChip.Area1Size/SelectedChip.Area4Size); i++)
                { //       scratchpad
                  SendMsgToLogForm(162,"");    //   
                  DS2432_InputData.TA1=SelectedChip.Area1Start+8*i;     //   TA1
                  DS2432_InputData.TA2=0;                               //   TA2
                  //   
                  if(Port!=INVALID_HANDLE_VALUE)
                  { DS2432_OutputData=DS2432_RefreshScratchpad(DS2432_InputData);
                    if(DS2432_OutputData.Success)
                    { TempBuf[0]=DS2432_OutputData.Test;
                      BinToHex(TempBuf,OutHexBuf,1);      //     ()
                      OutHexBuf[2]=0;                     //    
                      Form1->Edit7->Text = OutHexBuf;
                      SendMsgToLogForm(164,"");           //    
                    }
                    else
                    {  SendMsgToLogForm(163,"");            //     
                       return;
                    }
                  }
                  else
                  {    SendMsgToLogForm(2,"");    // . COM-  
                       return;
                  }
                  //  ,     (TA1, TA2, ES)
                  if(Port!=INVALID_HANDLE_VALUE)
                  { DS2432_OutputData=DS2432_ReadFromScratchpad();  //    Scratchpad
                    if(DS2432_OutputData.Success)           //   
                    { DS2432_InputData.ES=DS2432_OutputData.ES;      //  E/S
                      DS2432_InputData.TA2=DS2432_OutputData.TA2;    //  TA2
                      DS2432_InputData.TA1=DS2432_OutputData.TA1;    //  TA1
                      SendMsgToLogForm(108,"");                //    
                    }
                    else
                    {  SendMsgToLogForm(107,"");            //     
                       return;
                    }
                  }
                  else
                  {    SendMsgToLogForm(2,"");    // . COM-  
                       return;
                  }
                  //   LoadFirstSecret (      ,        )
                  if(Port!=INVALID_HANDLE_VALUE)
                  { DS2432_OutputData=DS2432_LoadFirstSecret(DS2432_InputData);
                    if(DS2432_OutputData.Success)
                    { TempBuf[0]=DS2432_OutputData.Test;
                      BinToHex(TempBuf,OutHexBuf,1);        //     ()
                      OutHexBuf[2]=0;                       //    
                      Form1->Edit7->Text = OutHexBuf;
                      SendMsgToLogForm(166,"");    //     
                    }
                    else
                    {    SendMsgToLogForm(165,"");    //       
                         return;
                    }
                  }
                  else
                  {    SendMsgToLogForm(2,"");    // . COM-  
                       return;
                  }
                }
                break;
    case 0x3B:  //-----------------------------------------------------
                //   MAX31826,   Lock High Memory
                //-----------------------------------------------------
                //   
                MAX31826_INPUT_DATA MAX31826_InputData;     //     MAX31826
                MAX31826_OUTPUT_DATA MAX31826_OutputData;   //     MAX31826
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //   
                SendMsgToLogForm(168," High Memory");    //   
                MAX31826_InputData.SA=0x81;              //     
                if(Port!=INVALID_HANDLE_VALUE)
                { MAX31826_OutputData=MAX31826_LockMemory(MAX31826_InputData);
                  if(MAX31826_OutputData.Success)
                  { SendMsgToLogForm(151,"");           // ,  Low Memory  
                  }
                  else
                  {  SendMsgToLogForm(150,"");          // ,      
                     return;
                  }
                }
                else
                {    SendMsgToLogForm(2,"");    // . COM-  
                     return;
                }
                break;
    case 0x2:   //   DS1991
    case 0x4:   //   DS1994(DS2404)
    case 0x5:   //   DS2405
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0x9:   //   DS2502 / DS1982
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0xD:   //   DS28E05
    case 0x10:  //   DS18S20
    case 0x1A:  //   DS1963L
    case 0x1D:  //   DS2423
    case 0x22:  //   DS1822
    case 0x23:  //   DS24B33
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    case 0x28:  //   DS18B20
    case 0x2C:  //   DS2890
    case 0x2D:  //   DS2431
    case 0x82:  //   DS1425
    case 0x84:  //   DS1427(DS2404S)
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---   BUTTON14 ------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button14Click(TObject *Sender)
{
  switch(SelectedChip.Family)
  { case 0x0:   //       ROM
                switch(SelectedChip.Modify)
                { case 1:  //   RW1990
                  case 2:  //   AN1990
                  case 3:  //   TM2004
                  default: break;
                }
                break;
    case 0x3B:  //---------------------------------------------------------------
                //   MAX31826,   COPY SCRATCHPAD 2 TO MEMORY
                //---------------------------------------------------------------
                //   
                MAX31826_OUTPUT_DATA MAX31826_OutputData; //     MAX31826
                SendMsgToLogForm(118,"");    //     EEPROM
                //  
                //   Copy Scratchpad 2 to Memory
                GetDataToMemory(0,0);                   //  ROM   (    )
                if(Port!=INVALID_HANDLE_VALUE)
                {  MAX31826_OutputData=MAX31826_CopyScratchpadToMemory();
                   if(MAX31826_OutputData.Success)      SendMsgToLogForm(110,"");    //     EEPROM  
                   else                                 SendMsgToLogForm(109,"");    //       EEPROM  
                }
                else    SendMsgToLogForm(2,"");    // . COM-  
                break;
    case 0x2:   //   DS1991
    case 0x4:   //   DS1994(DS2404)
    case 0x5:   //   DS2405
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0x9:   //   DS2502 / DS1982
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0xD:   //   DS28E05
    case 0x10:  //   DS18S20
    case 0x14:  //   DS2430A
    case 0x1A:  //   DS1963L
    case 0x1D:  //   DS2423
    case 0x22:  //   DS1822
    case 0x23:  //   DS24B33
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    case 0x28:  //   DS18B20
    case 0x2C:  //   DS2890
    case 0x2D:  //   DS2431
    case 0x33:  //   DS2432
    case 0x82:  //   DS1425
    case 0x84:  //   DS1427(DS2404S)
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---   BUTTON15 ------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button15Click(TObject *Sender)
{
  switch(SelectedChip.Family)
  { case 0x3B:  //--------------------------------------------------------
                //   MAX31826,   Read Lock Status ---
                //--------------------------------------------------------
                //   
                MAX31826_INPUT_DATA MAX31826_InputData;     //     MAX31826
                MAX31826_OUTPUT_DATA MAX31826_OutputData;   //     MAX31826
                //  
                GetDataToMemory(0,0);                   //  ROM   (    )
                //         
                SendMsgToLogForm(169,"");               //  lock-
                MAX31826_InputData.SA=0x80;             //       
                if(Port!=INVALID_HANDLE_VALUE)
                { MAX31826_OutputData=MAX31826_ReadLockStatus(MAX31826_InputData);
                  if(MAX31826_OutputData.Success)
                  { if(MAX31826_OutputData.Test == 0x55 )
                    {   SendMsgToLogForm(170,": Low");       // ,    
                    }
                    else
                    {   SendMsgToLogForm(171,": Low");       // ,     
                    }
                                                        //     
                  }
                  else
                  {  SendMsgToLogForm(150,"");          // ,       
                     return;
                  }
                }
                else
                {    SendMsgToLogForm(2,"");    // . COM-  
                     return;
                }
                //         
                MAX31826_InputData.SA=0x81;             //       
                if(Port!=INVALID_HANDLE_VALUE)
                { MAX31826_OutputData=MAX31826_ReadLockStatus(MAX31826_InputData);
                  if(MAX31826_OutputData.Success)
                  { if(MAX31826_OutputData.Test == 0x55 )
                    {   SendMsgToLogForm(170,": High");       // ,    
                    }
                    else
                    {   SendMsgToLogForm(171,": High");       // ,     
                    }
                                                        //     
                  }
                  else
                  {  SendMsgToLogForm(150,"");          // ,       
                     return;
                  }
                }
                else
                {    SendMsgToLogForm(2,"");    // . COM-  
                     return;
                }
                break;
    case 0x0:   //       ROM
    case 0x2:   //   DS1991
    case 0x4:   //   DS1994(DS2404)
    case 0x5:   //   DS2405
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0x9:   //   DS2502 / DS1982
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0xD:   //   DS28E05
    case 0x10:  //   DS18S20
    case 0x14:  //   DS2430A
    case 0x1A:  //   DS1963L
    case 0x1D:  //   DS2423
    case 0x22:  //   DS1822
    case 0x23:  //   DS24B33
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    case 0x28:  //   DS18B20
    case 0x2C:  //   DS2890
    case 0x2D:  //   DS2431
    case 0x33:  //   DS2432
    case 0x82:  //   DS1425
    case 0x84:  //   DS1427(DS2404S)
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---  TIMER1 -------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{ Form1->Timer1->Enabled=false;         //  
  switch(SelectedChip.Family)
  { case 0x0:   //       ROM
                switch(SelectedChip.Modify)
                { case 1:  //   RW1990
                  case 2:  //   AN1990
                  case 3:  //   TM2004
                  default: break;
                }
                break;
    case 0x10:  //------------------------------------
                //   DS18S20,  TIMER1
                //------------------------------------
                //  
                DS18S20_OUTPUT_DATA DS18S20_OutputData; //     DS18S20
                float DS18S20_TempValue;                //     
                //  
                if(Port!=INVALID_HANDLE_VALUE)  DS18S20_OutputData=DS18S20_ConvertT();          //  
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                Sleep(2000);                                                                    //    
                if(Port!=INVALID_HANDLE_VALUE)  DS18S20_OutputData=DS18S20_ReadFromScratchpad();        //  
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS18S20_OutputData.Success)                                                  //   
                { DS18S20_TempValue = DS18S20_DecodeTemperature();                       //  
                  Form1->Edit4->Text=FloatToStrF(DS18S20_TempValue, ffFixed, 7, 7);      //    Edit4
                  Form1->Timer1->Enabled=true;          //    
                }
                else    SendMsgToLogForm(107,"");    //  
                break;
    case 0x22:  //------------------------------------
                //   DS1822,  TIMER1
    case 0x28:  //------------------------------------
                //   DS18B20,  TIMER1
                //------------------------------------
                //  
                DS18B20_OUTPUT_DATA DS18B20_OutputData; //     DS18B20
                float DS18B20_TempValue;                //     
                //  
                if(Port!=INVALID_HANDLE_VALUE)  DS18B20_OutputData=DS18B20_ConvertT();          //  
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                Sleep(2000);                                                                    //    
                if(Port!=INVALID_HANDLE_VALUE)  DS18B20_OutputData=DS18B20_ReadFromScratchpad();        //  
                else  //    -    
                { SendMsgToLogForm(2,"");    // . COM-  
                  return;
                }
                if(DS18B20_OutputData.Success)                                                  //   
                { DS18B20_TempValue = DS18B20_DecodeTemperature();                       //  
                  Form1->Edit4->Text=FloatToStrF(DS18B20_TempValue, ffFixed, 7, 7);      //    Edit4
                  Form1->Timer1->Enabled=true;          //    
                }
                else    SendMsgToLogForm(107,"");    //  
                break;
    case 0x2:   //   DS1991
    case 0x4:   //   DS1994(DS2404)
    case 0x5:   //   DS2405
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0x9:   //   DS2502 / DS1982
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0xD:   //   DS28E05
    case 0x14:  //   DS2430A
    case 0x1A:  //   DS1963L
    case 0x1D:  //   DS2423
    case 0x23:  //   DS24B33
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    case 0x2C:  //   DS2890
    case 0x2D:  //   DS2431
    case 0x33:  //   DS2432 / DS1961S
    case 0x3B:  //   MAX31826
    case 0x82:  //   DS1425
    case 0x84:  //   DS1427(DS2404S)
    default:    break;
  }
}
//---------------------------------------------------------------------------
//***************************************************************************
//***      ****************************************
//***************************************************************************
//---------------------------------------------------------------------------
//---       -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{ AnsiString FilePath, Ext;
  int NameLength;

  if(OpenDialog1->Execute())
  { if((SelectedChip.Family|SelectedChip.Modify)!=0)              //          ROM
    { FilePath=OpenDialog1->FileName;                             //    
      NameLength=FilePath.Length();                               //      
      Ext=FilePath.SubString(NameLength-2,3);                     // 
      Ext=UpperCase(Ext);                                         //    
      if(Ext=="HEX")      LoadFromHexFileToMemory(FilePath);      //   hex-
      else                LoadFromBinFileToMemory(FilePath);      //   bin-
    }
    else        SendMsgToLogForm(3,"");    //     
  }
}
//---------------------------------------------------------------------------
//---       ---------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{ AnsiString FilePath, Ext;                     //      
  int FilePathLength;                           //   
  bool SelBin, SelHex;                          //    

  //  ,   
  SelBin=false; SelHex=false;
  FilePath=Form1->StaticText1->Caption;         //       
  FilePathLength=FilePath.Length();             //       
  if(FilePathLength)                            //      (    )
  { // ,   ,   
    if(MessageBox(Form1->Handle,"   , ?","", MB_OKCANCEL|MB_ICONQUESTION)==IDOK)
    { //      
      Ext=FilePath.SubString(FilePathLength-2,3); //  
      Ext=UpperCase(Ext);                         //     
      //    
      if(Ext=="BIN")    SelBin=true;            //   bin- -    bin
      else              SelHex=true;            //     hex-
    }
  }
  //     -  
  else if(SaveDialog1->Execute())               //     (  )
  { FilePath=SaveDialog1->FileName;             //     
    FilePathLength=FilePath.Length();           //       
    Ext=FilePath.SubString(FilePathLength-2,3); //   ( 3 )
    Ext=UpperCase(Ext);                         //     
    //   (  )
    if(SaveDialog1->FilterIndex == 1)           //   BIN (   SaveDialog )
    { if(Ext!="BIN")    FilePath = FilePath + ".bin";   //     bin -    .bin
      SelBin=true;
    }
    else                                        //   HEX (   BIN,     )
    { if(Ext!="HEX")    FilePath = FilePath + ".hex";   //     hex -    .hex
      SelHex=true;
    }
  }
  //------------------------------------------
  //  , ,    
  //------------------------------------------
  if(SelBin)            //     bin
  { SaveFromMemoryToBinFile(FilePath);  //      bin-
  }
  if(SelHex)            //    hex
  { SaveFromMemoryToHexFile(FilePath);  //      hex-
  }
}
//---------------------------------------------------------------------------
//---        --------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Saveas1Click(TObject *Sender)
{ AnsiString FilePath, Ext;                     //      
  int FilePathLength;                           //   
  bool SelBin, SelHex;                          //    

  SelBin=false; SelHex=false;                   //    
  if(SaveDialog1->Execute())                    //     (  )
  { FilePath=SaveDialog1->FileName;             //     
    FilePathLength=FilePath.Length();           //       
    Ext=FilePath.SubString(FilePathLength-2,3); //   ( 3 )
    Ext=UpperCase(Ext);                         //     
    //   (  )
    if(SaveDialog1->FilterIndex == 1)           //   BIN (   SaveDialog )
    { if(Ext!="BIN")    FilePath = FilePath + ".bin";   //     bin -    .bin
      SelBin=true;
    }
    else                                        //   HEX (   BIN,     )
    { if(Ext!="HEX")    FilePath = FilePath + ".hex";   //     hex -    .hex
      SelHex=true;
    }
  }
  //------------------------------------------
  //  , ,    
  //------------------------------------------
  if(SelBin)            //     bin
  { SaveFromMemoryToBinFile(FilePath);  //      bin-
  }
  if(SelHex)            //    hex
  { SaveFromMemoryToHexFile(FilePath);  //      hex-
  }
}
//---------------------------------------------------------------------------
//---        ---------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveLogas1Click(TObject *Sender)
{ AnsiString FilePath;                          //    

  if(SaveDialog1->Execute())                    //     (  )
  { FilePath=SaveDialog1->FileName;             //     
    //    
    Form1->RichEdit9->Lines->SaveToFile(FilePath);   //    RichEdit9
  }
}
//---------------------------------------------------------------------------
//---        -------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Lang1Click(TObject *Sender)
{ LangNum=0;            //  
  RenameFormElements();
}
//---------------------------------------------------------------------------
//---        ----------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Lang2Click(TObject *Sender)
{ LangNum=1;            //  
  RenameFormElements();
}
//---------------------------------------------------------------------------
//---      RH-0004 ------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RH00041Click(TObject *Sender)
{ SelectedProgrammer = 1;       //  RH-0004
  RenameProgrammerMenu();       //      
  Form1->Button2->Click();      //   Disconnect
}
//---------------------------------------------------------------------------
//---      RH-0010 ------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RH00101Click(TObject *Sender)
{ SelectedProgrammer = 2;       //  RH-0010
  RenameProgrammerMenu();       //      
  Form1->Button2->Click();      //   Disconnect
}
//---------------------------------------------------------------------------
//---      DS2431 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS24311Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS2431
  InitChip(0x2D);       //   ,  
  InitFormInf(0x2D);    //      
  InitForm(0x2D);       //      
}
//---------------------------------------------------------------------------
//---      DS28E07 ---------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS28E071Click(TObject *Sender)
{ SelectedChip.Modify = 1;      //   DS28E07
  InitChip(0x2D);       //   ,  
  InitFormInf(0x2D);    //      
  InitForm(0x2D);       //      
}
//---------------------------------------------------------------------------
//---      DS2430A ---------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS24301Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS2430A
  InitChip(0x14);       //   ,  
  InitFormInf(0x14);    //      
  InitForm(0x14);       //      
}
//---------------------------------------------------------------------------
//---      DS1971 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS19711Click(TObject *Sender)
{ SelectedChip.Modify = 1;      //   DS1971
  InitChip(0x14);       //   ,  
  InitFormInf(0x14);    //      
  InitForm(0x14);       //      
}
//---------------------------------------------------------------------------
//---      DS24B33 ---------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS24B331Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS24B33
  InitChip(0x23);       //   ,  
  InitFormInf(0x23);    //      
  InitForm(0x23);       //      
}
//---------------------------------------------------------------------------
//---      DS18B20 ---------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS18B201Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS18B20
  InitChip(0x28);       //   ,  
  InitFormInf(0x28);    //      
  InitForm(0x28);       //      
}
//---------------------------------------------------------------------------
//---      DS18S20 ---------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS18S201Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS18S20
  InitChip(0x10);       //   ,  
  InitFormInf(0x10);    //      
  InitForm(0x10);       //      
}
//---------------------------------------------------------------------------
//---      DS1920 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS19201Click(TObject *Sender)
{ SelectedChip.Modify = 1;      //   DS1920
  InitChip(0x10);       //   ,  
  InitFormInf(0x10);    //      
  InitForm(0x10);       //      
}
//---------------------------------------------------------------------------
//---      DS1991 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS19911Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS1991
  InitChip(0x2);        //   ,  
  InitFormInf(0x2);     //      
  InitForm(0x2);        //      
}
//---------------------------------------------------------------------------
//---      DS1425 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS14251Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS1425
  InitChip(0x82);        //   ,  
  InitFormInf(0x82);     //      
  InitForm(0x82);        //      
}
//---------------------------------------------------------------------------
//---      DS1992 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS19921Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS1992
  InitChip(0x8);        //   ,  
  InitFormInf(0x8);     //      
  InitForm(0x8);        //      
}
//---------------------------------------------------------------------------
//---      DS1993 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS19931Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS1993
  InitChip(0x6);        //   ,  
  InitFormInf(0x6);     //      
  InitForm(0x6);        //      
}
//---------------------------------------------------------------------------
//---      DS1995 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS19951Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS1995
  InitChip(0xA);        //   ,  
  InitFormInf(0xA);     //      
  InitForm(0xA);        //      
}
//---------------------------------------------------------------------------
//---      DS1996 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS19961Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS1996
  InitChip(0xC);        //   ,  
  InitFormInf(0xC);     //      
  InitForm(0xC);        //      
}
//---------------------------------------------------------------------------
//---      DS2405 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS24051Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS2405
  InitChip(0x5);        //   ,  
  InitFormInf(0x5);     //      
  InitForm(0x5);        //      
}
//---------------------------------------------------------------------------
//---      DS1822 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS18221Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS1822
  InitChip(0x22);        //   ,  
  InitFormInf(0x22);     //      
  InitForm(0x22);        //      
}
//---------------------------------------------------------------------------
//---      DS2415 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS24151Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS2415
  InitChip(0x24);        //   ,  
  InitFormInf(0x24);     //      
  InitForm(0x24);        //      
}
//---------------------------------------------------------------------------
//---      DS2417 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS24171Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS2417
  InitChip(0x27);        //   ,  
  InitFormInf(0x27);     //      
  InitForm(0x27);        //      
}
//---------------------------------------------------------------------------
//---      DS1994 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS19941Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS1994
  InitChip(0x4);        //   ,  
  InitFormInf(0x4);     //      
  InitForm(0x4);        //      
}
//---------------------------------------------------------------------------
//---      DS2404 ( DS1994) ------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS24041Click(TObject *Sender)
{ SelectedChip.Modify = 1;      //   DS2404
  InitChip(0x4);        //   ,  
  InitFormInf(0x4);     //      
  InitForm(0x4);        //      
}
//---------------------------------------------------------------------------
//---      DS1963L ---------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS1963L1Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS1963L
  InitChip(0x1A);        //   ,  
  InitFormInf(0x1A);     //      
  InitForm(0x1A);        //      
}
//---------------------------------------------------------------------------
//---      DS2423 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS24231Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS2423
  InitChip(0x1D);        //   ,  
  InitFormInf(0x1D);     //      
  InitForm(0x1D);        //      
}
//---------------------------------------------------------------------------
//---      DS2890 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS28901Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS2890
  InitChip(0x2C);        //   ,  
  InitFormInf(0x2C);     //      
  InitForm(0x2C);        //      
}
//---------------------------------------------------------------------------
//---      DS1427 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS14271Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS1427
  InitChip(0x84);        //   ,  
  InitFormInf(0x84);     //      
  InitForm(0x84);        //      
}
//---------------------------------------------------------------------------
//---      RW1990 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RW19901Click(TObject *Sender)
{ SelectedChip.Modify = 1;      //    RW1990
  InitChip(0x0);                //   ,  
  InitFormInf(0x0);             //      
  InitForm(0x0);                //      
}
//---------------------------------------------------------------------------
//---      DS28E05 ---------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS28E051Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS28E05
  InitChip(0xD);        //   ,  
  InitFormInf(0xD);     //      
  InitForm(0xD);        //      
}
//---------------------------------------------------------------------------
//---      AN1990 ---------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AN19901Click(TObject *Sender)
{ SelectedChip.Modify = 2;      //    AN1990
  InitChip(0x0);                //   ,  
  InitFormInf(0x0);             //      
  InitForm(0x0);                //      
}
//---------------------------------------------------------------------------
//---      TM-2004 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::TM20041Click(TObject *Sender)
{ SelectedChip.Modify = 3;      //    TM-2004
  InitChip(0x0);                //   ,  
  InitFormInf(0x0);             //      
  InitForm(0x0);                //      
}
//---------------------------------------------------------------------------
//---      DS2502 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS25021Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS2502
  InitChip(0x9);                //   ,  
  InitFormInf(0x9);             //      
  InitForm(0x9);                //      
}
//---------------------------------------------------------------------------
//---      DS1982 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS19821Click(TObject *Sender)
{ SelectedChip.Modify = 1;      //   DS1982
  InitChip(0x9);                //   ,  
  InitFormInf(0x9);             //      
  InitForm(0x9);                //      
}
//---------------------------------------------------------------------------
//---      DS2432 ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS24321Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   DS2432
  InitChip(0x33);        //   ,  
  InitFormInf(0x33);     //      
  InitForm(0x33);        //      
}
//---------------------------------------------------------------------------
//---      DS1961S ---------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DS1961S1Click(TObject *Sender)
{ SelectedChip.Modify = 1;      //   DS1961S
  InitChip(0x33);        //   ,  
  InitFormInf(0x33);     //      
  InitForm(0x33);        //      
}
//---------------------------------------------------------------------------
//---      MAX31826 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::MAX318261Click(TObject *Sender)
{ SelectedChip.Modify = 0;      //   MAX31826
  InitChip(0x3B);        //   ,  
  InitFormInf(0x3B);     //      
  InitForm(0x3B);        //      
}
//---------------------------------------------------------------------------

